commit ff633699cb785967a2cb0084d89d56e53c46e416
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:   Thu Jan 11 07:13:42 2024 -0800

    Updated the NEWS document and bumped the version number.

M	CMakeLists.txt
M	NEWS.txt

commit 6f47e5a8db62038c88eb38cb81221e4d1ae60f97
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Jan 10 21:50:31 2024 -0800

    Fixes #368.

    Added a (previously-missing) range check on the intermediate layer
    rates
    in the JPC encoder.
    Added another image to the test set.

A	data/test/good/368_poc_min.pnm
M	src/libjasper/jpc/jpc_enc.c

commit ca05a7f4dbf08eb9b3dc63d9ed7ff94055d24f7c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Jan 10 13:00:32 2024 -0800

    Updated the NEWS document (to add a reference to a CVE).

M	NEWS.txt

commit aeef5293c978158255ad4f127089644745602f2a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Dec 14 19:04:19 2023 -0800

    Fixes #367.

    Fixed an integer-overflow bug in the ICC profile parsing code.
    Added another invalid image to the test set.

A	data/test/bad/367-PoC.jp2
M	src/libjasper/base/jas_icc.c

commit 2bd1657c07e9815b89d0553c782b841d11630580
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Dec 1 09:27:08 2023 -0800

    Fixed a potential integer overflow problem in the
    jas_safeui32_to_intfast32 function.

M	src/libjasper/include/jasper/jas_math.h

commit 917f7708b755d8434f70618108c1a76f1b6a0a82
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Nov 28 09:19:23 2023 -0800

    Updated the NEWS document and bumped the version number.

M	CMakeLists.txt
M	NEWS.txt

commit d955e6d4c99aa03a3ece61010e8151f5058f0ffa
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 27 20:33:35 2023 -0800

    Changed the versions of macOS being tested in the GitHub Actions CI
    workflow (i.e., added macos-13 and deleted macos-11).

M	.github/workflows/ci.yml

commit dda5d2340221f71a3c25451f1373514ab964f21d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 27 19:33:00 2023 -0800

    Disabled the building of the JasPer documentation in the Appveyor
    CI to
    workaround problems with Doxygen/LaTeX in that environment.

M	build/appveyor/build.bat

commit 70168aeb30e56430f16f7f5a7773b3ae0e70f306
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 27 19:19:39 2023 -0800

    Changed the versions of Windows Visual Studio being tested with
    Appveyor CI.

M	appveyor.yml

commit b72e8b048680cf1b5a167a45747b2e9cbb667da5
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 27 19:03:58 2023 -0800

    Made some improvements/corrections to the InSourceBuild CMake module.

M	build/cmake/modules/InSourceBuild.cmake

commit 9c73145d615316c7da2d1e19734aac24610d56e2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 27 18:20:11 2023 -0800

    Made a few improvements/corrections to the InSourceBuild CMake module.

M	build/cmake/modules/InSourceBuild.cmake

commit a798ba0ebadc103d5c3bb525bd2b7d0059c98be7
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 27 17:43:39 2023 -0800

    Fixes #364.

    Made some changes to the InSourceBuild CMake module in an attempt
    to prevent CMake-challenged individuals from trashing the source
    tree when performing a build.

M	CMakeLists.txt
M	build/cmake/modules/InSourceBuild.cmake

commit 175731c70e14e952ba09f7dded1486d30555ba7e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Nov 17 06:42:59 2023 -0800

    Fixes #363.

    Fixed a potential integer overflow problem in the
    jas_get_total_mem_size
    function (for the Windows platform).

M	src/libjasper/base/jas_malloc.c

commit abf85caf71d705d4ee44c66d450a693ecccfc267
Merge: 5010de0 aa6d42a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Nov 5 13:26:31 2023 -0800

    Merge pull request #362 from jubalh/cve

    Add reference of CVE-2021-3443 to NEWS file

commit 5010de0779d0a7de02426cfe63727bd9a84af7c3
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Nov 4 21:39:06 2023 -0700

    Made a few improvements to the WebAssembly support.

M	CMakeLists.txt
M	build/build_wasi_jasper
M	src/libjasper/base/jas_malloc.c

commit e7cbee671893992e11a1fc603019bc8112cf7d15
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Nov 4 20:22:33 2023 -0700

    Bumped the version number and updated the NEWS document.

M	CMakeLists.txt
M	NEWS.txt

commit da765f5178cb3b38754bacd27386c16d4007980d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Nov 4 16:19:03 2023 -0700

    Added a comment to a GitHub Actions workflow file.

M	.github/workflows/ci.yml

commit e6b1dae6b21491a9e468eefdc36fa3784650ac65
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Nov 4 16:07:59 2023 -0700

    Disable the build with Ubuntu 20.04 and GCC in the CI workflow.

M	.github/workflows/ci.yml

commit a0ac8435bf2e8a013a0cd8e8e98e285cc1868187
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Nov 4 15:50:14 2023 -0700

    Disable the build with Ubuntu 20.04 and GCC in the CI workflow.

M	.github/workflows/ci.yml

commit 8335265dbfa2e539600602c391535033e3a82245
Merge: 09233ab 304ffce
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Nov 4 15:36:47 2023 -0700

    Merge preliminary support for WebAssembly.

commit 09233abec431253ba1a955f6641d707c88773d1d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Nov 4 15:19:58 2023 -0700

    Bumped the version number and updated the NEWS document.

M	CMakeLists.txt
M	NEWS.txt

commit 304ffce7498eb38ec782785e853a8ac4419f4184
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Nov 4 15:03:01 2023 -0700

    Removed a comment from a GitHub Actions workflow file.

M	build/github/prebuild

commit a886dcd98f8bffb3c0bcd96b5fd26022e2d692b0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Nov 4 14:58:04 2023 -0700

    Made some further build changes to experiment with WebAssembly
    support.

M	.github/workflows/release.yml
M	build/build_wasi_jasper
M	build/github/prebuild

commit 7976385b6111f4a8ac7f26d28355769b30528556
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Nov 4 14:42:30 2023 -0700

    Made some changes to the GitHub Actions release workflow.

M	.github/workflows/release.yml

commit 0a013da1e7f4cde51f7b4d9fa06e836a4b9c93b1
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Nov 4 13:26:04 2023 -0700

    Added preliminary support for building and deploying JasPer for a
    WebAssembly target that supports WASI.

M	.github/workflows/release.yml
M	CMakeLists.txt
A	build/build_wasi_jasper
A	build/install_wasi_sdk
A	build/install_wasmtime
M	build/make_release
A	build/wasm_cc
M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_stream.h

commit aa6d42a871eab4d4ee52ef5b592bef902986a244
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Mon Oct 30 18:51:50 2023 +0100

    Add reference of CVE-2021-3443 to NEWS file

M	NEWS.txt

commit 354722a9a42e502092c31941913f4552bb72eb63
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Apr 10 19:36:07 2023 -0700

    Moved some C++ related settings inside an if statement in the
    top-level
    CMakeLists.txt file just in case this might fix issue #356.

M	CMakeLists.txt

commit d1b8a3702319c0b6d992c2d0c2cb5744bb9dd8ac
Merge: f1ae9d7 f2d2e5d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Mar 27 06:58:40 2023 -0700

    Merge pull request #355 from jpalus/parallel-docs

    doc/CMakeLists.txt: fix parallel build of api docs and pdf manual

commit f2d2e5d6f06bdd60d3be8277726e238659bc56b5
Author: Jan Palus <jpalus@fastmail.com>
Date:	Mon Mar 27 13:55:04 2023 +0200

    doc/CMakeLists.txt: fix prallel build of api docs and pdf manual

    according to cmake docs DEPENDS in add_custom_command with file being
    output of other custom command:

    > If any dependency is an OUTPUT of another custom command in the same
    > directory (CMakeLists.txt file), CMake automatically brings
    the other
    > custom command into the target in which this command is built.

    this means "manual_pdf" target will not wait for previous doxygen
    invocation but will trigger its own. in case of parallel build two
    doxygen invocations with same input parameters might overwrite each
    other's output resulting in broken files. it could be verified
    with just
    grepping cmake output:

    ```
    $ grep -r 'doxygen Doxyfile' builddir/doc
    builddir/doc/CMakeFiles/doc.dir/build.make:     cd
    /home/users/builder/rpm/BUILD/jasper-3.0.6/builddir/doc &&
    /usr/bin/doxygen Doxyfile
    builddir/doc/CMakeFiles/manual_pdf.dir/build.make:	    cd
    /home/users/builder/rpm/BUILD/jasper-3.0.6/builddir/doc &&
    /usr/bin/doxygen Doxyfile
    ```

    instead of putting dependency on "latex/index.tex" file, use "doc"
    target as dependency resulting in ordering "doc" before "manual_pdf"
    and
    single doxygen invocation.

M	doc/CMakeLists.txt

commit f1ae9d7c329281534ca00474ec01c2382a016020
Merge: 71bb750 6120ae4
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Mar 21 20:02:06 2023 -0700

    Merge pull request #352 from kmilos/patch-1

    Handle relative vs absolute paths for .pc file variables

commit 71bb7509ddf8d85e1caa61e440405aeae0906da7
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Mar 20 11:41:20 2023 -0700

    Fixes #353.

    Fixed an integer overflow bug in the PNM decoder.
    Added some new utility functions for performing safe integer
    arithmetic.

M	NEWS.txt
A	data/test/bad/353.pnm
A	data/test/good/signed_pnm.pnm
M	src/libjasper/include/jasper/jas_math.h
M	src/libjasper/include/jasper/jas_types.h
M	src/libjasper/pnm/pnm_dec.c

commit 6120ae4d5bffb318c9d6e137190edff6ff0c4efa
Author: Miloš Komarčević <miloskomarcevic@aim.com>
Date:	Mon Jan 9 12:15:15 2023 +0100

    Handle relative vs absolute paths for .pc file variables

M	CMakeLists.txt
M	build/jasper.pc.in

commit 294db12f949f38eebedde6e0e1c8b9d4befcc5b2
Merge: d8ea0e0 f10e2c1
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Fri Jan 6 17:33:42 2023 +0100

    Merge pull request #351 from theta682/patch-1

    Don't force debug suffix

commit f10e2c1338544eba61450774985e96133b1bf49d
Author: Timothy Lyanguzov <timothy.lyanguzov@sap.com>
Date:	Thu Jan 5 13:31:47 2023 +1300

    Don't force debug suffix

    The external build system can specify debug suffix if it is needed.

    Close https://github.com/jasper-software/jasper/issues/350

M	CMakeLists.txt

commit d8ea0e06435d8b99cf2072bdf7d2f42e61157955
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jan 5 10:38:12 2023 -0800

    Made some changes to the prebuild script for MacOS.

M	build/github/prebuild-v2

commit 9d990d233383ed4b7498568192d98f55558ffffd
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jan 5 09:59:38 2023 -0800

    Changed the version of the checkout action from 2 to 3 in the
    GitHub CI workflow.

M	.github/workflows/ci.yml
M	.github/workflows/deploy_manual.yml
M	.github/workflows/release.yml
M	.github/workflows/win_ci.yml

commit 62c394fa34b857e0d655bafc1485d956f6133306
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jan 5 09:25:07 2023 -0800

    Made some changes to the prebuild script for MacOS.
    Added Ubuntu 20.04 and MacOS 12 to the test matrix for the
    GitHub CI workflow.

M	.github/workflows/ci.yml
M	build/github/prebuild-v2

commit 92168f7ef280fe894ff76f389ff33fdedac2116e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jan 5 09:01:14 2023 -0800

    Made some changes to the prebuild script for MacOS.

M	build/github/prebuild-v2

commit 348f3184b0eca6bf271efee7f798370869ef2a63
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jan 5 08:48:45 2023 -0800

    Made some changes to the prebuild script for MacOS.

M	build/github/prebuild-v2

commit 74c72b57c70d1ef1ae17d4ea74c33a152e981de0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jan 5 08:09:44 2023 -0800

    Changed the GitHub CI workflow to explicitly specify the versions of
    Ubuntu and MacOS to be used (instead of using the versions named as
    "latest").

M	.github/workflows/ci.yml

commit 402d096b39f4f618ad9e6ff2b4fc1b5eb260a2e4
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Nov 5 10:06:53 2022 -0700

    Bumped the version number and updated the NEWS document.

M	CMakeLists.txt
M	NEWS.txt

commit ec4d0223f08f4555283d739abc6ba71e8e751039
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Nov 4 23:57:25 2022 -0700

    Made a number of improvements to the test scripts.
    Added a hack to the build_all script for the case of
    building with Clang on Ubuntu.

M	build/build_all
M	test/bin/run_test_1
M	test/bin/run_test_2
M	test/bin/run_test_5
M	test/bin/run_test_imginfo

commit e54c63858308c5f7c0433ab099527cdecc41c0b4
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Nov 4 22:31:38 2022 -0700

    Made a number of improvements to the test scripts.
    Fixed a typo in the top-level CMakeLists.txt file.

M	CMakeLists.txt
M	test/bin/jpdec
M	test/bin/jpenc
M	test/bin/run_codec_test
M	test/bin/run_conformance_tests
M	test/bin/run_mem_test
M	test/bin/run_test_1
M	test/bin/run_test_2
M	test/bin/run_test_5
M	test/bin/run_test_imginfo
M	test/bin/utilities

commit 37f90268a7c8e54759987dd511246517b97de7a2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Nov 3 22:14:13 2022 -0700

    Made some experimental changes to a GitHub Actions workflow.

M	.github/workflows/ci.yml

commit d36e0377b1c50d7ff0852c1a2b1c4a2f5699267a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Nov 3 22:01:47 2022 -0700

    Change the build script to print the value of the CXX
    environment variable.

M	build/build

commit 2468aac7685039c07ff7df9010c0399239861bbc
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Nov 3 21:54:51 2022 -0700

    Made some experimental changes to a GitHub Actions workflow.

M	.github/workflows/ci.yml

commit 4ce3ce84d76240b1ef2931387413c410953bd0aa
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Nov 3 18:45:23 2022 -0700

    Updated the NEWS document.

M	NEWS.txt

commit e97639fe47faed62703ba47c1071b91e3d76eb41
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Nov 3 18:13:53 2022 -0700

    Fixes #342, #343, #344.

    Some command-line options for the jasper, imginfo, imgcmp, and jiv
    programs (that are not deemed to be for internal use only) were not
    documented in the manual.  Descriptions for these options have
    now been
    added to the manual.

    The help information message printed by each of the jasper, imginfo,
    imgcmp, and jiv programs has been improved.  A mention of the URL
    for the
    online documentation is now included in all help messages.	A comment
    has also been added indicating that not all options are listed in the
    help message and that the manual should be checked for a complete list
    of options (excluding, of course, the ones that are deemed to be for
    internal use only and are deliberately undocumented).

M	doc/src/apps_imgcmp.dox
M	doc/src/apps_jiv.dox
M	src/app/imgcmp.c
M	src/app/imginfo.c
M	src/app/jasper.c
M	src/app/jiv.c
M	src/libjasper/include/jasper/jas_version.h

commit 34faad593c872e6a7a88f25f86337d26280c3df1
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Nov 3 13:01:03 2022 -0700

    Fixes #345.

    Fixed a bug in the PNM decoder caused by integer overflow.
    Added some functions for performing safe 32-bit unsigned integer
    arithmetic.
    Added the JAS_ATTRIBUTE_CONST and JAS_ATTRIBUTE_PURE to some math
    functions.

A	data/test/bad/345-0.pnm
A	data/test/bad/345-1.pnm
M	src/libjasper/include/jasper/jas_math.h
M	src/libjasper/pnm/pnm_dec.c

commit 6663250088ece915836dcaece4a18131d046138c
Merge: 40cf600 b9631a1
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Mon Sep 19 18:02:48 2022 +0200

    Merge pull request #341 from Biswa96/pkgconfig-requires-private

    pkgconfig: Add Requires.private field for static linking

commit b9631a160de3237d851ccbd53d66eb601968ff89
Author: Biswapriyo Nath <nathbappai@gmail.com>
Date:	Mon Sep 19 20:27:46 2022 +0530

    pkgconfig: Add Requires.private field for static linking

    Requires.private field is required to link dependent libraries
    while static linking. For example, here libjpeg and libheif.
    `pkgconf -libs -static` command will show the dependent libraries.
    This helps to manage the dependent libraries automatically in build
    system without adding them explicitly while static linking.
    More information about this feature can be found here
    https://people.freedesktop.org/~dbn/pkg-config-guide.html

M	CMakeLists.txt
M	build/jasper.pc.in

commit 40cf600848cb07b604ba81c9b31b0f1d4e395bac
Merge: 2b784e4 8442158
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Sep 19 07:37:24 2022 -0700

    Merge pull request #339 from jasper-software/rel307

    Update NEWS file in preparation of next release

commit 8442158424fdfa5f7676e41c81c8ed66986f8d56
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Fri Sep 16 14:04:17 2022 +0200

    Update NEWS file in preparation for next release

M	NEWS.txt

commit 2b784e4767784500883ae5f1ab342986bcee4ca0
Merge: 0c2a927 b04f8a2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Sep 18 22:25:58 2022 -0700

    Merge pull request #336 from Biswa96/pkgconfig-cflags-private

    pkgconfig: Add Cflags.private field for static linking

commit b04f8a2daa2f4cf3715dc698e7e4d5942866d68b
Author: Biswapriyo Nath <nathbappai@gmail.com>
Date:	Wed Aug 24 21:22:19 2022 +0530

    pkgconfig: Add Cflags.private field for static linking

    This defines LIBJASPER_STATIC_DEFINE when static linking is expected.
    The Cflags.private field depends on pkgconf rather than pkg-config.
    Without this change, linker finds exported APIs with dllimport and
    it produces the error:

    ld.exe: test_1.c:(.text+0x2b): undefined reference to
    `__imp_jas_get_total_mem_size'
    ld.exe: test_1.c:(.text+0x4b): undefined reference to
    `__imp_jas_optarg'
    and more.

    Result of this change:

    * Before:
    $ pkgconf -cflags -static jasper
    -IF:/msys64/ucrt64/include/jasper -IF:/msys64/ucrt64/include

    * After:
    $ pkgconf -cflags -static jasper
    -IF:/msys64/ucrt64/include/jasper -IF:/msys64/ucrt64/include
    -DLIBJASPER_STATIC_DEFINE

M	build/jasper.pc.in

commit 0c2a927c530d18a706ace73536f347354ca3d957
Merge: 75c5cec 411c81a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Aug 24 07:37:48 2022 -0700

    Merge pull request #335 from Biswa96/pkgconfig-path-relocate

    pkgconfig: Add missing prefix field

commit 411c81a90d0f91e80983f85041015e220f180f41
Author: Biswapriyo Nath <nathbappai@gmail.com>
Date:	Wed Aug 24 12:11:59 2022 +0530

    pkgconfig: Add missing prefix field

    This fixes path relocation in mingw environment. For example,

    * Before:
    $ pkgconf -cflags jasper
    -I/ucrt64/include/jasper -IF:/msys64/ucrt64/include

    * After:
    $ pkgconf -cflags jasper
    -IF:/msys64/ucrt64/include/jasper -IF:/msys64/ucrt64/include

M	build/jasper.pc.in

commit 75c5cecb20a67101eddc189f373efefcd431b71c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 30 13:29:10 2022 -0700

    Modified the sysinfo script to better detect various OSes.

M	build/sysinfo

commit 8ff64591c153ab41dde35317fe9a63910a9dce72
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 30 11:56:10 2022 -0700

    Added some extra information logging in the build and build_all
    scripts.
    Changed the format of a log message in the JPC codec.
    Added -I and -X options to the run_codec_test script in order to allow
    explicit inclusion and exclusion of tests.
    Disabled the sgn_1 test in the run_test_3 script on Windows.
    Added a new script called sysinfo for obtaining platform-specific
    information.

M	build/build
M	build/build_all
A	build/sysinfo
M	src/libjasper/jpc/jpc_enc.c
M	test/bin/run_codec_test
M	test/bin/run_test_3

commit 5cc343fd839d28645396437f7ed6bead4ac13ad9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 30 09:23:50 2022 -0700

    JPC Codec:
    Added more information to a log message in the JPC encoder.

M	src/libjasper/jpc/jpc_enc.c

commit 815e3bf29b6362288507206b110b4623d434cc01
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 30 08:19:26 2022 -0700

    Added the --out-dir option to the build script.
    Made a few code changes in an attempt to eliminate some compiler
    warnings
    in the case of MSVC on Windows.

M	build/build
M	src/libjasper/base/jas_image.c
M	src/libjasper/include/jasper/jas_math.h
M	src/libjasper/pgx/pgx_enc.c

commit 5d6db116623b16e295ad04a3608a262e502b1baf
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jul 29 23:07:16 2022 -0700

    Made several code changes in order to prevent some compiler
    warnings in
    the case of MSVC on Windows.

M	CMakeLists.txt
M	src/libjasper/base/jas_image.c
M	src/libjasper/jpc/jpc_enc.c
M	src/libjasper/pgx/pgx_enc.c

commit 7ea30054f420046596e9b9d78e90d4011a901ccf
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jul 29 20:52:23 2022 -0700

    Corrected some inconsistent choices of integral types used for
    fixed-point
    representations (which causes portability problems).

M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_fix.h
M	src/libjasper/include/jasper/jas_seq.h
M	src/libjasper/jpc/jpc_fix.h

commit 1772294a59cbbb88f1251e876da8a9007dae9451
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jul 25 10:45:59 2022 -0700

    JPC/JP2 Codec:
    Changed the manner in which the parameters of the fixed-point
    representation used in the codec are specified.
    Changed the default settings for these parameters to ensure that the
    implementation can pass the JPEG-2000 conformance tests (with
    the caveat
    that reduced resolution reconstructions are not currently supported so
    tests requiring this functionality simply cannot be run).

M	CMakeLists.txt
M	src/libjasper/jpc/jpc_fix.h

commit 098db6fec6c982bc91ad5898f7deea225670827f
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jul 25 07:24:35 2022 -0700

    Changed the run_conformance_tests script to obtain the JPC/JP2
    codestreams
    for JPEG-2000 conformance testing from the WG1 GitLab repository.

M	src/app/CMakeLists.txt
M	test/bin/run_conformance_tests

commit 270000671d4f411fe7e65c7bc02fd6ff14dd6946
Merge: 71d9331 d99636f
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Mon Jul 25 10:44:23 2022 +0200

    Merge pull request #333 from xiaoxiaoafeifei/master

    fix memory leaks in function cmdopts_parse

commit 71d93313c9ee37b15ae72289b0793cc53e747a38
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jul 24 21:52:21 2022 -0700

    JPC/JP2 Codec:
    Added descriptions for some new conformance tests and updated the
    descriptions for some of the old ones.
    Made a few improvements to the run_conformance_tests script (e.g.,
    changed the script to skip tests that require resolution reduction
    since
    the JPC decoder does not support this).

    JPC/JP2 Codec:
    Fixed a regression in the jpc_pi_nextcprl function.  This regression
    would cause some valid JPC/JP2 codestreams to be rejected.

M	src/libjasper/jpc/jpc_t2cod.c
M	src/libjasper/jpc/jpc_t2dec.c
R078	test/bin/decoder_tests	test/bin/conformance_tests
M	test/bin/run_conformance_tests

commit d99636fad60629785efd1ef72da772a8ef68f54c
Author: zhailiangliang <zhailiangliang@loongson.cn>
Date:	Wed Jul 20 08:58:31 2022 +0000

    fix memory leaks in function cmdopts_parse

M	src/app/jasper.c

commit 402de0aee7c12f1b4070a0ab2476e1c112fbe62c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jul 17 14:44:41 2022 -0700

    Made a few improvements to the run_conformance_tests script.

M	src/app/CMakeLists.txt
M	test/bin/decoder_tests
M	test/bin/run_conformance_tests
M	test/bin/utilities

commit f14b2d247a46690ee930fe55f5992cabcb3d41be
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jul 17 11:53:35 2022 -0700

    Made a few minor improvements to the run_conformance_tests script.

M	test/bin/run_conformance_tests

commit 460c7927ca6469095b6a7d1067d86680c5ec7770
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jul 17 11:52:11 2022 -0700

    imgcmp Program:
    Fixed a minor bug that would cause an infinite metric value to be
    printed only as a very large number (FLT_MAX) instead of as "inf".

M	src/app/imgcmp.c

commit 971c7d48de9952dd91cb37b79b1c38e1c946b0f2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 16 12:20:57 2022 -0700

    Made some changes to the build process in an attempt to fix a build
    issue with Clang on Ubuntu.

M	CMakeLists.txt
M	build/build
M	build/build_all

commit b80ee3ba67c9d52b507219426001d214a35e407a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 16 08:44:26 2022 -0700

    Enabled building with PIC in order to try to resolve a build
    issue with
    Clang on Ubuntu.

M	CMakeLists.txt

commit dfadaf416158e58b1725999f932437ec5e2e7165
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 16 07:39:35 2022 -0700

    Disabled a hack to workaround a GitHub CI build issue.

M	build/build_all

commit 8b77319410042d7e21409447c39fbb7782f9c665
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jul 15 23:23:53 2022 -0700

    JPC Codec:
    More experimenting with the JPC_FIX_FRACBITS parameter of the
    fixed-point
    representation.

M	src/libjasper/jpc/jpc_fix.h
M	test/bin/decoder_tests

commit 012c4f42482dcb9bf6f965ee9e337ff1acba3006
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jul 15 21:31:53 2022 -0700

    JPC Codec:
    Further experimenting with the JPC_FIX_FRACBITS parameter of the
    fixed-point representation.

M	CMakeLists.txt
M	src/libjasper/jpc/jpc_fix.h

commit 46b5c14b33b7b0955855b09cf99f60c85d9e2ef2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jul 15 20:38:14 2022 -0700

    JPC Codec:
    Further experimenting with the JPC_FIX_FRACBITS parameter of the
    fixed-point representation.

M	src/libjasper/jpc/jpc_fix.h

commit 0ad67b4e865e08e392694e9af1e498d19ae86b85
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jul 15 17:32:06 2022 -0700

    JPC Codec:
    Made further adjustments to the JPC_FIX_FRACBITS parameter of the
    fixed-point representation.

    Disabled some conformance tests that would fail with the new choice
    of JPC_FIX_FRACBITS.

M	src/libjasper/jpc/jpc_fix.h
M	test/bin/decoder_tests
M	test/bin/run_conformance_tests
M	test/bin/utilities

commit 76c3fa3d48d7092c4834712787196dbd48c70379
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jul 15 16:53:24 2022 -0700

    JPC Codec:
    Changed the JPC_FIX_FRACBITS parameter used to determine the position
    of the radix point in the fixed-point representation.  This was
    done in
    order to satisfy some error thresholds specified in ISO/IEC 15444-4.

    Changed the build process so that the exit status of the
    run_conformance_tests script is no longer ignored.	(Previously, the
    exit status had been deliberately ignored.)

M	build/github/prebuild-v2
M	src/app/CMakeLists.txt
M	src/libjasper/jpc/jpc_fix.h
M	test/bin/run_conformance_tests

commit 0bbce180111ee5cafc7bd360a970db74ff1ae8b1
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jul 15 14:43:15 2022 -0700

    Fixed a GitHub CI issue.

M	build/github/prebuild-v2

commit 6e000fc8927c38dfe7336078ebd1b17f7fc30e43
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jul 15 14:38:41 2022 -0700

    Added the CMake build option JAS_ENABLE_CONFORMANCE_TESTS for enabling
    conformance tests.
    Changed the build scripts to allow for conformance tests to be
    enabled.
    Made some changes/corrections to the conformance-test database.

    jasper Program:
    Added the --quiet option to the jasper program to allow the verbosity
    of program output to be reduced.

M	CMakeLists.txt
M	build/build
M	build/build_all
M	build/github/prebuild-v2
M	src/app/CMakeLists.txt
M	src/app/jasper.c
M	test/bin/decoder_tests
R083	test/bin/run_test_4	test/bin/run_conformance_tests

commit 4e19b2bde2188d68e22a7516b1b0a422c1da09fe
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jul 14 20:58:52 2022 -0700

    Testing Scripts:
    Made a few small improvements to the run_test_4 script.
    Added a few more conformance tests.

M	test/bin/decoder_tests
M	test/bin/run_test_4

commit db967c16d1b840ebd86ca9969fb59a032de4277e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jul 14 20:13:26 2022 -0700

    imgcmp Program:
    Added the quiet (-q) and debug-level (--debug-level) options to the
    imgcmp program.  Also, fixed a memory leak that can occur when the
    program terminates due to an error.

    imginfo Program:
    Added the quiet (-q) option to the imginfo program.

    JPC/JP2 Codec:
    Added some more calls for log message generation.

    PGX Codec:
    Fixed an apparent bug in the parsing of the PGX header.

    Testing Scripts:
    Revised the run_test_4 script (which is used for conformance testing).

M	src/app/imgcmp.c
M	src/app/imginfo.c
M	src/libjasper/jp2/jp2_dec.c
M	src/libjasper/jpc/jpc_bs.c
M	src/libjasper/jpc/jpc_t2cod.c
M	src/libjasper/jpc/jpc_t2cod.h
M	src/libjasper/jpc/jpc_t2dec.c
M	src/libjasper/pgx/pgx_dec.c
M	test/bin/decoder_tests
M	test/bin/run_test_4
M	test/bin/utilities

commit 6d2a339fa18a4dad0ac19aafad7646cb099c7aae
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Jul 13 08:13:22 2022 -0700

    Bumped the version number and updated the NEWS document.

M	CMakeLists.txt
M	NEWS.txt

commit c77a491a8ef8ce0811161a86ff694ce9dba33f22
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Jul 13 08:11:07 2022 -0700

    Fixed an apparent typo in the deploy_gh_pages script.

M	build/github/deploy_gh_pages

commit 7a77a00ce0a6e9388e6dcd041eaea7030cb084cd
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jun 23 09:09:12 2022 -0700

    Changed the build script so that it automatically disables the
    building
    of the documentation on the Windows platform.

M	build/build

commit a0dbf66af3a1eb47e4f744e8242597aea5f24a3d
Merge: 2f472a1 3a4e0d4
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jun 23 07:12:55 2022 -0700

    Merge pull request #329 from jubalh/305-changelog

    Add PR number to NEWS

commit 3a4e0d4458bab75d369da65d6d0d64e2c482f369
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Thu Jun 23 16:04:14 2022 +0200

    Add PR number to NEWS

    For users who are interested in reading up on the details.

M	NEWS.txt

commit 2f472a1d7f3faa213bc826ae258768d849964cfe
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jun 23 06:58:55 2022 -0700

    Updated the NEWS document and bumped the version number.

M	CMakeLists.txt
M	NEWS.txt

commit 2c6d9fefe005970c2bcd64830aae4db60addd9d4
Merge: 6a5d65a 565d09d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jun 23 06:53:02 2022 -0700

    Merge pull request #328 from theta682/fix-embedded-build

    Allow building inside another project

commit 565d09de7061f29cd611374b67141899b7541380
Author: Timothy Lyanguzov <timothy.lyanguzov@sap.com>
Date:	Mon Jun 20 11:20:09 2022 +1200

    Allow building inside another project

M	build/cmake/modules/JasGetStdcVersion.cmake

commit 6a5d65aef9c80e6accbfa52e70f89fb29bc89838
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jun 2 21:10:20 2022 -0700

    Updated the NEWS document and bumped the version number.

M	CMakeLists.txt
M	NEWS.txt

commit 8138231d3caf95000cff7e1df86c10d0ce8db223
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jun 2 18:45:27 2022 -0700

    Eliminated a few calls to the abort function.

M	src/libjasper/base/jas_cm.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_stream.c
M	src/libjasper/bmp/bmp_cod.c
M	src/libjasper/bmp/bmp_dec.c

commit f8809df1965a5eee1c73ffea7174689031d03ed2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jun 2 18:03:32 2022 -0700

    Added another test image and test case.

A	data/test/other/pr325-bad-icc-profile.jp2
M	test/bin/run_test_imginfo

commit 8056c8eeb17e9e0240abf42e0baaa317419980bb
Merge: 77d1fd0 07856c3
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jun 2 17:23:01 2022 -0700

    Merge pull request #325 from theta682/relax-icc-validation

    Don't crash the application if ICC color profile is incorrect

commit 07856c3155f463ec4f4dc5608720e00dde00069d
Author: Timothy Lyanguzov <timothy.lyanguzov@sap.com>
Date:	Wed Jun 1 12:38:33 2022 +1200

    Don't crash the application if ICC color profile is incorrect

    Incorrect ICC color profile should not kill the application.
    Just report an issue and continue. It is not a critical issue.

M	src/libjasper/base/jas_cm.c
M	src/libjasper/jp2/jp2_dec.c

commit 77d1fd04632ca85340101f1418b0f06687fcf5a3
Merge: 5e45df4 bd909b4
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon May 30 09:46:54 2022 -0700

    Merge pull request #324 from jubalh/fix/323-value

    Fix value in jas_safeui64_div

commit bd909b4479c5c08b9592cb33a8bbc2066de9e45c
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Mon May 30 18:19:48 2022 +0200

    Fix value in jas_safeui64_div

    y.valid was used where we wanted y.value.

    It got introduced with commit def49688. So JasPer versions affected
    are: 3.0.0 until 3.0.3.

    Fix https://github.com/jasper-software/jasper/issues/323

M	src/libjasper/include/jasper/jas_math.h

commit 5e45df490870073c9f38785724959c1a429e95a0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu May 12 22:37:38 2022 -0700

    Eliminated the use of Travis CI for CI functionality, since GitHub
    Actions is now used for this purpose.

D	.travis.yml

commit 411571cf8f341c4b4e01bc2fe5c68f5127ecdc02
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Apr 8 09:22:54 2022 -0700

    Added some additional logging to the color-management code.

M	src/libjasper/base/jas_cm.c

commit 6b13436680733fd9c3963ded91667a46b8e6771d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Mar 22 19:03:53 2022 -0700

    Removed a dependence on a nonstandard language extension in the
    JP2 codec.

M	src/libjasper/jp2/jp2_dec.c

commit 4dc8415170657fc56545c05e077ff467b79b0a2b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Mar 22 18:12:10 2022 -0700

    Added the (conditional) printing of several log messages in the code.

M	src/libjasper/base/jas_image.c
M	src/libjasper/bmp/bmp_dec.c
M	src/libjasper/pgx/pgx_dec.c
M	src/libjasper/ras/ras_dec.c

commit bc34e551a3ac5572d3a7e6767b729296c29d2c51
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Mar 22 17:27:06 2022 -0700

    Fixed some issues with the integral types used internally by
    jas_stream_peek.
    Made some mostly cosmetic changes to the JP2 decoder.

M	src/libjasper/base/jas_stream.c
M	src/libjasper/jp2/jp2_dec.c

commit 482c64058c6227fe65a23130cc00c30a0774dd56
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Mar 22 16:19:06 2022 -0700

    Added more information to a log message for the JP2 decoder.

M	src/libjasper/jp2/jp2_dec.c

commit 38ee384c825076834d7ee83655f8bc6af38e5b36
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Mar 16 10:44:58 2022 -0700

    Fixes #321.

    An invocation of JAS_UNUSED was misplaced in one function, which might
    cause some compilers to generate a warning.  This has now been fixed.

M	src/libjasper/base/jas_cm.c

commit 020ec588d59d6ef13aef73aa0d86343ddda600b5
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Mar 15 00:45:37 2022 -0700

    Updated the NEWS document.
    Bumped the version number.

M	CMakeLists.txt
M	NEWS.txt

commit 9fd150d68bdec00c638690887654ff58b6a9959b
Merge: cd9273c 3b45402
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Feb 18 17:51:39 2022 -0800

    Merge pull request #320 from diizzyy/bash-path

commit cd9273c65ad4b885f97b358ae748528c9057798c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Feb 18 17:27:07 2022 -0800

    Changed the GitHub Actions ci workflow to also run on pull_request
    events.

M	.github/workflows/ci.yml

commit 3b45402e1fa273c01b38c559deb14c18f5fb73ff
Author: Daniel Engberg <daniel.engberg.lists@pyret.net>
Date:	Sat Feb 19 00:23:09 2022 +0100

    Use #!/usr/bin/env bash shebang for test binaries

    Use a non hardcoded path to bash for all test binaries

M	test/bin/jpcod
M	test/bin/jpdec
M	test/bin/jpenc
M	test/bin/run_codec_test
M	test/bin/run_mem_test
M	test/bin/run_test_1
M	test/bin/run_test_2
M	test/bin/run_test_3
M	test/bin/run_test_4
M	test/bin/run_test_5
M	test/bin/run_test_imgcmp
M	test/bin/run_test_imginfo
M	test/bin/utilities
M	test/bin/wrapper.in

commit 00786cda659bef967a18555bd904cc36a50ed809
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Feb 14 07:05:43 2022 -0800

    Corrected a typo in the pattern used to identify non-preview releases
    in the deploy_gh_pages script.

M	build/github/deploy_gh_pages

commit 2678639c1f233522819093d128f19a4ac4a5cc03
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Feb 14 06:54:28 2022 -0800

    Bumped the version number and updated the NEWS document.

M	CMakeLists.txt
M	NEWS.txt

commit acfe76d764403aa7351f125717e0eb0384fff85f
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Feb 14 06:47:14 2022 -0800

    Added logic to the deploy_gh_pages script to automatically determine
    if
    the "latest" symlink should be updated during deployment.

M	build/github/deploy_gh_pages

commit b8ecbfbf293ee6086e4d40108ad730229388cd8d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Feb 13 06:54:26 2022 -0800

    Added a mechanism for JAS_STDC_VERSION to be set (cleanly) when a
    cross-compiler is used.

M	CMakeLists.txt

commit 901f295e974b827e925e8b943380abffd0845adf
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 12 14:22:36 2022 -0800

    Changed the GitHub Actions deploy_manual and release workflows to use
    on-push.

M	.github/workflows/deploy_manual.yml
M	.github/workflows/release.yml

commit 594162cf2225926895f8f98380d1d6926dbb1845
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 12 13:11:04 2022 -0800

    Made some improvements to the build_all script.

M	build/build_all

commit 091d019c17740266f26b75356f86fb86df5b2377
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 12 12:49:32 2022 -0800

    Bumped the version number and updated the NEWS document.

M	CMakeLists.txt
M	NEWS.txt

commit 606e5852c90d919d3b5504e65157117fd842e543
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 12 11:38:15 2022 -0800

    Enabled some CI tests that were disabled on MacOS.

M	build/build_all

commit 19aae6412e7abf2defdc11a156cc76675a074348
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 12 11:27:38 2022 -0800

    Fixed a typo in the build_all script.

M	build/build_all

commit 9ae2abfc34dfc9ada845b06973a3cf39d85c3a17
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 12 10:41:49 2022 -0800

    Added a temporary hack to workaround a build problem when C++
    test code
    is built in the GitHub Actions CI framework with Clang on Ubuntu.

M	build/build_all

commit d2351c928bb59ab11873dc1e9dcd2d8f815e05b6
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 12 10:17:39 2022 -0800

    Modified the build_all script so that all tests are always run.

M	CMakeLists.txt
M	build/build_all

commit 39047be58de0f7f1e58b9866ef7f78722fba9bf1
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 12 07:36:21 2022 -0800

    Fixes #318.

    Eliminated the use of "class" as an identifier, as this will
    clearly cause
    problems if JasPer headers are used in C++ source code.

    In order to catch incompatibilities with C++ in the future, a
    trivial C++
    test program has been added.
    The CMake build process was adjusted to (optionally) allow the use
    of a
    C++ compiler.
    Each use of add_compile_options that sets C compiler options was
    changed
    to use a new function called add_c_compile_options that only sets
    options
    for the C compiler.
    Some changes to the CMake module for code sanitizers were made in
    order to
    handle the C++ compiler case.
    Several new options were added to the build script.

M	CMakeLists.txt
M	build/build
M	build/build_all
M	build/cmake/modules/Sanitizers.cmake
M	src/app/CMakeLists.txt
A	src/app/test_2.cpp
M	src/libjasper/include/jasper/jas_log.h

commit 2c3517f528f6ffd5f8ce4af604c8cdc558d0bf1d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 12 05:44:51 2022 -0800

    Fixes #317.

    Changed two occurrences of WIN32 to _WIN32 in the I/O stream code.

M	src/libjasper/base/jas_stream.c

commit fd08e1778e5c19fb0ef4d231490bbf3b7b66fa72
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Feb 7 05:13:57 2022 -0800

    Changed the top-level CMakeLists.txt file to print the CMake version
    being used.

M	CMakeLists.txt

commit df22a3c8c32d51255a6a3eacbc61a1c2bee33340
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Feb 7 05:02:51 2022 -0800

    Removed some extra double quotes from the top-level CMakeLists.txt
    file.

M	CMakeLists.txt

commit 1d50ee8b3fb5189cfa61550aa40fb93c99ba2f6c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Feb 6 11:27:32 2022 -0800

    Changed the make_main_gh_page script so that the latest version is
    explicitly identified and the entries are listed in reverse order.

M	build/github/make_main_gh_page

commit 6708e57d2b95158dc3774dfa2effdbc67a0c752e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 5 15:24:56 2022 -0800

    Changed the GitHub Actions CI deploy_manual workflow to specify
    on-create.

M	.github/workflows/deploy_manual.yml

commit 87e327003499bae0ecaf211d4fc1f04f1f15bf0d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 5 15:13:16 2022 -0800

    Changed the GitHub Actions release workflow to specify on-create.

M	.github/workflows/release.yml

commit 9bdf1ddaa05d824c69c6b239a3642105c6458b34
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 5 13:05:54 2022 -0800

    Updated a date in the NEWS document.

M	NEWS.txt

commit 7125722eab46612bbde8759d47c650146866deb9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 5 13:00:12 2022 -0800

    Revised the man pages for the various JasPer application programs.

M	src/app/imgcmp.1
M	src/app/imginfo.1
M	src/app/jasper.1
M	src/app/jiv.1

commit 56dce6bedac53b1b39a3e419dd2ffbdf6a2b6132
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 5 12:11:41 2022 -0800

    Made a few improvements/corrections to the documentation.

M	NEWS.txt
M	doc/src/overview.dox.in
M	src/libjasper/include/jasper/jas_debug.h

commit a3721e0352cb2765010eff90f201a093ca2c973e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Feb 5 07:43:15 2022 -0800

    Made some changes to the manner in which the max_align_t and ssize_t
    types are handled.

M	CMakeLists.txt
M	src/libjasper/include/jasper/jas_types.h

commit 09d5bbc7a71bf99a870a62adff73633e8815a2f9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 20:06:13 2022 -0800

    Added the CMake function jas_check_type to provide a more convenient
    interface to the check_type_size function.
    Eliminated the jas_ssize_t type and the JAS_SSIZE_MAX constant.

M	CMakeLists.txt
A	build/cmake/modules/JasCheckType.cmake
M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_stream.h
M	src/libjasper/include/jasper/jas_types.h
M	src/libjasper/jp2/jp2_cod.c

commit 6447bd695b8157b3a66657383112454d802b408f
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 16:05:01 2022 -0800

    Disabled the setting of the CMake policy CMP0115 (since it is
    relatively
    new and appears to cause problems for older versions of CMake).

M	CMakeLists.txt

commit fae1ee3a465a7ea5df19916dd5acb9720eb71e01
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 15:52:09 2022 -0800

    Updated the date for the 3.0.0 release in the NEWS document.

M	NEWS.txt

commit 4df33b36afcf5938993911064d5c1b3cf244bacc
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 15:46:21 2022 -0800

    Revised the remove list in the make_release script.

M	build/make_release

commit e61d4e8262f57f64e8497010844231b56fe46067
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 15:05:02 2022 -0800

    Removed the PDF file containing the obsolete document titled "JasPer
    Software Reference Manual (Version 1.900.0)" (dated 2006-12-07),
    as this
    document is completed replaced by the Doxygen-generated manual.

M	doc/CMakeLists.txt
M	doc/README.txt
D	doc/jasper.pdf

commit 8681af6a88755f34e9b41304e8329a4f1301bf59
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 14:49:29 2022 -0800

    Changed a few key compiler flags to be set via CMAKE_C_FLAGS instead
    of via add_compile_options.
    Removed the use of _POSIX_C_SOURCE in a few places.

M	CMakeLists.txt
M	src/app/multithread.c
M	src/libjasper/include/jasper/jas_config.h.in

commit dce2969406d2812950f8ae73f875936b171fa63b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 13:09:20 2022 -0800

    Set CMAKE_C_EXTENSIONS to ON.

M	CMakeLists.txt
M	src/libjasper/include/jasper/jas_string.h

commit 36e650b6ee4b60d50429902ed570c729cfe66aed
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 12:16:47 2022 -0800

    Set CMAKE_C_EXTENSIONS to OFF.
    Added a preprocessor definition of _POSIX_C_SOURCE in a few places.
    Added the -Wpedantic and -Werror options to some of the compile tests
    to prevent failures due to compiler warnings when later building the
    real code.

M	CMakeLists.txt
M	src/app/multithread.c
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_types.h

commit 317fa63ea61fbc86d7e40c7343caf8bcc17a4943
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 10:19:54 2022 -0800

    Added special case handling of max_align_t for Windows.

M	src/libjasper/include/jasper/jas_types.h

commit 424afcdfd203b4b900560e92a8d8ea0cdc39d686
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 10:13:43 2022 -0800

    Changed the print_stdc program to print a version of 0 when the
    version cannot be determined.
    Used a define instead of a typedef for max_align_t in the
    jas_types.h header.
    Added a -h option to the build_all script for printing usage
    information.

M	CMakeLists.txt
M	build/build_all
M	build/cmake/src/print_stdc.c
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_types.h

commit d4540c93df4a50b641be3dddead91cd5b211d5ff
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 09:50:27 2022 -0800

    Changed the handling of max_align_t in an attempt to fix a Windows
    build problem.

M	CMakeLists.txt
M	src/libjasper/include/jasper/jas_types.h

commit 37da135dd620ae573866c73ce361b67fe4ed2464
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 09:09:08 2022 -0800

    Removed the jas_max_align_t type.

M	CMakeLists.txt
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/include/jasper/jas_cm.h
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_types.h

commit 69181807bbdad0c750a85b461399cb9fac43f8fc
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 08:35:02 2022 -0800

    Removed the jas_uintmax_t and jas_intmax_t types.

M	CMakeLists.txt
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_math.h
M	src/libjasper/include/jasper/jas_types.h

commit 5a720e7aaa2f54774dc1a7163add6bae668aead8
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 08:08:25 2022 -0800

    Fixed a build problem caused by pre-C99 compilers.

M	build/cmake/src/print_stdc.c

commit 656d84a81937b8a004a70103c18360b1b79d4e60
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Feb 3 07:58:59 2022 -0800

    Changed the build process to record the version of the C standard
    against
    which JasPer was built.
    Modified the JasPer headers so that a warning will be generated if the
    headers are used to build against an older version of the C standard
    than what was used to build JasPer.

M	CMakeLists.txt
A	build/cmake/modules/JasGetStdcVersion.cmake
A	build/cmake/src/print_stdc.c
M	src/libjasper/include/jasper/jas_config.h.in

commit 1a076bb1aa0afe9fcdd09339989b9eea61a90d08
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 30 14:06:10 2022 -0800

    Renamed jas_logtype_get_class and jas_logtype_get_priority to
    jas_logtype_getclass and jas_logtype_getpriority, respectively.
    Renamed jas_string_tokenize to jas_stringtokenize.

    Added support for HEIC encoding of grayscale images.
    Fixed a bug in jas_heic_validate.

    Added the --enable-all-formats option to the jasper and imginfo
    programs.
    Added the --max-samples and --enable-all-formats options to the
    jiv program.
    Changed the default maximum number of samples for decoding to be
    unlimited.

    Added some code documentation.

M	NEWS.txt
M	doc/src/codecs.dox
M	doc/src/lib_log.dox
M	doc/src/lib_string.dox
M	src/app/imginfo.c
M	src/app/jasper.c
M	src/app/jiv.c
M	src/app/test_1.c
M	src/libjasper/base/jas_debug.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_string.c
M	src/libjasper/heic/heic_dec.c
M	src/libjasper/heic/heic_enc.c
M	src/libjasper/heic/heic_val.c
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_log.h
M	src/libjasper/include/jasper/jas_string.h
M	src/libjasper/include/jasper/jas_version.h

commit 441d8f2bf8f2bc5645055fca4f2577996a7e9d17
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jan 28 09:07:32 2022 -0800

    Added a log message to the jas_init_library function that shows the
    library version.
    Added support in the jas_get_total_mem_size function for generic Unix
    platforms.

M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c

commit 5b06931c8a08bc06d305d831ea23da3162fedc1b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jan 27 23:30:33 2022 -0800

    Added JP2 versions of the goldenears and goldenears_gray images.

A	data/images/goldenears.jp2
A	data/images/goldenears_gray.jp2

commit 73d02ec44792655ebc20cd888c821ad5b0522c20
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jan 27 23:24:18 2022 -0800

    Fixed a bug in the I/O streams code related to the handling of
    the FILE
    (i.e., C standard library stream) type of file object.  This bug can
    result losing characters at/near the end of file.

M	src/libjasper/base/jas_stream.c

commit 26da5104642725b638ff73517897f99619b126ce
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jan 27 11:13:36 2022 -0800

    Added the --debug-level option to the jiv program.

M	src/app/jiv.c

commit 449c4a9eb9030eb6cdb37f976c3f8d6a6ac05c84
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Jan 27 10:49:24 2022 -0800

    Added the generation of more log messages in the JPC decoder.
    Fixed a typo in a string constant.

M	src/libjasper/base/jas_debug.c
M	src/libjasper/jpc/jpc_t2dec.c

commit 7061c3b8c319bfbc2cecd06148f648f4f5e5cb12
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Jan 26 08:12:30 2022 -0800

    Reverted the change of the return type of the jas_stream_copy
    function,
    since the change of the return type does not make sense unless the
    function is also changed to return the number of characters copied.

    Added some information to the installation section of the manual.
    Corrected a typo in the documentation.

M	doc/src/install.dox.in
M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_log.h
M	src/libjasper/include/jasper/jas_stream.h

commit 65ee3a02d4148d9890dbbecca1432f10fc886e5c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Jan 26 07:47:00 2022 -0800

    Changed the return type of jas_set_debug_level to void to be
    consistent
    with other similar functions in the JasPer library API.
    Changed all uses of jas_getdbglevel and jas_setdbglevel to
    jas_get_debug_level and jas_set_debug_level, respectively.
    Marked the functions jas_getdbglevel and jas_setdbglevel as
    deprecated.

M	src/libjasper/base/jas_debug.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_string.c
M	src/libjasper/include/jasper/jas_debug.h
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_stream.h
M	src/libjasper/jp2/jp2_cod.c
M	src/libjasper/jp2/jp2_dec.c
M	src/libjasper/jpc/jpc_cs.c
M	src/libjasper/jpc/jpc_dec.c
M	src/libjasper/jpc/jpc_enc.c
M	src/libjasper/jpc/jpc_mqdec.c
M	src/libjasper/jpc/jpc_mqenc.c
M	src/libjasper/jpc/jpc_t1dec.c
M	src/libjasper/jpc/jpc_t2dec.c
M	src/libjasper/pgx/pgx_dec.c
M	src/libjasper/pgx/pgx_enc.c

commit 648d44f91e26e7852dc114aa8bcf629384fc0cc9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Jan 25 16:31:13 2022 -0800

    Moved a use of _Thread_local inside a conditional compile directive.

M	src/libjasper/include/jasper/jas_init.h

commit 4ecc94c07da4d3e08dcba55fb288118040b14cdd
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Jan 25 16:16:17 2022 -0800

    Fixed a typo in the top-level CMakeLists.txt file.
    Made some minor changes to the build script.

M	CMakeLists.txt
M	build/build

commit 6623861d031b60aa5cacc4580fa46203713f92b8
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Jan 25 15:30:21 2022 -0800

    Changed the per-thread context to use thread-local storage (i.e.,
    _Thread_local) by default instead of POSIX Thread Library
    thread-specific storage.  This should allow more optimal code to be
    generated on some platforms.
    Changed the implementation of the functions used to query some
    per-thread
    context settings to better exploit thread-local storage.
    Made the jas_ctx_t type normally hidden.

    Added the CMake option JAS_PREFER_PTHREAD_TSS to allow the use of
    thread-local storage to be disabled.

    Made some changes to the verbosity of the build and build_all scripts.

M	CMakeLists.txt
M	build/build
M	build/build_all
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_init.h

commit de43a2bb8738751a50d39e50a931c79faad2db9b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Jan 25 11:16:27 2022 -0800

    Made the type jas_image_fmt_t local to the source file jas_init.c.
    Performed some miscellaneous code cleanup.

M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_init.h

commit 3e9c4e5c923ba290869077916a83d2dd6dda07be
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 23 19:51:27 2022 -0800

    Added more information to the manual.

M	doc/src/lib_images.dox
M	doc/src/lib_math.dox
M	doc/src/lib_timers.dox
M	src/libjasper/include/jasper/jas_seq.h
M	src/libjasper/include/jasper/jas_tmr.h

commit 983651f8bdc9dacb546ac9839ac3051f23fddae2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 23 17:15:08 2022 -0800

    Updated the top-level README document.

M	README.md

commit 8947d8c3c667995e96c810b0bdd1823b287bbc44
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 23 16:26:12 2022 -0800

    Made the strict mode for the build process treat all warnings
    as errors.
    Disabled compiler warnings for out-of-range comparisons, since these
    warnings can cause the build process to fail on some platforms when
    building in strict mode (e.g., due to some compilers issuing spurious
    warnings).
    Added a CMake option for disabling the use of LaTeX even when it is
    detected as being available.
    Made the --verbose option of the build script yield more verbose
    output.
    Added a --quiet option to the build script.

    Used doxygen to update the Doxyfile.
    Made numerous improvements to the manual (e.g., added some information
    on the codec driver interface).
    Fixed some typos/errors in the manual.

    Added a missing check on the return value of jas_cmshapmat_invmat
    in the
    jas_cmprof_createsycc function.
    Fixed a memory leak on an error path in the jas_cmprof_createsycc
    function.
    Removed some unused/unnecessary code from the library.

M	CMakeLists.txt
M	build/build
M	doc/CMakeLists.txt
M	doc/Doxyfile.in
M	doc/src/bugs.dox
M	doc/src/intro.dox
M	doc/src/lib.dox
M	doc/src/lib_images.dox
M	doc/src/lib_string.dox
M	doc/src/license.dox.in
M	doc/src/modules.dox
M	doc/src/overview.dox.in
M	src/libjasper/base/jas_cm.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_cm.h
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_log.h
M	src/libjasper/include/jasper/jas_stream.h

commit 8ad974b534aa0bf494351629797fd7cbb8d31dfa
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 23 07:48:53 2022 -0800

    Added more information to the manual.

M	src/libjasper/include/jasper/jas_cm.h
M	src/libjasper/include/jasper/jas_init.h

commit 5fe57ac5829ec31396e7eaab59a688da014660af
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 22 13:46:37 2022 -0800

    Removed the export of all internal codec-driver entry points.
    Added more information to the manual.
    Updated the very badly out-of-date JAS_NOTES macro.
    Made many cosmetic changes to the source code.

M	src/libjasper/include/jasper/jas_cm.h
M	src/libjasper/include/jasper/jas_debug.h
M	src/libjasper/include/jasper/jas_icc.h
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_malloc.h
M	src/libjasper/include/jasper/jas_seq.h
M	src/libjasper/include/jasper/jas_stream.h
M	src/libjasper/include/jasper/jas_string.h
M	src/libjasper/include/jasper/jas_tmr.h
M	src/libjasper/include/jasper/jas_version.h

commit 45e97688b924ee0944ae5e7aeaa8b29941d122a0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 22 13:04:43 2022 -0800

    Replaced all explicit casts to void indicating a variable may
    be unused
    with an invocation of JAS_UNUSED.

    Added partial documentation for some functions related to color
    management.

M	src/app/jiv.c
M	src/libjasper/base/jas_cm.c
M	src/libjasper/base/jas_icc.c
M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_cm.h
M	src/libjasper/jp2/jp2_cod.c
M	src/libjasper/jpc/jpc_cs.c
M	src/libjasper/jpc/jpc_dec.c
M	src/libjasper/jpc/jpc_enc.c
M	src/libjasper/jpc/jpc_t1cod.c
M	src/libjasper/jpc/jpc_tagtree.c
M	src/libjasper/jpg/jpg_dec.c
M	src/libjasper/jpg/jpg_enc.c
M	src/libjasper/mif/mif_cod.c
M	src/libjasper/pgx/pgx_enc.c
M	src/libjasper/ras/ras_dec.c

commit 83c6ae005f7f377c55460b60975184363c9371d2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 22 12:22:51 2022 -0800

    Enabled the building of the tmrdemo program.

M	src/app/CMakeLists.txt
M	src/app/tmrdemo.c

commit b6659b0460070d6e47dfc8d03e65c5180d159094
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 22 11:59:59 2022 -0800

    Changed the build process for the JasPer applications so that the test
    programs multithread and test_1 are not installed.

M	src/app/CMakeLists.txt

commit 7a868e8b75ec1e43d7d45bb60939616e36e84f9e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 22 11:03:01 2022 -0800

    Added some missing function prototypes and commented out some
    unreachable code.

M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c

commit e9457f393f04fa22e3881a63cc99b3feb00ef6b3
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 22 10:53:04 2022 -0800

    Introduced a single consistently-named preprocessor define for gaining
    access to JasPer internals.

M	src/libjasper/base/jas_cm.c
M	src/libjasper/base/jas_debug.c
M	src/libjasper/base/jas_getopt.c
M	src/libjasper/base/jas_icc.c
M	src/libjasper/base/jas_iccdata.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/base/jas_seq.c
M	src/libjasper/base/jas_stream.c
M	src/libjasper/base/jas_string.c
M	src/libjasper/base/jas_tmr.c
M	src/libjasper/base/jas_tvp.c
M	src/libjasper/base/jas_version.c
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_malloc.h
M	src/libjasper/include/jasper/jas_thread.h
M	src/libjasper/jpc/jpc_cod.c

commit 21754de970b917ef1d87d3b2e09286abde619c93
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 22 09:13:28 2022 -0800

    Modified the make_main_gh_page script in order to better handle
    pre-releases.

M	build/github/make_main_gh_page

commit 47624a91f92eeb486e2693af2615e5aca30a08f7
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 22 09:12:45 2022 -0800

    Made some minor changes to the overview section of the manual.

M	doc/src/overview.dox.in

commit fc50c4f0dc5a6b718da73e3f636640c4578768b1
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 22 08:10:35 2022 -0800

    Made numerous improvements to the manual, including the addition of
    several figures.

M	doc/Doxyfile.in
A	doc/src/figures/comp.fig
A	doc/src/figures/make_figures
A	doc/src/figures/refgridex.fig
A	doc/src/figures/software.fig
A	doc/src/figures/srcimgmodel.fig
A	doc/src/figures_generated/comp.eps
A	doc/src/figures_generated/comp.png
A	doc/src/figures_generated/refgridex.eps
A	doc/src/figures_generated/refgridex.png
A	doc/src/figures_generated/software.eps
A	doc/src/figures_generated/software.png
A	doc/src/figures_generated/srcimgmodel.eps
A	doc/src/figures_generated/srcimgmodel.png
M	doc/src/lib.dox

commit e0dcf9c669e87c777db0a15b255f27d829682bf9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 22 01:22:40 2022 -0800

    Made some improvements to the string-processing section of the manual.

M	doc/src/lib_string.dox

commit 50dd614f4b6638516c76e45d2a5a2753f34a577a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 22 00:45:31 2022 -0800

    Added some extra sanity-checking to the code for library
    initialization and clean-up.
    Added more functionality to the test_1 program.
    Excluded the thread-related documentation from the manual.
    Fixed a typo in the manual.

M	doc/src/lib.dox
M	doc/src/lib_init.dox
M	doc/src/lib_misc.dox
M	doc/src/lib_threads.dox
M	doc/src/modules.dox
M	src/app/test_1.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_thread.h

commit 91fca092098396938830fe458f57109f0dd58a54
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jan 21 13:41:38 2022 -0800

    Changed the build process to fail if multithreading support is
    requested
    but cannot be provided (instead of simply generating a warning).

M	CMakeLists.txt

commit 9cfa1d79e6310fc8e91ed89cd5fdeca3380c357b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jan 21 12:07:00 2022 -0800

    Fixed a typo in the initialization section of the manual.

M	doc/src/lib_init.dox

commit 1801e0ff88e2f8c212f4c934b2734cccc31bb6f5
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Jan 19 10:51:17 2022 -0800

    Removed the use of jas_thread_yield in jas_call_once for the Windows
    platform in order to fix a dependency problem.

M	src/libjasper/include/jasper/jas_thread.h

commit 08c636ec9a1bbf1a4019e11e641143bd6d336e61
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Jan 19 08:13:32 2022 -0800

    Made the functions for manipulating threads hidden from normal library
    users, since they should not use these functions.

    Made more improvements to the manual.

M	doc/src/lib_images.dox
M	src/app/multithread.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_thread.h

commit 265de7ddd33f1f84b3c61dd43a749df777f7bf52
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Jan 18 12:59:16 2022 -0800

    Added some clarifying comments regarding library initialization to
    the manual.

M	doc/src/lib_init.dox

commit 8765c3f13c7e7b4733647ecfe0cc69587b6690f7
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Jan 18 00:13:30 2022 -0800

    Fixed some memory leaks on error paths in the JPC/JP2 encoder.

    Made a small fix to the manner in which programs are located in
    the run_mem_test script.

M	src/libjasper/jpc/jpc_enc.c
M	test/bin/run_mem_test

commit 441fcc6bd17fc0032271d2810b3cd0ef62740826
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jan 17 23:23:52 2022 -0800

    Made a few small improvements to the manual.
    Added encoder testing functionality to the run_mem_test script.

M	doc/src/apps_jasper.dox
M	doc/src/overview.dox.in
M	test/bin/run_mem_test

commit 9878adb805b9124704f07ccbee088a81c78667fb
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jan 17 19:09:04 2022 -0800

    Updated the manual-deployment workflow for GitHub Actions CI.

M	.github/workflows/deploy_manual.yml

commit 74f0d726e627a6d04813f7c7bcccf5e9a58ac56f
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jan 17 19:04:10 2022 -0800

    Made more improvements/corrections/updates to the manual.

M	INSTALL.txt
M	doc/src/bugs.dox
M	doc/src/install.dox.in
M	doc/src/intro.dox
M	doc/src/lib.dox
M	doc/src/overview.dox.in
M	doc/src/references.bib
D	doc/src/unused/software.dox

commit 191f135c7e98c33522a409417c110939df7fabe9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jan 17 15:04:28 2022 -0800

    Made more improvements to the manual.

M	doc/src/apps_imginfo.dox
M	doc/src/apps_jasper.dox
M	doc/src/lib.dox
D	doc/src/unused/library.dox
M	src/app/test_1.c

commit ecd3833bafe5e3fe34f77c310b719760674ea1d2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jan 17 13:35:15 2022 -0800

    Fixed some memory leaks on error paths in the code for image-format
    tables.

M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	test/bin/run_mem_test

commit 8a3fa3377edeb1fe1f2a260af68befa1d0d4150f
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jan 17 11:06:51 2022 -0800

    Changed the pattern specifying the tags for which the release workflow
    (for GitHub Actions) will be invoked so that the pattern is more
    restrictive (i.e., corresponds to normal, RC, alpha, and beta releases
    only).

M	.github/workflows/release.yml

commit d6b2f1d541c37b0d62c74991dc7534e287514720
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jan 17 10:39:54 2022 -0800

    Made some improvements/corrections to the initialization section of
    the manual.

M	doc/src/lib_init.dox

commit 6d4b777a334299eb90cccc3f9798ed0c487bbee5
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jan 17 09:46:44 2022 -0800

    Library:
    Fixed a serious bug in the memory allocation code (related to
    jas_realloc).
    Added the jas_string_tokenize function for splitting a string
    into tokens.
    Added the following image-related functions:
	jas_image_getfmtbyind
	jas_image_getnumfmts
	jas_image_setfmtenable
    Added support for the run-time enabling/disabling of codecs.
    Added the ability to store multiple file name extensions in each image
    format table entry.
    Made the table used to initialize the per-context image-format table
    private to the library.

    Applications:
    Changed the -l option of the jasper program to --list-enabled-formats.
    Added the --list-all-formats option to the jasper program.
    Added the --list-enabled-formats and --list-all-formats options to the
    imginfo program.
    Added the --enable-format option to the jasper and imginfo programs.
    Added the -- (i.e., end-of-options) option to the build script.
    Added the test_1 program for performing various simple tests.

    Revised the shared-library version information.

M	CMakeLists.txt
M	build/build
M	src/app/CMakeLists.txt
M	src/app/imgcmp.c
M	src/app/imginfo.c
M	src/app/jasper.c
M	src/app/jiv.c
M	src/app/multithread.c
C063	src/libjasper/base/jas_string.c src/app/test_1.c
M	src/app/tmrdemo.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/base/jas_string.c
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_string.h
M	src/libjasper/jpc/jpc_cs.c
M	test/bin/run_test_1
M	test/bin/run_test_2
M	test/bin/run_test_5
M	test/bin/run_test_imginfo

commit dfdb68e924f798b90661c41e0cc74fa3335725c6
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 15 17:38:14 2022 -0800

    Made more improvements to the JasPer documentation.

M	doc/Doxyfile.in
M	doc/src/lib.dox
M	doc/src/lib_images.dox
A	doc/src/lib_math.dox
A	doc/src/lib_string.dox
A	doc/src/lib_timers.dox
M	doc/src/modules.dox
M	src/libjasper/include/jasper/jas_getopt.h
M	src/libjasper/include/jasper/jas_tvp.h

commit 4472f88a58f985d01588c75621b54c34af3e4727
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 15 16:39:15 2022 -0800

    Made numerous improvements to the JasPer documentation.

M	doc/Doxyfile.in
M	doc/src/lib.dox
M	doc/src/lib_init.dox
M	doc/src/lib_iostreams.dox
M	doc/src/lib_log.dox
A	doc/src/lib_threads.dox
M	doc/src/modules.dox
M	doc/src/overview.dox.in
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_log.h
M	src/libjasper/include/jasper/jas_stream.h
M	src/libjasper/include/jasper/jas_thread.h

commit 579ec71d86d2d4fd0dd8ecf643c0499a372e37b1
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 15 11:43:01 2022 -0800

    Made many improvements to the JasPer documentation.

M	NEWS.txt
M	doc/Doxyfile.in
M	doc/src/apps.dox
M	doc/src/apps_imgcmp.dox
M	doc/src/apps_imginfo.dox
M	doc/src/apps_jasper.dox
M	doc/src/apps_jiv.dox
M	doc/src/lib.dox
M	doc/src/lib_images.dox
M	doc/src/lib_init.dox
R095	doc/src/lib_streams.dox doc/src/lib_iostreams.dox
M	doc/src/lib_log.dox
M	doc/src/modules.dox
M	doc/src/references.bib
M	src/app/imgcmp.1
M	src/app/imginfo.1
M	src/app/jasper.1
M	src/app/jiv.1
M	src/libjasper/include/jasper/jas_cm.h
M	src/libjasper/include/jasper/jas_fix.h
M	src/libjasper/include/jasper/jas_getopt.h
M	src/libjasper/include/jasper/jas_icc.h
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_log.h
M	src/libjasper/include/jasper/jas_malloc.h
M	src/libjasper/include/jasper/jas_seq.h
M	src/libjasper/include/jasper/jas_stream.h
M	src/libjasper/include/jasper/jas_string.h
M	src/libjasper/include/jasper/jas_thread.h
M	src/libjasper/include/jasper/jas_tmr.h
M	src/libjasper/include/jasper/jas_tvp.h

commit d7786ce48411d84b8c963ac54be5100eaa7b3bd0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 15 09:28:11 2022 -0800

    Fixed some integral-type issues for the jas_stream_gobble and
    jas_stream_pad functions.

M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_stream.h

commit 666e510f7014ad0f74339c69207ddfbbe26fcb7f
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 15 08:50:39 2022 -0800

    Renamed JAS_SSIZE_T to jas_ssize_t.

M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_stream.h
M	src/libjasper/include/jasper/jas_types.h

commit dc261868be17cc0c5b88f1b1d11ad83fcdb8afe5
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 15 08:39:13 2022 -0800

    Fixed some portability issues related to the use of ssize_t on the
    Windows platform.

M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_stream.h

commit 555139fbe6bfca7bab609f437443962d43924e08
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 15 08:26:24 2022 -0800

    Added more changes to fix integral-type issues (e.g., unsigned/int
    versus
    size_t/ssize_t) in the I/O streams code.

M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_stream.h

commit 5ad208975dd741d0e24e172cf85ff831202793b9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jan 10 15:15:50 2022 -0800

    Made minor changes to some of the code documentation.

M	src/libjasper/include/jasper/jas_init.h

commit 348c50d97086a350812f04566eb5e08895922d12
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 9 20:37:30 2022 -0800

    Restructured/reorganized the manual.

M	doc/CMakeLists.txt
M	doc/Doxyfile.in
A	doc/src/apps.dox
A	doc/src/apps_imgcmp.dox
A	doc/src/apps_imginfo.dox
R053	doc/src/applications.dox	doc/src/apps_jasper.dox
A	doc/src/apps_jiv.dox
M	doc/src/bugs.dox
D	doc/src/getting_started.dox.in
A	doc/src/install.dox.in
R084	doc/src/introduction.dox	doc/src/intro.dox
A	doc/src/lib.dox
A	doc/src/lib_images.dox
R066	doc/src/overview.dox	doc/src/lib_init.dox
A	doc/src/lib_log.dox
A	doc/src/lib_misc.dox
A	doc/src/lib_streams.dox
D	doc/src/license.dox
A	doc/src/license.dox.in
R078	doc/src/mainpage.dox.in doc/src/overview.dox.in
R100	doc/src/library.dox	doc/src/unused/library.dox
R100	doc/src/software.dox	doc/src/unused/software.dox

commit ddcab63ec314cbec78dd055b76f9ab2cdfd68c1f
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 9 12:33:16 2022 -0800

    Revised the part of the manual about library setup and shutdown.
    Renamed the function jas_conf_set_max_mem to
    jas_conf_set_max_mem_usage.

M	doc/src/overview.dox
M	src/app/imgcmp.c
M	src/app/imginfo.c
M	src/app/jasper.c
M	src/app/jiv.c
M	src/app/multithread.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_init.h

commit 8b713af9dc87736c138b8d3c8b4946b3c97b29ba
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 9 09:31:44 2022 -0800

    Renamed the appl directory to app.

M	.gitignore
M	CMakeLists.txt
M	build/travis/build
M	doc/src/software.dox
R100	src/appl/CMakeLists.txt src/app/CMakeLists.txt
R100	src/appl/fuzz.c src/app/fuzz.c
R100	src/appl/imgcmp.1	src/app/imgcmp.1
R100	src/appl/imgcmp.c	src/app/imgcmp.c
R100	src/appl/imginfo.1	src/app/imginfo.1
R100	src/appl/imginfo.c	src/app/imginfo.c
R100	src/appl/jasper.1	src/app/jasper.1
R100	src/appl/jasper.c	src/app/jasper.c
R100	src/appl/jiv.1	src/app/jiv.1
R100	src/appl/jiv.c	src/app/jiv.c
R100	src/appl/multithread.c	src/app/multithread.c
R100	src/appl/tmrdemo.c	src/app/tmrdemo.c
M	test/bin/jpcod
M	test/bin/jpdec
M	test/bin/jpenc
M	test/bin/run_codec_test
M	test/bin/run_mem_test
M	test/bin/run_test_1
M	test/bin/run_test_2
M	test/bin/run_test_4
M	test/bin/run_test_5
M	test/bin/run_test_imgcmp
M	test/bin/run_test_imginfo

commit 6a00cc4b5a90b36518ea2a98076b00ef452e14f6
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 9 09:05:03 2022 -0800

    Changed the JasPer library to track whether the memory limit
    configuration
    setting has been explicitly set.
    Changed the manner in which the JasPer memory limit is set in
    the various
    JasPer application programs.

M	doc/src/overview.dox
M	src/appl/imgcmp.c
M	src/appl/imginfo.c
M	src/appl/jasper.c
M	src/appl/jiv.c
M	src/appl/multithread.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_malloc.h

commit 55eb08b5dc12ed06a88a26414c9136fd5ee549ab
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 9 00:23:05 2022 -0800

    Fixed an incorrect file name reference in the manual.

M	doc/src/mainpage.dox.in

commit c7d20454af4fadb4de0f9e3ec7d965620f0d71ae
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 9 00:20:28 2022 -0800

    Fixed an incorrect file name in a script.

M	build/make_release

commit ac2017f9b741208b8c4f679ae245f5918889b097
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 9 00:12:50 2022 -0800

    Fixed a few problems related to file naming.
    Fixed a formatting error in the top-level README document.

M	CMakeLists.txt
M	README.md
M	test/bin/run_test_1

commit 688601c736165d424b95413ea40d5571a5ccfe02
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 9 00:02:54 2022 -0800

    Added extensions to numerous file names.
    Revised some documentation files.

M	CMakeLists.txt
R055	COPYRIGHT	COPYRIGHT.txt
R100	INSTALL INSTALL.txt
R100	LICENSE LICENSE.txt
R100	NEWS	NEWS.txt
D	README
A	README.md
R100	data/colorprofiles/README	data/colorprofiles/README.txt
R100	data/images/README	data/images/README.txt
R100	data/test/bad/README	data/test/bad/README.txt
R100	data/test/good/README	data/test/good/README.txt
R100	doc/README	doc/README.txt
M	doc/src/mainpage.dox.in
R100	src/README	src/README.txt
R100	src/libjasper/README	src/libjasper/README.txt
R100	src/libjasper/jpg/README	src/libjasper/jpg/README.txt
R100	src/libjasper/mif/README	src/libjasper/mif/README.txt

commit 34ddc0092fa3f7c89409109ab922309f31d4dff0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 8 23:44:36 2022 -0800

    Made further revisions to the codecs part of the manual.

M	doc/src/codecs.dox

commit 3ceba3ef93b69e1d04446ad8740d458845b29736
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 8 22:21:50 2022 -0800

    Fixed some of the formatting in the codecs part of the manual.

M	doc/src/codecs.dox

commit d9e8186d8987d778b88d3d2ff3d405aaee55d8db
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 8 20:50:52 2022 -0800

    Made the function jas_deprecated variadic and added the ability for
    this function to perform output formatting.
    Added some warning messages for the use of deprecated functionality.
    Added some checks related to the memory limit setting.

M	src/appl/multithread.c
M	src/libjasper/base/jas_debug.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/include/jasper/jas_debug.h

commit 3dcf7132700d85be842887fa9dfbf2fd493a70b9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 8 13:37:55 2022 -0800

    Merged some of the content from the old (i.e., circa 2006/2007)
    LaTeX-format JasPer manual into the Doxygen-based manual.  Started to
    convert the content from LaTeX to Doxygen format and update/revise the
    content in the process.

M	doc/Doxyfile.in
A	doc/src/applications.dox
A	doc/src/codecs.dox
A	doc/src/introduction.dox
A	doc/src/library.dox
A	doc/src/license.dox
A	doc/src/references.bib
A	doc/src/software.dox

commit 87f085486f326a562fcaf8c63fe1f18d0b38593a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 8 12:10:06 2022 -0800

    Fixed a typo in the multithread application (which resulted in
    the wrong
    function being called to deallocate memory in one place).

M	src/appl/multithread.c

commit 1aa4ced3bc449af080bc3497b8fe22a8d54feebb
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 8 11:16:33 2022 -0800

    Fixed a memory leak in the multithread application.

M	src/appl/multithread.c

commit 3708f3bb425287ea1f23a4b715480ee7c3906376
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jan 8 10:47:35 2022 -0800

    Enhanced the testing capabilities of the multithread application.
    Cleaned up some of the library initialization code.
    Added the detection of the nanosleep function to the build process.

M	CMakeLists.txt
M	src/appl/multithread.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_config.h.in
M	test/bin/run_test_5

commit d1348a41deada6cf531737a911e0f9508bb07d25
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jan 7 14:26:40 2022 -0800

    Changed the various JasPer application programs to allow the memory
    limit to be defaulted by the JasPer library.

M	src/appl/imgcmp.c
M	src/appl/imginfo.c
M	src/appl/jasper.c
M	src/appl/jiv.c
M	src/appl/multithread.c

commit f0bb008aec1af7a2d65ce40367b19e8ec6d16d11
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jan 7 13:52:29 2022 -0800

    Removed the ability of the library user to disable the allocator
    wrapper.
    Changed the maximum memory limit so that it defaults to half of
    the available system memory if not explicitly set during run-time
    configuration.

    Added a --no-test to the build script.
    Added an option to the build_all script for disabling testing.

M	build/build
M	build/build_all
M	src/appl/multithread.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_init.h

commit e0b3607a4b86df093952b48479c0aeb8d02861ef
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jan 7 13:00:17 2022 -0800

    Fix a compiler warning generated by MSVC.

M	src/libjasper/include/jasper/jas_thread.h

commit cbc4e85dc62ce84e0035996fe4184da847fca5c0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jan 7 12:41:35 2022 -0800

    Reorganized the jas_thread.h header in an attempt to facilitate better
    cross-platform portability.
    Added a --no-prefer-pthread option to the build script.

M	CMakeLists.txt
M	build/build
M	src/libjasper/include/jasper/jas_thread.h

commit d034fc5af560ea175823df8f22359efaf683a646
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jan 7 11:11:27 2022 -0800

    Reworked the multithreading support.

    Purged support for the optional automatic invoking of jas_cleanup
    via atexit.

    Changed the CMake build process to prefer the use of the POSIX Threads
    Library.  This will help to reduce the likelihood of some problems
    caused by C11 threading support not interacting well with TSan.

    Added --no-lsan and --no-asan options to the build script.	Also,
    fixed
    a typo in a directory name in the same script.

M	CMakeLists.txt
M	build/build
M	build/build_all
M	src/appl/imgcmp.c
M	src/appl/imginfo.c
M	src/appl/jasper.c
M	src/appl/jiv.c
M	src/appl/multithread.c
M	src/libjasper/base/jas_debug.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/bmp/bmp_dec.c
M	src/libjasper/heic/heic_dec.c
M	src/libjasper/include/jasper/jas_debug.h
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_log.h
M	src/libjasper/include/jasper/jas_thread.h
M	src/libjasper/jpc/jpc_dec.c
M	src/libjasper/jpg/jpg_dec.c
M	src/libjasper/pgx/pgx_dec.c
M	src/libjasper/pnm/pnm_dec.c
M	src/libjasper/ras/ras_dec.c

commit 8d6ee5fece1ac7abdeb00a1a60cb2b9d23baf2e1
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Jan 5 15:17:17 2022 -0800

    Made many cosmetic formatting changes to the code (e.g., adding braces
    around many single-statement if/for/while bodies).
    Added some missing checks for I/O failure in the functions
    jas_iccputtime
    and jas_iccputxyz.
    Replaced some explicit casts to void with invocations of JAS_UNUSED.
    Added the generation of some warning messages.

M	doc/src/modules.dox
M	src/libjasper/base/jas_cm.c
M	src/libjasper/base/jas_getopt.c
M	src/libjasper/base/jas_icc.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/base/jas_seq.c
M	src/libjasper/base/jas_stream.c
M	src/libjasper/base/jas_tmr.c
M	src/libjasper/include/jasper/jas_getopt.h
M	src/libjasper/include/jasper/jas_string.h
M	src/libjasper/include/jasper/jas_tvp.h

commit e4a76ec792ac8bdda8d42b5a241c8aee13dc26e6
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Jan 4 01:27:11 2022 -0800

    Made some changes in an attempt to fix some portability problems
    (impacting Windows and MacOS).

M	src/libjasper/base/jas_malloc.c

commit 74a6419dd054d503aa25d53860dfa0b8ee843980
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Jan 4 01:20:13 2022 -0800

    Added the jas_get_total_mem_size function for querying the total
    amount
    of memory available.

M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/include/jasper/jas_malloc.h

commit baa1fdbe2102080a515671b35bae1db49050d560
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Dec 27 10:04:36 2021 -0800

    Fixed a memory leak in the CM code.
    Fixed a memory leak in the JPEG decoder.

M	src/libjasper/base/jas_cm.c
M	src/libjasper/jpg/jpg_dec.c

commit f8293fe9d6e26db44eecd9ffbd219624a9d1b6c2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Dec 27 08:52:32 2021 -0800

    Fixed a memory leak in the CM/ICC code.

M	src/libjasper/base/jas_cm.c
M	src/libjasper/base/jas_icc.c
M	test/bin/run_mem_test

commit 7fc0d9adacd72d568e6a6013bb810d7a1a0abc29
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Dec 26 23:54:13 2021 -0800

    Updated the NEWS document.

M	NEWS

commit a2e9448ef0f2415adc46a2052ada7faa2e48a844
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Dec 26 21:08:52 2021 -0800

    Fixes #314.

    Reworked some of the internal interfaces for computing wavelet
    transforms
    in the JPC/JP2 codec in order to eliminate the need for some abort
    calls.

M	src/libjasper/base/jas_image.c
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/jpc/jpc_qmfb.c

commit 28c7a64ece3dab5477ead4972435f69de5659fb7
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Dec 24 10:13:43 2021 -0800

    Fixed a bug in the realloc-related code.
    Fixed some bugs in the JPC/JP2 decoder on error paths in the code that
    are hit due to failed memory allocations.

M	src/libjasper/base/jas_malloc.c
M	src/libjasper/jpc/jpc_dec.c
A	test/bin/run_mem_test

commit 73f7dbd440f42c5f6dda2048c3a866c3bd2fa34a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Dec 23 08:56:17 2021 -0800

    Fixes #312.

    The test suite will fail miserably if support for any of the native
    codecs is not included.  To make this clear, the test suite has been
    disabled in the case that support for one or more native codecs is
    missing.

M	CMakeLists.txt
M	src/appl/CMakeLists.txt

commit 2019dcff7b869ba05e1b35fd9cebdd2b94740e17
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Dec 23 00:12:33 2021 -0800

    Cleaned up the prebuild-v2 script.

M	build/github/prebuild-v2

commit d82b63fa7e8fbc4faf5f6c73f35f9d70597294d0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Dec 22 22:18:46 2021 -0800

    Made more changes to the GitHub CI workflow.

M	.github/workflows/ci.yml

commit 2def05f127c0c723ca677fb615430b35c5f2b423
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Dec 22 22:11:56 2021 -0800

    Made more changes to the GitHub CI workflow.

M	build/github/prebuild-v2

commit 64930eeedd9a2a66f1c8c2bc905601db2275ad10
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Dec 22 21:55:02 2021 -0800

    Changed the prebuild-v2 script to try to workaround an apparent bug in
    the GitHub CI runner for Windows.

M	build/github/prebuild-v2

commit f615159e19323b341890eaabaffb6d40b2690187
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Dec 22 21:50:06 2021 -0800

    Changed the prebuild-v2 script to try to workaround an apparent bug in
    the touch command for the GitHub CI runner for Windows.

M	build/github/prebuild-v2

commit 3aece33c21cbc8daa216d109bce1781c68f6710d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Dec 22 21:46:38 2021 -0800

    Fixed a bug in the prebuild-v2 script.

M	build/github/prebuild-v2

commit e9ecb1d9790dc10a90b066afaaf6710c865a8fa9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Dec 22 21:37:23 2021 -0800

    Made some changes to try to fix some problems in the GitHub CI
    workflow
    for MacOS.

M	.github/workflows/ci.yml
M	build/build_all
A	build/github/prebuild-v2

commit 6fc422632a6ff71358bc3cb1f5c27cf81c343261
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Dec 22 20:06:50 2021 -0800

    Fixed a typo in one of the CMakeLists.txt files.

M	src/libjasper/CMakeLists.txt

commit d83be32a6f6100ca557b67c3ef040870aef14f7d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Dec 22 19:55:12 2021 -0800

    Fixed a few typos in one of the CMakeLists.txt files.

M	src/appl/CMakeLists.txt

commit 325bf70fd799da78822fd5154abc4d8708baaec1
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Dec 22 19:42:43 2021 -0800

    Changed the CMake build process to use an imported target for the
    LIBJPEG library.

M	CMakeLists.txt
M	src/appl/CMakeLists.txt

commit b88f34be1f65145bc5a26daa26e17279f77303d8
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Dec 22 12:30:08 2021 -0800

    Fixed more build problems.

M	CMakeLists.txt

commit 4254473ee2f7b1a324645a58d06df412d5ffd95c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Dec 22 11:52:37 2021 -0800

    Made some build changes in an attempt to address some GLUT-related
    issues on MacOS.

M	CMakeLists.txt
M	src/appl/jiv.c
M	src/libjasper/include/jasper/jas_config.h.in

commit a7f1b7e512d8d75a2b4d41f66cbaa0dde80efebf
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Dec 22 11:37:35 2021 -0800

    Changed the CMake build process to consider the include directories
    for OpenGL-related libraries when testing for the existence of the
    glut.h header.

M	CMakeLists.txt
A	build/cmake/modules/JasGetIncludes.cmake

commit 3c4fa79cf44aae0df3dc52f4dd18253ccbcc59cc
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Dec 22 09:35:45 2021 -0800

    Changed the CMake build files to use imported targets for the
    OpenGL-related libraries.  This change was partly motivated by
    the need
    to fix build problems on some Linux variants.

M	CMakeLists.txt
M	src/appl/CMakeLists.txt

commit 836a79c39cc467e9a45981c1dc9caf114bdb1e20
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Dec 7 13:53:36 2021 -0800

    Added a new test case involving bad JPC-coded data.

A	data/test/bad/309.jpc

commit def496882ab8af3e13f38102bebd195a7dd9db61
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Dec 7 13:47:47 2021 -0800

    Fixes #309.

    Added several functions to facilitate overflow checking when
    performing
    integer arithmetic.
    Fixed an integer-overflow bug in the JPC decoder that could result in
    division by zero.

M	CMakeLists.txt
M	build/build
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_math.h
M	src/libjasper/include/jasper/jas_types.h
M	src/libjasper/jpc/jpc_t2cod.c
M	src/libjasper/jpc/jpc_t2dec.c

commit 99a06a65a55717c53ae93319fa8c465027fee30d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Dec 5 06:05:37 2021 -0800

    Fixed a typo in the manual.

M	doc/src/overview.dox

commit 4c002707d725fe42a7779e8276a6eb43feebf5e5
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 29 19:13:58 2021 -0800

    Removed some comments from the top-level CMakeLists.txt file.

M	CMakeLists.txt

commit 938587cbe4d71c49f582232473fab786b524bc7d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 29 16:18:07 2021 -0800

    Remove the /Wv:18 option from the MSVC compiler.

M	CMakeLists.txt

commit e99f43c7c36405a5024a41aa7ed16c66c3f75c45
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 29 15:41:46 2021 -0800

    Added a missing type cast to the argument passed in various
    invocations
    of isspace, isdigit, and isalpha (to ensure that the argument is not
    out of range).

M	src/libjasper/base/jas_icc.c
M	src/libjasper/pgx/pgx_dec.c
M	src/libjasper/pnm/pnm_dec.c

commit 1b62bfdfb02b0f8a15f43a974693e7e60b91967e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 29 15:13:22 2021 -0800

    Added some missing type casts in the tag-value parser code.
    Marked some types of image-related files as binary in the
    .gitattributes file.

M	.gitattributes
M	src/libjasper/base/jas_tvp.c

commit 97de1dda36df600db747d8b27d4092e45423bf7b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 29 13:41:32 2021 -0800

    Fixed a typo in the code for the MIF codec.

M	src/libjasper/mif/mif_cod.c

commit aa23f4e6619a13528fb871b1aa9b945184d3aef3
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 29 13:38:27 2021 -0800

    Added more informational log messages to the MIF codec.

M	src/libjasper/mif/mif_cod.c

commit 12045d39725d715805ce4cc6116227f3011cc3d4
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 29 12:42:47 2021 -0800

    Added more informational log messages to the MIF codec.

M	src/libjasper/mif/mif_cod.c

commit c0ff348e5f6c9d4e5f1e32822c967a1e66a396a3
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 29 11:29:57 2021 -0800

    Disable the use of ASan with MSVC on Windows, since this is causing
    dynamic linking errors.

M	build/build_all

commit f7281623f966aeb7476241469e2ff7ca39ccbcc5
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 29 11:05:56 2021 -0800

    Added the /wd4267 option to the MSVC compiler to eliminate some
    bogus compiler warnings.

M	CMakeLists.txt

commit c3988d79adb257d08e0e17eeb1d3a2dd12f8c2d7
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 29 10:58:23 2021 -0800

    Change Windows CI from using windows-2019 to windows-2022 runner.

M	.github/workflows/ci.yml
M	.github/workflows/win_ci.yml

commit 0fe57f14162f20df2709678c38a2df4e95c80c28
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 29 10:36:04 2021 -0800

    Add the /Wv:18 option to the MSVC compiler to avoid warnings that
    appear to be generated by code in some MSVC headers.

M	CMakeLists.txt

commit 1904d33884f18cf8f889d107989e8eaaf0cbd7fe
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 29 09:33:55 2021 -0800

    Change Windows CI from using windows-2016 to windows-2019 runner.

M	.github/workflows/ci.yml
M	.github/workflows/win_ci.yml

commit ff44cb5ce937b8069cb5bcf62495ed7e7dae4600
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 29 08:44:30 2021 -0800

    Added some error logging messages to the MIF codec.
    Added some debug code to the run_test_1 script.

M	src/libjasper/mif/mif_cod.c
M	test/bin/run_test_1

commit c7a6ee5e7f9834d25acdde1609e9e2cf542ebb7f
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 29 07:35:26 2021 -0800

    Changed the run_test_imginfo script to make its output less verbose.

M	test/bin/run_test_imginfo

commit c4d41e847a87b60ea220255714872a64c5f100f2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Nov 28 19:31:20 2021 -0800

    Marked several types of image files as binary in the .gitattributes
    file.

M	.gitattributes

commit b6445e3e8956fe745e7ee8c63be90639b0767e1a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Nov 28 19:19:29 2021 -0800

    Added some log messages to the MIF codec.

M	src/libjasper/mif/mif_cod.c

commit b72bb6bed5c5989bd2d586fa9ac9b64af12eb16e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Nov 28 18:54:25 2021 -0800

    Fixed a bug in a call to a logging function in the Sun Rasterfile
    decoder.

M	src/libjasper/ras/ras_dec.c

commit 1b40d74c9f9f6f64e331edb714227848a117ca27
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Nov 28 18:35:59 2021 -0800

    Added more error logging to the MIF codec.
    Added more error logging capabilities to the run_test_imginfo script.

M	src/libjasper/mif/mif_cod.c
M	test/bin/run_test_imginfo

commit a42397d60253efcf585dcf726111c648e1e87882
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Nov 28 12:47:56 2021 -0800

    Added another invalid image to the test set.

A	data/test/bad/307_empty_iccp.jp2

commit e9c8372f96e547ea35fbca1c7106baf15b6818cd
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Nov 28 12:04:59 2021 -0800

    Fixes #307.

    Fixed a bug in the JP2 decoder that caused a crash if the ICC
    profile data in a COLR box had zero length.

M	src/libjasper/base/jas_icc.c
M	src/libjasper/jp2/jp2_cod.c

commit 0de4e3fe43762049e1b5f4c36a18ef5b35521a70
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Nov 28 01:11:39 2021 -0800

    Added a sanity check on the build type to the build script.

M	build/build

commit 4bfd64d639a22121bd6b9977fd9d8a351b8084b9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Nov 28 01:03:28 2021 -0800

    Fixed a typo in the build script.

M	build/build

commit 7166be4f2452caf182ce30922fc964b6a5f82bd0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Nov 28 00:18:07 2021 -0800

    Improved the documentation of the build script.

M	build/build

commit 3acb67277d36ac91965dcff97c44a54035942727
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Nov 23 11:29:21 2021 -0800

    Added an assertion to jas_get_mb to ensure that the parameter to the
    function is not a null pointer.

M	src/libjasper/base/jas_malloc.c

commit 4a553437edad922616c8eeb97f4d73fd70cb1bbd
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Nov 23 10:03:00 2021 -0800

    Added a dependency on the threading libraries when building the JasPer
    library.

M	src/libjasper/CMakeLists.txt

commit 5175dcd845c385ac16c55a8de5c25e3d49bd075e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Oct 12 09:09:58 2021 -0700

    Added the generation of some extra error logging messages in the
    JP2 and CM code.

M	src/libjasper/base/jas_cm.c
M	src/libjasper/jp2/jp2_dec.c

commit 48c7b04ee268c478a3bea0e12282a4eac4b498f3
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Oct 12 08:58:34 2021 -0700

    Added checks for invalid command-line options/arguments in the
    build_all
    script.

M	build/build
M	build/build_all

commit 083ca1578b1ec526e38153b3b113fe5d8823d229
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Oct 10 20:41:36 2021 -0700

    Fixed a typo in the top-level CMakeLists.txt file.

M	CMakeLists.txt

commit c6c61c2d9d3d404eb3203f911e09e49caa833f52
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Oct 10 20:36:41 2021 -0700

    Fixed a bug in the build process that is encountered when the libheif
    library is not available.

M	CMakeLists.txt

commit 7e8c6f9ef15496cc720134eda8a7bf7217120162
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Oct 10 20:30:26 2021 -0700

    Added partial decoding support for the HEIC format.
    Fixed a bug in the jasper program, where the JasPer library was being
    used before being initialized.
    Added some assertions to check for out-of-bound indexing in
    jas_matrix_get and jas_matrix_set.

M	CMakeLists.txt
M	NEWS
M	src/appl/CMakeLists.txt
M	src/appl/jasper.c
M	src/appl/jiv.c
M	src/libjasper/CMakeLists.txt
M	src/libjasper/base/jas_init.c
A	src/libjasper/heic/heic_dec.c
A	src/libjasper/heic/heic_enc.c
A	src/libjasper/heic/heic_val.c
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_seq.h

commit 68506c06e59bc1efbaf84dcbf568c8eaf4d88e1b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Oct 2 12:00:46 2021 -0700

    Enabled the full test suite for CI builds on the Windows platform.
    (Previously, the full test suite was only enabled for CI builds on
    Unix-based platforms.)
    Added a new script called run_test_imgcmp for testing the imgcmp
    program.
    Added a new script called run_test_imginfo for testing the imginfo
    program.
    Added a new test image.
    Updated the NEWS document.

    jasper program:
    Fixed an uninitialized variable bug in the jasper program.

    imgcmp program:
    Changed the exit-status conventions for the imgcmp program in order to
    allow the case of an unequal comparison result to be distinguished
    from
    the case of failure due to an error.

    build_all script:
    Changed the build_all script to output information about mounted
    file systems.
    Improved some of the informational messages generated by the build_all
    script.

    run_test_1 script:
    Removed the use of ASan in the run_test_1 script.
    Changed the run_test_1 script to skip test cases that use image
    formats
    that are not supported.
    Changed the run_test_1 script to print more detailed information about
    failed test cases.

    run_test_2 script:
    Changed the run_test_2 script to skip test cases that use input images
    whose format is unsupported.
    Made the run_test_2 script more gracefully handle image-comparison
    failures.
    Changed the run_test_2 script to output more detailed information
    about
    failed test cases.

M	NEWS
M	build/build_all
A	data/images/feed.pnm
M	src/appl/CMakeLists.txt
M	src/appl/imgcmp.c
M	src/appl/jasper.c
M	test/bin/run_test_1
M	test/bin/run_test_2
A	test/bin/run_test_imgcmp
A	test/bin/run_test_imginfo

commit 78672346aa80ff1b26a7ad6479daa47055c23ba4
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Sep 30 14:55:59 2021 -0700

    Made some improvements to the documentation/manual and updated the
    NEWS document.

M	NEWS
M	doc/src/mainpage.dox.in
M	src/libjasper/include/jasper/jas_init.h

commit 0014d72836f1398a31c9334dee8baddf32da98e3
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Sep 30 14:30:53 2021 -0700

    Changed SSIZE_MAX to JAS_SSIZE_MAX in the JP2 codec, for better
    portabilty.

M	src/libjasper/jp2/jp2_cod.c

commit fb894064f29793dd1f5c1b42bc99f7d28c3d9473
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Sep 30 13:02:36 2021 -0700

    Made the use of ssize_t more portable.

M	CMakeLists.txt
M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_stream.h
M	src/libjasper/include/jasper/jas_types.h

commit e8d9cb8620508a6c3a5e5c20cf380d14831ef132
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Sep 30 11:27:24 2021 -0700

    Fixed a number of longstanding problems with the integral types
    used in
    the API for the following JasPer I/O stream functions:
	- jas_stream_memopen
	- jas_stream_read
	- jas_stream_write
	- jas_stream_copy
    Marked jas_stream_memopen2 as deprecated.
    Made numerous cosmetic changes to the code.

M	src/appl/fuzz.c
M	src/libjasper/base/jas_icc.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_stream.h
M	src/libjasper/jp2/jp2_cod.c
M	src/libjasper/jpc/jpc_enc.c

commit eab65d820eb3dcab32a7e595c985771e072ad008
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Sep 27 22:12:06 2021 -0700

    Fixed a typo in the manual.

M	doc/src/bugs.dox

commit a21a00eb7fcf5a871ee83fa30589da1587b8afcf
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Sep 20 11:41:12 2021 -0700

    Changed the jas_init function so that it no longer registers
    jas_cleanup
    as an atexit handler.
    Added a note about API changes to the NEWS document as well as the
    manual.
    Started to add some help information to the build script.

M	NEWS
M	build/build
M	build/build_all
M	doc/src/mainpage.dox.in
M	src/appl/imgcmp.c
M	src/appl/imginfo.c
M	src/appl/jasper.c
M	src/appl/jiv.c
M	src/appl/multithread.c
M	src/libjasper/base/jas_init.c

commit 9456f3a60ffd618ce5abb155aba7895cc54a9e0e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Sep 12 15:16:08 2021 -0700

    Fixed numerous references to JAS_DEFAULT_MAX_MEM_USAGE.

M	INSTALL
M	src/appl/imgcmp.c
M	src/appl/jasper.c
M	src/appl/jiv.c

commit 6d0c47f10c494e1fbecafcb415bcff228369e485
Merge: 01d16de 9afb0d6
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Sep 12 14:14:50 2021 -0700

    Merge pull request #301 from theta682-tl/cmake-update

	Make CMake code style similar to standard CMake.
	Improve multi-configuration support: Add "d" suffix for Debug
	configuration.
	Improve detection of snprintf on Windows.
	Use BUILD_SHARED_LIBS to declare JAS_ENABLE_SHARED if it is
	defined.
	Reduce warning about GLUT on Windows.

commit 9afb0d6c1e7b6fbb4f6c973e8e3ebcb034ca7186
Author: Timothy Lyanguzov <timothy.lyanguzov@sap.com>
Date:	Wed Sep 8 20:38:15 2021 +1200

    Use BUILD_SHARED_LIBS for enabling SHARED

M	CMakeLists.txt

commit 0f020fd73bb8fa74a1a5557c4280ff5722d94d62
Author: Timothy Lyanguzov <timothy.lyanguzov@sap.com>
Date:	Wed Sep 8 20:28:24 2021 +1200

    Update CMake scripts

M	CMakeLists.txt
M	build/cmake/modules/EnableAssertions.cmake
M	build/cmake/modules/InSourceBuild.cmake
M	build/cmake/modules/Sanitizers.cmake
M	doc/CMakeLists.txt
M	src/appl/CMakeLists.txt
M	src/libjasper/CMakeLists.txt
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_types.h

commit 01d16de0a87993426b44012d4d83d0fbdbdf9244
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Sep 7 14:06:50 2021 -0700

    Added a missing mention of CVE-2021-27845 in the NEWS file.

M	NEWS

commit 614b8177cfd6631c96e510bb1e15d91f3fdcb94b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 26 17:34:29 2021 -0700

    Corrected a typo in the top-level CMakeLists.txt file.

M	CMakeLists.txt

commit 5717d44546e95c15eb6e91b085c2de95d28955e4
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 26 16:34:26 2021 -0700

    Made some code changes to reduce the number of compiler warnings.

M	CMakeLists.txt
M	build/build_all
M	src/libjasper/include/jasper/jas_compiler.h
M	src/libjasper/jp2/jp2_enc.c
M	src/libjasper/jpc/jpc_t1cod.c

commit 5c799d5456065637467c13ce6d6b74b29d410633
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 26 15:57:59 2021 -0700

    Added a compiler option to the build process to silence warnings about
    OpenGL being deprecated on MacOS.

M	CMakeLists.txt

commit 15a6a6f80ed8b9918bae2608031c07e286e522d4
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 26 15:50:03 2021 -0700

    Fixed two cases in which a variable might potentially be used
    uninitialized.
    Added an annotation to avoid a warning about a potentially unused
    variable.

M	CMakeLists.txt
M	src/appl/imginfo.c
M	src/libjasper/base/jas_malloc.c

commit 6ed489e31d446496296be6ec2fb6c17446456c44
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 26 15:31:28 2021 -0700

    Added a missing return statement to jas_call_once.

M	src/libjasper/include/jasper/jas_thread.h

commit b5040bcc5e39ae86415469dafe7011ec71a687d9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 26 15:19:44 2021 -0700

    Removed some redundant message commands from the top-level
    CMakeLists.txt file.

M	CMakeLists.txt

commit a16604ba34448d5ad7089834c264dd139fb9763a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 26 15:15:52 2021 -0700

    Fixed a typo in the top-level CMakeLists.txt file.

M	CMakeLists.txt

commit adc52870ceaa7a1b0c53b6c44ebb2c36671f7bb9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 26 15:07:08 2021 -0700

    Added the printing of more informational messages during the build
    process.

M	CMakeLists.txt

commit 1f3e803fa02c17a29db2df182c09eda512a5b743
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 26 14:57:52 2021 -0700

    Made a few minor changes to some of the messages generating during the
    build process.

M	CMakeLists.txt
M	build/build

commit bf85f9142743aae21039a249e27eff84dffd2d05
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 26 14:38:10 2021 -0700

    Added the printing of the CMAKE_C_COMPILER_ID variable during
    the build
    process.

M	CMakeLists.txt

commit 3210498d7cbc0ca8533fa85d2e103ccebf675658
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 26 14:21:51 2021 -0700

    Fixed some compiler warnings.

M	CMakeLists.txt
M	build/build
M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_compiler.h

commit 17af3153b301dcf7cd9f32050cb0fb404d9fe495
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 26 10:16:35 2021 -0700

    Attempted to improve the portability of the method used to build a
    shared library.

M	CMakeLists.txt

commit 44c43dbaba4edb9053a05aca432dc3fe1e88d288
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 26 09:45:25 2021 -0700

    Changed max_align_t to jas_max_align_t in several places in order to
    avoid compilation failures on some platforms.

M	src/libjasper/base/jas_malloc.c

commit a5982942adfb6039cc0aeec1929041fbb7596155
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 26 09:25:40 2021 -0700

    Added a more robust method for testing for the existence of
    max_align_t.
    Added a build configuration to the build_all script that uses jas_init
    for library initialization.
    Fixed an incorrect condition for an assertion in jas_init, which
    caused
    correct usage of jas_init to fail.
    Added more content to the manual.

M	CMakeLists.txt
M	build/build
M	build/build_all
M	doc/src/mainpage.dox.in
M	doc/src/overview.dox
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_cm.h
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_icc.h
M	src/libjasper/include/jasper/jas_types.h

commit acbb705a4d652e7028b8d15aefa4584b8078d863
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Aug 25 23:13:14 2021 -0700

    Added some assertions that check for the correct order of library
    configuration, initialization, and cleanup.

M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_init.h

commit 60d6a9d7927e5aebef236543c8e124f5412a7bc1
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Aug 25 13:52:41 2021 -0700

    Fixed some typos that caused the build process to fail on Windows.

M	CMakeLists.txt
M	src/libjasper/include/jasper/jas_thread.h

commit 27c604ea0e0ce2926e21640fadbdf4ef50dfe038
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Aug 25 13:33:37 2021 -0700

    Made some improvements to the manner in which the threading support
    library is chosen when threading support is enabled.
    Also, the choice of whether threading support is enabled is now
    captured
    in the generated configuration header for the library so that
    library users
    have an easy way of determining whether threading support is
    available.

M	CMakeLists.txt
A	build/cmake/modules/EnableAssertions.cmake
M	doc/Doxyfile.in
M	src/appl/CMakeLists.txt
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_malloc.h
M	src/libjasper/include/jasper/jas_thread.h
M	src/libjasper/jpc/jpc_cod.c

commit e5397f7b24221801aa3683c58ff137e4c7faa424
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Aug 25 00:49:35 2021 -0700

    Enabled the testing of Windows shared library builds.

M	build/build
M	build/build_all

commit c713d5c1883cbafe7faabefd49531d5e4e572023
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Aug 25 00:16:14 2021 -0700

    Fixed a typo in the Sanitizers CMake module.

M	build/cmake/modules/Sanitizers.cmake

commit d51be3e91295f3ac8edb08f5c11427e98a2b260a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Aug 25 00:11:41 2021 -0700

    Added support for ASan on Windows in the Sanitizers CMake module.

M	build/cmake/modules/Sanitizers.cmake

commit d9c803b4982e980cb9651cab4fb5b8b943c0f0dc
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 23:12:13 2021 -0700

    Reduced the verbosity of the GitHub Actions CI workflow.

M	.github/workflows/ci.yml

commit f90d11b701100dea77b80e2da5164e4319720ddd
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 23:02:20 2021 -0700

    Disabled the execution of some test scripts in the case of a
    Windows build
    (as the scripts in question do not work correctly under Windows).

M	build/build_all
M	src/appl/CMakeLists.txt

commit 72357f58f5969769ebdd43f0c3b9d4d13753cf4e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 19:44:12 2021 -0700

    Removed an output direction from the image_info shell function.

M	test/bin/utilities

commit 44cf8042f5900900002a94af4cafbdb6e6e499d7
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 19:37:55 2021 -0700

    Changed the build_all script to print the contents of the build and
    install directories for debugging purposes.
    Performed some minor code cleanup on the imginfo and jasper programs.

M	build/build
M	build/build_all
M	src/appl/imginfo.c
M	src/appl/jasper.c

commit 1ce7e514bef90f7a7b870e31aeca1563f8521381
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 18:58:32 2021 -0700

    Replaced some calls to the exit function with a return statement
    in the
    main function of the imginfo program (for consistency).
    Added a check for the Clang and GCC compilers in the Sanitizer module.
    Added improved error checking to the image_info shell function used by
    various scripts.

M	build/cmake/modules/Sanitizers.cmake
M	src/appl/imginfo.c
M	test/bin/utilities

commit 625e463665c02e8e40275ddccea5526a2c7a8026
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 17:55:05 2021 -0700

    Added some extra debugging output to the build process.

M	test/bin/jpcod
M	test/bin/jpdec
M	test/bin/jpenc

commit 10d1c7efc9fd5be0d23e66af75ded031cbb858d8
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 17:43:36 2021 -0700

    Added some extra debugging output to the build process.

M	test/bin/utilities

commit b350e1ad1343fb9465e2c391b733177095f8548f
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 17:24:13 2021 -0700

    Added the generation of some extra debugging output to the GitHub
    Actions
    CI workflow.

M	.github/workflows/ci.yml
M	build/build
M	build/build_all
M	test/bin/run_codec_test
M	test/bin/run_test_1
M	test/bin/run_test_2
M	test/bin/run_test_3
M	test/bin/run_test_4
M	test/bin/run_test_5

commit 62aa113ed1fef869bb8e3f9d8943d3b129c2941d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 16:38:00 2021 -0700

    Changed the image search path in various scripts to use semicolons
    (instead of colons) to delimit entries, since Windows may use
    colons in
    path names.

M	test/bin/jpcod
M	test/bin/run_codec_test
M	test/bin/utilities

commit 9303ae4024c8c25edda713f874bb0ffbd2c13f31
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 16:17:11 2021 -0700

    Increased the verbosity level of the GitHub Actions CI workflow.

M	.github/workflows/ci.yml
M	.github/workflows/win_ci.yml
M	build/build
M	build/build_all

commit 88a90340509aa6112e657a2bd5586ddeee2e78a8
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 14:22:15 2021 -0700

    Added support for partial testing of JasPer under Windows in the
    GitHub
    Actions CI workflow.

M	.github/workflows/ci.yml
M	build/build_all

commit ec9e3a101b15befc342664f7aec3b6b7684dee1b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 13:39:22 2021 -0700

    Made some changes that move towards being able to run the GitHub
    Actions
    CI workflow on a Windows runner.

M	.github/workflows/win_ci.yml
M	src/appl/CMakeLists.txt

commit 42952746ba07d22f9f765c468e69281aa46661d8
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 13:25:17 2021 -0700

    Added a CLI option to the jasper program to list the supported codecs.
    Modified the run_test_5 script to use this option to detect the
    absence
    of JPEG codec support.

M	src/appl/jasper.c
M	test/bin/run_test_5

commit acc951d77c80fd5166e18c256c581f16f246670e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 12:29:25 2021 -0700

    Fixed a portability bug in the multithread program (related to
    binary versus text mode).

M	src/appl/multithread.c

commit 7fa551358aa935a24d74b85d5160f7a8069544a8
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 12:18:49 2021 -0700

    Fixed a portability bug in the multithread program (related to
    the name
    of the null device).

M	src/appl/multithread.c

commit 295fd45db7e7d04893932efe9d490bf71591686b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 12:04:28 2021 -0700

    Cleaned up the code for jas_tss_create in the Windows case.

M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_thread.h

commit d6210ef2c1bf101fbb4c46f618985aaffec24cfc
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 11:46:52 2021 -0700

    Added the printing of an error message when library initialization
    fails.
    Added a missing null-pointer check in the library initialization code.

M	src/libjasper/base/jas_init.c

commit ede3dffdfbd53991eb240a55ad9c5ea6a0fbc4d4
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 10:51:56 2021 -0700

    Added the printing of some informational messages in the top-level
    CMakeLists.txt.

M	CMakeLists.txt
M	build/build

commit 12a75e0451eceba4de7e936b9467d24b95205112
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 10:32:23 2021 -0700

    Added special handling of Windows builds in the build script.

M	build/build

commit d2ce89e79982bd96469a77ad5d689e899b6184b9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 10:18:43 2021 -0700

    Added a --debug-level option to the CLI for the build script.

M	.github/workflows/win_ci.yml
M	build/build

commit f050447e9464f028eb717d2476f8849f89f7f6e6
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 10:05:27 2021 -0700

    Experimenting with GitHub Actions.

A	.github/workflows/win_ci.yml

commit aa792f3c124d4648675b08107e2335fea4798856
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 09:45:49 2021 -0700

    Removed the inclusion of unistd.h in jas_stream.h.

M	src/libjasper/include/jasper/jas_stream.h

commit 0498199d85d0a2f37e83b232e9fac80c10724c7d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 09:24:28 2021 -0700

    Made some changes in an attempt to fix a MacOS build issue.

M	CMakeLists.txt

commit 3e47508eb024dd1405cac06a05c935fcae386acf
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 09:04:03 2021 -0700

    Added a missing include of unistd.h.

M	src/libjasper/include/jasper/jas_stream.h

commit c87f1c879bce270bc479f1b3bbc02f083427d459
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 24 08:47:29 2021 -0700

    Cleaned up the top-level CMakeLists.txt file.

M	CMakeLists.txt
D	build/cmake/modules/JasOpenGL.cmake
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_dll.h

commit e2c4b2a1043cbc64008157c694f58faeb9623d79
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Aug 23 09:28:46 2021 -0700

    Updated the installation instructions in the file INSTALL.
    Renamed the preprocessor define JAS_ATTRIBUTE_DISABLE_USAN to
    JAS_ATTRIBUTE_DISABLE_UBSAN.
    Renamed the CMake option DJAS_ENABLE_USAN to DJAS_ENABLE_UBSAN.

M	CMakeLists.txt
M	INSTALL
M	build/build
M	build/cmake/modules/Sanitizers.cmake
M	build/my_build
M	src/libjasper/include/jasper/jas_compiler.h
M	src/libjasper/include/jasper/jas_math.h

commit 6dfb8097dc0f509ce0f45556362e2730cb05822a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Aug 23 07:52:48 2021 -0700

    Added some new build configurations to the build_all script.

M	build/build_all

commit eb53548a96252ef3a295c43fef5f276bc835960e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 23:12:14 2021 -0700

    Fixed a build problem with Clang on MacOS (resulting from an invalid
    compiler option).

M	CMakeLists.txt

commit 5b407ee34a27c9f09637fa37931be0fc9536114c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 22:41:25 2021 -0700

    Fixed some minor build issues.
    Added the jas_context_get_vlogmsgf function, which was missing.
    Added more content to the manual.

M	CMakeLists.txt
M	build/build
M	doc/src/overview.dox
M	src/libjasper/include/jasper/jas_init.h

commit 58d8d40d9a0c7fbb96d50bf4ed2479a05243366f
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 16:06:20 2021 -0700

    Disabled Windows builds that use GitHub Actions CI, since this
    currently
    fails and Windows builds are already being performed by Appveyor CI
    anyways.

M	.github/workflows/ci.yml

commit 23bb7f352489e4b5eda80cb984bdaeab298561e9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 15:55:50 2021 -0700

    Added an attempted fix for a MacOS build problem.

M	CMakeLists.txt

commit 36afd8ba60b56fc19da355eb943deb79f6ff166a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 15:49:53 2021 -0700

    Changed the method used to determine the threading library in the
    top-level CMakeLists.txt file.

M	CMakeLists.txt

commit ff2c5c4f8660fd2252507ddc072758feb02deee2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 15:36:09 2021 -0700

    Fixed a bug in the top-level CMakeLists.txt file impacting the MacOS
    platform.

M	CMakeLists.txt

commit 951d3fe1327255197e38763d60ffe45d9ffc433b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 15:32:10 2021 -0700

    Made further changes to address CI related problems.

M	build/build_all

commit ab838d6b2b2a72ebd0011b3b9dcb9627d696af47
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 15:27:10 2021 -0700

    Modified the build_all script in an attempt to fix GitHub Actions CI
    problems for MacOS.

M	build/build_all

commit c7dad93d6fface7a1457bcd56ac8a90240abccc9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 15:09:47 2021 -0700

    Added a special case for MacOS when finding the threads library.

M	CMakeLists.txt

commit a5a202908f410550592f3f9905b21b0a7fb6293b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 15:00:22 2021 -0700

    Added the jas_realpath script in order to provide the functionality
    of the realpath program on MacOS.

M	build/build
M	build/build_all
A	build/jas_realpath

commit 99c129b5c425bdc3cea3b4ecf768518a73a37fb5
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 14:39:33 2021 -0700

    Added more platforms to the CI workflow.

M	.github/workflows/ci.yml

commit 7da6f69dea6356e23a8c1f546b316c79dfb52bb5
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 14:13:32 2021 -0700

    Improved the method used to detect C11 threading support.

M	CMakeLists.txt
M	build/build_all
M	src/libjasper/include/jasper/jas_config.h.in

commit ac15ab8294e2229dffa9ef5b730d52d2b849dadb
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 13:28:50 2021 -0700

    Revised the installation instructions.

M	INSTALL

commit 7836fbda6cbe21dbb9d4d88677200077e37f7acf
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 13:09:14 2021 -0700

    In the CI workflow, the test using TSan has been modified to build
    with POSIX threading support.

M	build/build_all

commit 0685f6a59e265e335a99804d0ed966531ab5fc47
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 12:44:16 2021 -0700

    Reworked the build scripts and the GitHub Actions CI workflow in order
    to allow more build configurations to be tested.

M	.github/workflows/ci.yml
A	build/build
A	build/build_all

commit 5b83edf1e0e4d8e57247a5160ddf842a83195529
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 22 10:50:35 2021 -0700

    Changed the build process to use CMake to determine the appropriate
    compiler/linker flags to use for hiding symbols for shared libraries.
    Added the CMake-generated jas_export_cmake.h header.
    Replaced JAS_DLLEXPORT and JAS_DLLLOCAL with JAS_EXPORT and JAS_LOCAL,
    respectively.

M	CMakeLists.txt
M	build/my_build
M	src/libjasper/CMakeLists.txt
M	src/libjasper/base/jas_debug.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_cm.h
M	src/libjasper/include/jasper/jas_debug.h
M	src/libjasper/include/jasper/jas_dll.h
M	src/libjasper/include/jasper/jas_getopt.h
M	src/libjasper/include/jasper/jas_icc.h
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_log.h
M	src/libjasper/include/jasper/jas_malloc.h
M	src/libjasper/include/jasper/jas_seq.h
M	src/libjasper/include/jasper/jas_stream.h
M	src/libjasper/include/jasper/jas_string.h
M	src/libjasper/include/jasper/jas_tmr.h
M	src/libjasper/include/jasper/jas_tvp.h
M	src/libjasper/include/jasper/jas_version.h

commit cd4266f3b0580ed9b0c44e0cd703e8e7bbf57071
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Aug 21 15:50:42 2021 -0700

    Fixed a bug in how C11 threading support is detected.

M	CMakeLists.txt
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_debug.h

commit 2bb7a330c75828b6a8c3607b81cb27d5eefa2d3e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Aug 19 13:32:24 2021 -0700

    Renamed some functions related to logging.
    Commented out some obsolete settings from the Doxygen configuration
    file.
    Made further improvements to the documentation.

M	doc/Doxyfile.in
D	doc/src/initialization.dox
M	doc/src/overview.dox
M	src/appl/imginfo.c
M	src/appl/multithread.c
M	src/libjasper/base/jas_debug.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_debug.h
M	src/libjasper/include/jasper/jas_init.h

commit 58832c6103e5f9b4f06556d98d6879ab82f6be52
Merge: 8b51dc3 90000d5
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Aug 18 10:14:35 2021 -0700

    Merge branch 'mdadams-callbacks'

commit 90000d531eab4f14b27f22602d8ee18326e9b0ab
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Aug 18 09:09:07 2021 -0700

    Enabled the JAS_ENABLE_HIDDEN build option by default.
    Made numerous improvements to the my_build script.
    Fixed a bug in the file_close function associated with a potentially
    uninitialized variable.
    Added some missing JAS_DLLEXPORT qualifiers on functions.

M	CMakeLists.txt
M	build/my_build
M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_debug.h

commit 79d28727141f608eef79649918c4657bb80068c4
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 17 17:37:05 2021 -0700

    Removed the JAS_INTERNAL_USE_ONLY preprocessor define from the code
    for all of the codecs, as the codecs should be written without relying
    on the base library internals.  In the process of doing so, added the
    new functions:
	jas_context_get_debug_level
	jas_context_get_dec_default_max_samples
	jas_logmemdump
    Changed all of the error, warning, informational, and debug
    messages to
    be generated via the logging interface.
    Added a new CLI option to the imginfo program to be used for testing
    purposes.
    In the JP2/JPC codec, changed all of the dump/dumpdata functions
    to use
    the logging interface instead of writing to standard error.
    In the JPC codec, added some missing checks on the return values of
    functions that could lead to assertion failures.

M	src/appl/imginfo.c
M	src/appl/multithread.c
M	src/libjasper/base/jas_debug.c
M	src/libjasper/base/jas_icc.c
M	src/libjasper/base/jas_iccdata.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/base/jas_stream.c
M	src/libjasper/bmp/bmp_dec.c
M	src/libjasper/bmp/bmp_enc.c
M	src/libjasper/include/jasper/jas_debug.h
M	src/libjasper/include/jasper/jas_fix.h
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_log.h
M	src/libjasper/jp2/jp2_cod.c
M	src/libjasper/jp2/jp2_cod.h
M	src/libjasper/jp2/jp2_dec.c
M	src/libjasper/jp2/jp2_enc.c
M	src/libjasper/jpc/jpc_bs.c
M	src/libjasper/jpc/jpc_cod.c
M	src/libjasper/jpc/jpc_cs.c
M	src/libjasper/jpc/jpc_cs.h
M	src/libjasper/jpc/jpc_dec.c
M	src/libjasper/jpc/jpc_enc.c
M	src/libjasper/jpc/jpc_mqdec.c
M	src/libjasper/jpc/jpc_mqdec.h
M	src/libjasper/jpc/jpc_mqenc.c
M	src/libjasper/jpc/jpc_mqenc.h
M	src/libjasper/jpc/jpc_t1dec.c
M	src/libjasper/jpc/jpc_t1enc.c
M	src/libjasper/jpc/jpc_t2dec.c
M	src/libjasper/jpc/jpc_t2enc.c
M	src/libjasper/jpg/jpg_dec.c
M	src/libjasper/jpg/jpg_enc.c
M	src/libjasper/mif/mif_cod.c
M	src/libjasper/pgx/pgx_dec.c
M	src/libjasper/pgx/pgx_enc.c
M	src/libjasper/pnm/pnm_dec.c
M	src/libjasper/pnm/pnm_enc.c
M	src/libjasper/ras/ras_dec.c
M	src/libjasper/ras/ras_enc.c

commit e27f23a51c711876ed4b4c378d8cf868e43aee17
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 17 08:16:10 2021 -0700

    Made an attempt to fix a build issue on Windows.

M	src/libjasper/include/jasper/jas_thread.h

commit 0d283034514aa93e1824d9f81d9462eae2c5a636
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 17 08:13:47 2021 -0700

    Made an attempt to fix a build issue on Windows.

M	src/libjasper/include/jasper/jas_thread.h

commit a339214bf7f3b9a8b75dc3a528b0ee6f08bd9438
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 17 07:53:03 2021 -0700

    Fixed a typo in an invocation of assert.

M	src/libjasper/include/jasper/jas_thread.h

commit 9237fdd330bfbbabe080d1635247e76401bcc928
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 17 07:47:45 2021 -0700

    Added more multithreading support functionality for MSVC under
    Windows.

M	src/libjasper/include/jasper/jas_thread.h

commit 6e86bdfda5ab2d7e7c4fec4bd59f6fb0ee44a281
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 17 07:17:41 2021 -0700

    Changed the multithread program to use jas_getopt instead of getopt.

M	src/appl/multithread.c

commit 3a67a180a1c949de7f1c8197bf30726e5968efe0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 17 02:00:21 2021 -0700

    Made an attempt to fix a build issue on Windows.

M	src/libjasper/include/jasper/jas_thread.h

commit ff91c1a599ae2035ecbfaeb3ceb10916560da44d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 17 01:57:06 2021 -0700

    Made an attempt to fix a build issue on Windows.

M	src/libjasper/include/jasper/jas_thread.h

commit ff4bc43f34f71573b676babe2c362acda7c50935
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 17 01:51:41 2021 -0700

    Made an attempt to fix a build issue on Windows.

M	src/libjasper/include/jasper/jas_config.h.in

commit c4af343f419cf0c9704e7859c4f40814e74bd557
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 17 01:41:53 2021 -0700

    Added a check for Win32 Threads in the top-level CMakeLists.txt file.
    Changed the method for selecting the threading library to use.
    Fixed a bug in the Sanitizers.cmake CMake module.

M	CMakeLists.txt
M	build/cmake/modules/Sanitizers.cmake
M	build/my_build
M	src/libjasper/include/jasper/jas_config.h.in

commit f670eff45caed11ae19e7546acd134fa370274d2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Aug 17 01:20:24 2021 -0700

    Added some partial threading support for MSVC on Windows.

M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_thread.h

commit 8b51dc31e915b5c2e73bd82ee7846d7b311d9ec3
Merge: 82090f1 abda969
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Aug 16 10:18:09 2021 -0700

    Merge pull request #297 from jubalh/2033news

    Add issue numbers to 2.0.33 news

commit abda969eb7cb2890b7ef0c3e744b5e737f8c51c4
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Mon Aug 16 09:08:02 2021 +0200

    Add issue numbers to 2.0.33 news

M	NEWS

commit 1711d094e2a51076505197595fc7501d8305db52
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Aug 14 22:32:17 2021 -0700

    Restructured some of the code for generating log messages.
    Changed all generation of messages for errors, warnings, informational
    purposes, and debugging to be done with the jas_printferror,
    jas_printfwarn, jas_printfinfo, and jas_printfdebug functions.
    Added a missing failure check on the return value of an invocation of
    jas_matrix_create.
    Added more documentation to the source code and manual.
    Added some missing source-code annotations for Doxygen.
    Removed some unnecessary include directives from the demo application
    programs.
    Removed the use of an obsolete build option from the my_build script.

M	build/my_build
M	doc/Doxyfile.in
D	doc/src/images.dox
M	doc/src/initialization.dox
M	doc/src/modules.dox
A	doc/src/overview.dox
D	doc/src/streams.dox
M	src/appl/fuzz.c
M	src/appl/jasper.c
M	src/appl/jiv.c
M	src/appl/multithread.c
M	src/appl/tmrdemo.c
M	src/libjasper/CMakeLists.txt
M	src/libjasper/base/jas_cm.c
M	src/libjasper/base/jas_debug.c
M	src/libjasper/base/jas_getopt.c
M	src/libjasper/base/jas_icc.c
M	src/libjasper/base/jas_iccdata.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/base/jas_seq.c
M	src/libjasper/base/jas_stream.c
M	src/libjasper/base/jas_string.c
M	src/libjasper/base/jas_tmr.c
M	src/libjasper/base/jas_tvp.c
M	src/libjasper/base/jas_version.c
M	src/libjasper/bmp/bmp_dec.c
M	src/libjasper/bmp/bmp_enc.c
M	src/libjasper/include/jasper/jas_cm.h
M	src/libjasper/include/jasper/jas_debug.h
M	src/libjasper/include/jasper/jas_fix.h
M	src/libjasper/include/jasper/jas_icc.h
M	src/libjasper/include/jasper/jas_init.h
C074	src/libjasper/include/jasper/jas_debug.h
src/libjasper/include/jasper/jas_log.h
M	src/libjasper/include/jasper/jas_seq.h
M	src/libjasper/include/jasper/jas_thread.h
M	src/libjasper/include/jasper/jas_tmr.h
M	src/libjasper/include/jasper/jasper.h
M	src/libjasper/jp2/jp2_cod.c
M	src/libjasper/jp2/jp2_dec.c
M	src/libjasper/jp2/jp2_enc.c
M	src/libjasper/jpc/jpc_cs.c
M	src/libjasper/jpc/jpc_dec.c
M	src/libjasper/jpc/jpc_enc.c
M	src/libjasper/jpc/jpc_t1dec.c
M	src/libjasper/jpc/jpc_t1enc.c
M	src/libjasper/jpc/jpc_t2dec.c
M	src/libjasper/jpg/jpg_dec.c
M	src/libjasper/jpg/jpg_enc.c
M	src/libjasper/mif/mif_cod.c
M	src/libjasper/pgx/pgx_dec.c
M	src/libjasper/pgx/pgx_enc.c
M	src/libjasper/pnm/pnm_dec.c
M	src/libjasper/pnm/pnm_enc.c
M	src/libjasper/ras/ras_dec.c
M	src/libjasper/ras/ras_enc.c

commit 6e375fda5cfdff9d9c56d5bb89ca592683f5bc8a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Aug 14 12:25:50 2021 -0700

    Revised some of the documentation on library initialization and
    shutdown.

M	build/my_build
M	doc/src/initialization.dox
M	src/libjasper/include/jasper/jas_malloc.h

commit f4dc9ac16d9eb6bffbd62877cd14810a54308cb2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Aug 4 11:32:06 2021 -0700

    Fixed a typo in the documentation.

M	src/libjasper/include/jasper/jas_malloc.h

commit 71d4372f336b99cccdff7be8363d51e9e60d088a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Aug 2 11:41:38 2021 -0700

    Made some corrections/improvements to the initialization/shutdown
    section of the manual.

M	doc/src/initialization.dox

commit 0c6589f6afa98ab6a19e83fe00d6b9140a4c2477
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Aug 2 10:22:33 2021 -0700

    deploy_gh_pages script:
    Made the updating of the link for the latest version of the manual
    to be
    optional.

M	build/github/deploy_gh_pages
M	build/github/make_main_gh_page

commit a2306d2bd4eed7c04252f97ff5cd04fda3d402cf
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Aug 2 10:17:39 2021 -0700

    Added the generation of a main page for the GitHub pages site for
    the manual.

M	build/github/deploy_gh_pages
A	build/github/make_main_gh_page

commit c74fdc657fa96217ca6168c1d4baae6800f2fa37
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Aug 2 00:08:28 2021 -0700

    Added some information about library initialization and shutdown to
    the manual.

M	doc/Doxyfile.in
D	doc/src/faq.dox
M	doc/src/getting_started.dox.in
A	doc/src/images.dox
R066	notes.txt	doc/src/initialization.dox
A	doc/src/streams.dox

commit 20ba21a893707990aa13a4bd5db153ad81e77d11
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 21:54:01 2021 -0700

    Changed the memory allocator wrapper to use actual allocated size
    instead
    of requested size when tracking memory usage.
    Fixed several bugs in some of the math functions for safe integer
    arithmetic.

M	src/libjasper/base/jas_malloc.c
M	src/libjasper/include/jasper/jas_math.h

commit 5902caa3327a6c14aa3459b98fd68e0e17ff116d
Merge: e3d4a97 82090f1
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 14:45:47 2021 -0700

    Merge branch 'master' into mdadams-callbacks

commit 82090f11c663c00e4fb0fe3e17a095a37f64dc9e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 14:33:47 2021 -0700

    Change the GitHub Actions configuration so that releases are only
    performed for tags of the form "version-*.*.*".

C070	.github/workflows/release.yml
.github/workflows/deploy_manual.yml
M	.github/workflows/release.yml

commit fe00207dc10db1d7cc6f2757961c5c6bdfd10973
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 13:50:31 2021 -0700

    Updated the NEWS document and bumped the version number.

M	CMakeLists.txt
M	NEWS

commit e3d4a977a37d4410aa416dd6f9eec8c04be6da6c
Merge: 0700264 9dcd9c9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 13:30:29 2021 -0700

    Merge branch 'master' into mdadams-callbacks

commit 9dcd9c94ccf7b7cb589929ca2aea1e2893d06c01
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 13:24:12 2021 -0700

    Renamed the Travis CI configuration file that was accidentally renamed
    by a merge.

R100	.travis.yml-DISABLE	.travis.yml

commit 1fa3618add5a6636a2c0778575d29ac7efe49b7c
Merge: 87a8171 82c9de0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 13:21:35 2021 -0700

    Merge branch 'master' into mdadams-makerelease

commit 87a8171d02612ea131519a34bef729392c6477fc
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 13:17:16 2021 -0700

    Experimenting with GitHub Actions.

M	.github/workflows/release.yml
M	build/github/deploy_gh_pages

commit 82c9de00d49683ccbb9605ead92facc9367c6bd8
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 13:14:14 2021 -0700

    Changed the Travis CI configuration so that it no longer deploys the
    JasPer Manual to its corresponding GitHub Pages site.

M	.travis.yml

commit e1f95f23067156ba2e37a929b6740504b7cf9842
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 12:38:47 2021 -0700

    Experimenting with GitHub Actions.

M	build/make_release

commit 50e5786111075525049c6d8205de65b58cecb6a6
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 12:32:58 2021 -0700

    Experimenting with GitHub Actions.

M	build/github/deploy_gh_pages

commit bc79235ae626a48b6aef9acc66cf8ce0d684abec
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 12:23:59 2021 -0700

    Experimenting with GitHub Actions.

M	.github/workflows/release.yml

commit 3b05453591dfe1ecea0c69ac701fb5afe9d804d9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 12:12:28 2021 -0700

    Experimenting with GitHub Actions.

M	.github/workflows/release.yml

commit b69fec1780f9f2e86e3dffd8914e42effea60fb2
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 12:10:47 2021 -0700

    Experimenting with GitHub Actions.

M	.github/workflows/release.yml

commit fc4c9328c57809c397facc6021b9bd8e9bf7e825
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 12:08:53 2021 -0700

    Experimenting with GitHub Actions.

M	.github/workflows/release.yml

commit 7b4968ce65683ca25998320f56b21ab7b0aa9d7c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 12:05:54 2021 -0700

    Experimenting with GitHub Actions.

M	.github/workflows/release.yml

commit 654369e519dfc7e9ea7a127fb9e4aabf346fa0fd
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 1 11:43:44 2021 -0700

    Added some preliminary support for an improved GitHub pages site
    for the JasPer manual.

M	.github/workflows/release.yml
R077	.travis.yml	.travis.yml-DISABLE
A	build/github/deploy_gh_pages
A	build/github/prebuild
M	build/make_release

commit 0700264387355f94dcfcb27fb02565020d146565
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 31 13:29:29 2021 -0700

    Added the -Wno-sign-compare option to the GCC compiler flags in order
    to avoid many compiler warnings for benign code, which could result in
    other important warnings being missed.

M	CMakeLists.txt

commit 378f1ac05ee1205ca1b46324bcffed00957c037b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jul 30 22:42:07 2021 -0700

    Added support for the use of the POSIX Threads Library for threading
    functionality.
    Changed the build process to allow more control over the selection of
    the threading support to be used (i.e., the POSIX Threads Library
    versus
    C11 threading support).

M	CMakeLists.txt
M	src/appl/CMakeLists.txt
M	src/appl/multithread.c
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_thread.h

commit 008a8dcf489b1bf4ecb279dec9847ba65ee7d3f1
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jul 30 08:06:41 2021 -0700

    Added some missing include directives.

M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_malloc.h

commit ca07c7041f553d688093cc777b1f1e76c81b3a36
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jul 30 00:43:58 2021 -0700

    Added support for multiple library contexts (for use in multithreaded
    applications).
    Moved most of the previously library-wide state into into library
    contexts (where some of this state includes: the maximum number of
    samples for decoding, JPC/JP2 look-up tables, the debug level, etc.).
    Added an example application for testing the library's multithreading
    support.
    Improved some of the error messages in scripts used for testing.
    Fixed various other issues.

M	CMakeLists.txt
M	NEWS
M	build/my_build
M	notes.txt
M	src/appl/CMakeLists.txt
D	src/appl/dummy.c
D	src/appl/dummy2.c
M	src/appl/imgcmp.c
M	src/appl/imginfo.c
M	src/appl/jasper.c
M	src/appl/jiv.c
A	src/appl/multithread.c
M	src/libjasper/CMakeLists.txt
M	src/libjasper/base/jas_cm.c
M	src/libjasper/base/jas_debug.c
M	src/libjasper/base/jas_icc.c
M	src/libjasper/base/jas_iccdata.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/base/jas_string.c
M	src/libjasper/bmp/bmp_dec.c
M	src/libjasper/include/jasper/jas_compiler.h
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_debug.h
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_malloc.h
M	src/libjasper/include/jasper/jas_string.h
M	src/libjasper/include/jasper/jas_thread.h
M	src/libjasper/jp2/jp2_cod.c
M	src/libjasper/jp2/jp2_cod.h
M	src/libjasper/jp2/jp2_dec.c
M	src/libjasper/jp2/jp2_enc.c
A	src/libjasper/jpc/jpc_cod.c
M	src/libjasper/jpc/jpc_cod.h
M	src/libjasper/jpc/jpc_dec.c
M	src/libjasper/jpc/jpc_dec.h
M	src/libjasper/jpc/jpc_enc.c
M	src/libjasper/jpc/jpc_enc.h
M	src/libjasper/jpc/jpc_qmfb.c
M	src/libjasper/jpc/jpc_t1cod.c
M	src/libjasper/jpc/jpc_t1cod.h
M	src/libjasper/jpc/jpc_t1dec.c
M	src/libjasper/jpc/jpc_t2cod.c
M	src/libjasper/jpc/jpc_t2enc.h
M	src/libjasper/jpc/jpc_tsfb.c
M	src/libjasper/jpg/jpg_dec.c
M	src/libjasper/jpg/jpg_enc.c
M	src/libjasper/pgx/pgx_dec.c
M	src/libjasper/pnm/pnm_dec.c
M	src/libjasper/pnm/pnm_enc.c
M	src/libjasper/ras/ras_dec.c
M	test/bin/jpenc
M	test/bin/run_codec_test
A	test/bin/run_test_5

commit 76c41ddae262443596d2d6f346c435f51c26c4f6
Merge: 398da88 ed971e9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Jul 30 00:07:33 2021 -0700

    Merge pull request #296 from evanmiller/patch-1

    Use `__builtin_unreachable()` only with GCC 4.5+

commit ed971e908348e8d2cc6f11bf63e50196a47ab700
Author: Evan Miller <emmiller@gmail.com>
Date:	Wed Jul 28 14:36:28 2021 -0400

    Use __builtin_unreachable() only with GCC 4.5+

M	src/libjasper/include/jasper/jas_compiler.h

commit 867d6d92b868dd25a586ed27381b921cf22e3c5e
Merge: aa142c2 398da88
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jul 25 23:06:45 2021 -0700

    Merge branch 'master' into mdadams-callbacks.

commit 398da88f772b860432d655390e2dec5842d364f5
Merge: 1caaa0c f1489c5
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jul 25 11:13:33 2021 -0700

    Merge PR 295 with modifications.

commit aa142c2a83fc47a0415abb17e7a1107b68e47405
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jul 25 10:12:42 2021 -0700

    Made the following settings for the library customizable:
	1) the function used to handle eprintf operations
	2) the image format table

M	src/appl/jasper.c
M	src/libjasper/base/jas_debug.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/include/jasper/jas_debug.h
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_malloc.h

commit 1caaa0cb3e1193913da814457da5f5245c93fdf9
Merge: 2de285b 4d51902
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jul 25 09:43:57 2021 -0700

    Merge pull request #294 from jmroot/tarball-vers

    Include version number in release tarball name

commit ec11e58723b304796237a51c4fb36381aba4c2f7
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 24 15:55:28 2021 -0700

    Fixed some inconsistent declarations in the library code.

M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c

commit 98e1ac7a1647ae9fe8949479acb1ad34477678b0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 24 15:01:57 2021 -0700

    Added an attempt at a workaround to MSVC not supporting max_align_t.

M	src/libjasper/base/jas_malloc.c
M	src/libjasper/include/jasper/jas_types.h

commit 1660314dbce84429afe376c1f75dfdb0305aaa59
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 24 14:50:58 2021 -0700

    Added a missing preprocessor include.

M	src/libjasper/base/jas_malloc.c

commit edcede0ed58038fecc5ed98067524a5e84c369bd
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 24 14:31:55 2021 -0700

    Overhauled the handling of memory allocation in the library.
    Reworked the handling of library setup at run-time (i.e.,
    configuration and
    initialization).
    Added some preliminary threading support to the library.

M	CMakeLists.txt
M	build/cmake/modules/Sanitizers.cmake
M	build/my_build
M	notes.txt
M	src/appl/CMakeLists.txt
M	src/appl/imgcmp.c
M	src/appl/imginfo.c
M	src/appl/jasper.c
M	src/appl/jiv.c
M	src/libjasper/CMakeLists.txt
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/bmp/bmp_dec.c
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_malloc.h
C054	src/libjasper/include/jasper/jas_malloc.h
src/libjasper/include/jasper/jas_thread.h
M	src/libjasper/jp2/jp2_dec.c
M	src/libjasper/jpc/jpc_dec.c
M	src/libjasper/jpg/jpg_dec.c
M	src/libjasper/pgx/pgx_dec.c
M	src/libjasper/pnm/pnm_dec.c
M	src/libjasper/ras/ras_dec.c

commit f1489c5edd5f251dd7f64f1a72ce1ab877348189
Author: Joshua Root <jmr@macports.org>
Date:	Sat Jul 24 17:42:22 2021 +1000

    Fix check for overflow builtins

    Not all versions of clang have these builtins, so use clang's
    __has_builtin macro to check that they are available before using.

M	src/libjasper/include/jasper/jas_math.h

commit 4d51902b63952171d5c1c569673abb92bc828397
Author: Joshua Root <jmr@macports.org>
Date:	Fri Jul 23 16:50:53 2021 +1000

    Include version number in release tarball name

M	.github/workflows/release.yml
M	build/make_release

commit 5786d37c1a9e25c113fc9db577898cc4ecdb6c66
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jul 19 23:45:46 2021 -0700

    Added a check target for the CMake-based build.
    Added some extra command-line options to the my_build script.

M	CMakeLists.txt
M	build/my_build
M	src/appl/CMakeLists.txt

commit 8fce253d8ee19c001954540da3437176cf330ee9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jul 19 10:51:59 2021 -0700

    Moved the contents of the jas_conf.h header into the jas_init.h
    header.

M	src/libjasper/CMakeLists.txt
D	src/libjasper/base/jas_conf.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/bmp/bmp_dec.c
D	src/libjasper/include/jasper/jas_conf.h
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/jpc/jpc_dec.c
M	src/libjasper/jpg/jpg_dec.c
M	src/libjasper/pgx/pgx_dec.c
M	src/libjasper/pnm/pnm_dec.c
M	src/libjasper/ras/ras_dec.c

commit f3cd939b58addb9ddc68c480d7250ea460c9c568
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jul 12 10:31:23 2021 -0700

    Revised the documentation for the jas_init_custom function.

M	src/libjasper/include/jasper/jas_init.h

commit b48c3660037069b21af275931a43082fea40c7ad
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jul 11 09:04:18 2021 -0700

    Bumped the major version number since many significant API changes
    have
    been made.
    Changed the interface for the jas_init_custom function by merging the
    specification of the allocator with the other configuration settings.
    Made the following items configuration parameters that can be set via
    the jas_init_custom function:
       - the image formats to be handled by the library
       - the memory usage limit for the BMA allocator

M	CMakeLists.txt
M	build/my_build
A	notes.txt
M	src/appl/imgcmp.c
M	src/appl/imginfo.c
M	src/appl/jasper.c
M	src/appl/jiv.c
M	src/libjasper/base/jas_conf.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_conf.h
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_init.h

commit 1f3b60131d2e175e555411b2da90e4aa62114b9b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 10 22:08:47 2021 -0700

    Renamed some variables for the BMA allocator.

M	src/libjasper/base/jas_malloc.c

commit c3f5bd55c65fb85eacd23c6c0a8f790f777ef80d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 10 20:36:37 2021 -0700

    The JPC decoder had some execution paths associated with various
    failure
    modes that did not properly initialize all of the decoder state.
    When such a path is hit, the decoder is unable to clean up properly
    (e.g., often dying with a bad pointer access).

M	src/libjasper/jpc/jpc_dec.c

commit da0495e352f05565d1843704514e5eb26821c58f
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jul 4 12:49:29 2021 -0700

    Changed the behavior of the jas_init_custom function so that it
    no longer
    registers jas_cleanup as an atexit callback.

    Changed the jas_cleanup function to clear the memory allocator used by
    the library (in order to try to force a crash if someone invokes the
    memory allocator after the library is shutdown).

    Added some extra error checking/detection to the BMA allocator.

    The following changes were made to the top-level CMakeLists.txt file:
    Added the following new CMake build options:
	JAS_USE_JAS_INIT
	JAS_USE_DEFAULT_ALLOCATOR
    Enabled the exporting of compile commands via
    CMAKE_EXPORT_COMPILE_COMMANDS.

M	CMakeLists.txt
M	src/appl/imgcmp.c
M	src/appl/imginfo.c
M	src/appl/jasper.c
M	src/appl/jiv.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_malloc.h

commit bea5945bb59e09f26886e4d65cf8d136515c1fca
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Jul 3 16:09:01 2021 -0700

    Fixed some compiler warnings.

M	src/libjasper/base/jas_conf.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/include/jasper/jas_malloc.h

commit 5cf488a508d9254c67af9094c349ef57545fa1e0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Jun 28 15:37:37 2021 -0700

    Fixes #292.

    Added support for a user-specified memory allocator (via
    jas_init_custom).
    Added the ability to configure at run-time the parameter controlling
    the
    default maximum number of samples (for decoding).

    Changed some calls to malloc/free to use jas_malloc/jas_free.

M	CMakeLists.txt
M	NEWS
M	doc/src/modules.dox
M	src/appl/imgcmp.c
M	src/appl/imginfo.c
M	src/appl/jasper.c
M	src/appl/jiv.c
M	src/libjasper/CMakeLists.txt
C079	src/libjasper/include/jasper/jas_init.h
src/libjasper/base/jas_conf.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/base/jas_malloc.c
M	src/libjasper/bmp/bmp_dec.c
C083	src/libjasper/include/jasper/jas_init.h
src/libjasper/include/jasper/jas_conf.h
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_malloc.h
M	src/libjasper/jpc/jpc_dec.c
M	src/libjasper/jpc/jpc_tsfb.c
M	src/libjasper/jpg/jpg_dec.c
M	src/libjasper/pgx/pgx_dec.c
M	src/libjasper/pnm/pnm_dec.c
M	src/libjasper/ras/ras_dec.c

commit 2de285b864d64ecc66d5389a5d8c50cc8a439b0c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jun 20 13:43:40 2021 -0700

    Fixes #291.
    The JP2 decoder was aborting instead of returning with an error
    when an
    invalid ICC profile was provided.  This problem has been fixed.
    A new JP2 decoder test case was also added.

A	data/test/bad/291.jp2
M	src/libjasper/base/jas_icc.c

commit 543e18d0004dcf63b65b2ab4a22d3384517d7c22
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Apr 22 11:04:56 2021 -0700

    Added a mention of the CVE assigned for issue #268 to the NEWS
    document.

M	NEWS

commit 025768e2a5021b58f62d78155ff3f9ecd548cf22
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Apr 18 22:06:02 2021 -0700

    Updated the NEWS document and bumped the version number.

M	CMakeLists.txt
M	NEWS

commit 50db48b031215866c22f5050f573ddc514a04500
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Apr 18 22:03:32 2021 -0700

    Revised the GitHub Actions workflow for releases.

M	.github/workflows/release.yml
A	build/extract_release_notes
A	build/make_release

commit d6cec7261e777a38e6d42dddeb9fe98d0e26a75e
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Apr 17 15:24:32 2021 -0700

    Updated the NEWS document and bumped the version number.

M	CMakeLists.txt
M	NEWS

commit 4304676d259eb98d691b45e53357d4ece1f66d0b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Apr 17 15:13:47 2021 -0700

    Added a GitHub Actions workflow file for handling releases.

A	.github/workflows/release.yml

commit 621d23114aff461f8abe2c7c1f9dd149a39cf51f
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Apr 17 00:49:55 2021 -0700

    Disable the Windows and MacOS builds in the matrix for the ci.yml
    workflow.

M	.github/workflows/ci.yml

commit 0ea599539d01e1306692aab02d8bec0529c1b751
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Apr 17 00:44:52 2021 -0700

    Removed more dependencies on Make from the my_build script.

M	build/my_build

commit 9d271237b7d042a784a7161ef83f48b940f672d7
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Apr 17 00:34:42 2021 -0700

    Added the specification of the shell in ci.yml workflow.

M	.github/workflows/ci.yml

commit 21e46f59cb79e75eb805aac16b3588508a0a6fec
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Apr 17 00:30:47 2021 -0700

    Removed a few dependencies on Make from the my_build script.

M	build/my_build

commit 8a48ae28876d37e35304cd1a3b567f6cf2801639
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Apr 17 00:18:43 2021 -0700

    Added multiple compilers to the matrix for the ci.yml workflow.

M	.github/workflows/ci.yml

commit 3ca26b26271e0c9fd2662694eaf0217559802f98
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Apr 17 00:03:14 2021 -0700

    Disabled fail-fast for the matrix in the ci.yml workflow.

M	.github/workflows/ci.yml

commit d0f989deb4022cd6189d11eac0f535cf2abc95eb
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Apr 16 23:58:02 2021 -0700

    Added multiple runners to the ci.yml workflow.

M	.github/workflows/ci.yml

commit 3ebc4bc51533f392ae0690de628e3a758d7b04bb
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Apr 16 23:34:07 2021 -0700

    Added some experimental setup for GitHub Actions.

A	.github/workflows/ci.yml

commit 4b34f09099e8120444bd5959f9ac5a80485a03f0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Apr 16 19:13:18 2021 -0700

    Updated the NEWS document and bumped the version number.

M	CMakeLists.txt
M	NEWS

commit d1845f5e4abe45e1cfb420e3222686c2eae8071b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Apr 16 18:39:54 2021 -0700

    Fixes #289.
    An earlier version of the JP2 decoder was too relaxed in its
    checking for
    valid codestreams (i.e., the decoder did not reject some invalid
    codestreams).  In fixing this problem, the checks in the decoder were
    made overly restrictive so that some valid codestreams were rejected.
    To resolve this issue, some of the checks have now been relaxed
    slightly
    so as not to reject valid codestreams.

M	src/libjasper/jp2/jp2_dec.c

commit 5173ef1fbcdd90533a4450f51600ad42b14cd773
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Mar 29 07:57:11 2021 -0700

    Updated the NEWS document and bumped the version number.

M	CMakeLists.txt
M	NEWS

commit 717aeda40883b91f51161ea6c5dcac5f50ef7a59
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Mar 28 19:19:17 2021 -0700

    Issue #269 appears not to have been completely fixed.  This issue
    relates
    to the JP2/JPC decoder.  A bad pointer dereference can still occur.
    This problem has now been fixed (hopefully).  The return value of
    jas_image_depalettize is no longer ignored.  Also, a check has been
    added to ensure that certain box types (CMAP/PCLR/CDEF) have been
    previously processed to avoid dereferencing null pointers.

M	src/libjasper/jp2/jp2_dec.c

commit a8cb065572f3bd05ed4d5330914971934fa4bf90
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Mar 28 11:45:20 2021 -0400

    Fixes #287.
    Removed a bogus assertion that causes the program to be aborted when
    a harmless type of overflow is encountered in the JPC decoder.

M	src/libjasper/jpc/jpc_dec.c

commit 7512494d5012115cf83a3482a9b44424dbc24cd1
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Mar 28 11:43:50 2021 -0400

    Added -DJAS_ENABLE_DANGEROUS_INTERNAL_TESTING_MODE=true to the
    cmake configure options used by the my_build script.

M	build/my_build

commit 66f3d9d59e6eb4d7263c5e8511f25e2ace0e43be
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Mar 21 13:19:34 2021 -0700

    Fixes #286.

    The stream code was ignoring the JAS_STREAM_FILEOBJ_NOCLOSE flag
    during a file-object close operation.  This has now been fixed.

M	src/libjasper/base/jas_stream.c

commit 9cec977a2b492d4c56c876adb81de46c2ef4c397
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Mar 20 09:57:23 2021 -0700

    Added the logging of some extra debug information in the JP2/JPC
    codec.

M	src/libjasper/include/jasper/jas_math.h
M	src/libjasper/jpc/jpc_dec.c

commit 50b812b1fda099030c95b364d97de92146d29a3d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Mar 19 12:04:34 2021 -0700

    Fixes #284.
    The function jp2_getint (in the JP2 codec) did not account for the
    fact that int_fast32_t/uint_fast32_t may be larger than 32 bits.
    This has now been fixed.

M	src/libjasper/jp2/jp2_cod.c

commit 65f020aef4fbaff9a7bc4cbdb2110d5e7e5565f5
Merge: 1032266 f261ced
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Mar 18 08:27:28 2021 -0700

    Merge pull request #283 from alex/patch-1

    fix another potential source of undefined behavior

commit f261ced1f7a422bcaf8b4aac816192a01bc2fe48
Author: Alex Gaynor <alex.gaynor@gmail.com>
Date:	Thu Mar 18 11:21:01 2021 -0400

    Update pgx_dec.c

M	src/libjasper/pgx/pgx_dec.c

commit 10322667205fa9c198ca26f7ace197ed00846f83
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Thu Mar 18 12:23:26 2021 +0100

    Release 2.0.27

M	CMakeLists.txt
M	NEWS

commit 9f09ab50e2987e3fe1f9779dd5e2aa55b8b02b0c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Mar 14 09:21:09 2021 -0700

    Fixes #223.
    Added some comments to the NEWS document regarding breaking changes
    made to the JasPer library sometime around version 2.0.19.

M	NEWS

commit 63a87fb0a1d5461d9cb5858b1edefa987155f283
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Mar 14 09:05:40 2021 -0700

    Added a test case for the JP2 codec.

A	data/test/bad/277.jp2

commit e616594e38140b9dac3f16fd645dcf0eea96782f
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Mar 14 08:52:11 2021 -0700

    Fixes #278.
    The JP2 decoder was allowing integers to be decoded when those
    integers were too large in size.  A check has now been added
    to catch this problem.

A	data/test/other/278.jp2
M	src/libjasper/jp2/jp2_cod.c

commit f4eeac74b4496515d68afc85531cc694104be459
Author: Alex Gaynor <alex.gaynor@gmail.com>
Date:	Sun Mar 14 11:10:46 2021 -0400

    fix another potential source of undefined behavior

    if prec is 31, this leads to an undefined shift

M	src/libjasper/pgx/pgx_dec.c

commit f94e7499a8b1471a4905c4f9c9e12e60fe88264b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Mar 13 20:04:58 2021 -0800

    Fixes #269.
    Added a check for an invalid component reference in the JP2 decoder.
    Added a related test case for the JP2 codec.

A	data/test/bad/269.jp2
M	src/libjasper/jp2/jp2_dec.c

commit 1504ddd7e03a11a381070e853ee67c4d3c13c7a3
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Mar 13 14:12:29 2021 -0800

    Fixes #270.
    Fixed an arguably incorrect type for an integer literal in the
    PGX decoder.

M	src/libjasper/pgx/pgx_dec.c

commit 2db73b5b9f49feac4e1f0d8b33bf8f2acc7f989b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Mar 13 13:34:54 2021 -0800

    Added another test case for the PGX codec.

A	data/test/bad/276.pgx

commit 3228d83d8c7a36492c56b89643466e6ca3ea4afa
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Mar 13 13:23:00 2021 -0800

    Added checks for dimensions of zero in the JPC and JPEG decoders.
    Added two test cases for the PGX codec.

A	data/test/bad/281a.pgx
A	data/test/bad/281b.pgx
M	src/libjasper/jpc/jpc_dec.c
M	src/libjasper/jpg/jpg_dec.c

commit 6726b5859187dafe9f95e1220967768268d8d115
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Mar 13 13:10:12 2021 -0800

    Added two new PGX codec test cases.

A	data/test/bad/271a.pgx
A	data/test/bad/271b.pgx

commit 98d27a542d952e289da3727bdd160eb7f93802da
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Mar 13 12:47:46 2021 -0800

    Fixes #274.
    Added a check for an image containing no samples in the PGX decoder.

A	data/test/bad/274.pgx
M	src/libjasper/pgx/pgx_dec.c

commit 5083b949f0caa5bc6257cd81162a33c15bf8a1d1
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Mar 5 05:59:24 2021 -0800

    Updated the NEWS document and bumped the version number.

M	CMakeLists.txt
M	NEWS

commit c4144a6fdb2660794136d1daaa80682ee40b138b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Fri Mar 5 05:36:20 2021 -0800

    Fixes #268 (A Null Pointer dereference).
    The JP2 decoder was not checking if a component number referenced by
    a CDEF box was valid.  This has now been fixed.  A new test case
    related to this bug has been added to the test suite as well.

A	data/test/bad/268_poc.jp2
M	src/libjasper/jp2/jp2_dec.c

commit 2f280db4a72cc6660f97226d34db49c50599808a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Wed Feb 10 13:48:43 2021 -0800

    Added a note about CVE-2021-26927 to the NEWS document.

M	NEWS

commit 15971f282d278018c7b3ccc769681059a0f74394
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Feb 9 08:25:12 2021 -0800

    Added a note about CVE-2021-26926 to the NEWS document.

M	NEWS

commit 6afcd413d8a610d770618caf2440351dc0bad8ef
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Mon Feb 8 10:08:25 2021 +0100

    Add missing NEWS entries

    Among which CVE-2021-3272 which is worth mentioning.

M	NEWS

commit 9092dcb7f7680204ef523c73eb6132162b4358e3
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Feb 7 13:12:04 2021 -0800

    Updated the NEWS document and bumped the version number.

M	CMakeLists.txt
M	NEWS

commit 7002634a20913269df72b28a93a1c0f92fb6df0c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Feb 7 13:06:59 2021 -0800

    Added another JPEG-2000 decoding test case.

A	data/test/bad/poc_265.jp2

commit 41f214b121b837fa30d9ca5f2430212110f5cd9b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Feb 7 12:31:55 2021 -0800

    Fixes #264.

    The JP2 decoder was allowing the decoding of a code stream to be
    attempted when the stream has inconsistent values for the number of
    components and/or the component types.  For such invalid streams,
    only a warning would be issued and decoding would proceed.	This is
    dangerous, however, as it can lead to many unexpected paths through
    the code, which in some cases have been demonstrated to result in
    security vulnerabilities.  This code change makes decoding of these
    types invalid code streams a hard error.

A	data/test/bad/poc_264.jp2
M	src/libjasper/jp2/jp2_dec.c

commit c8f622d00fbc0204fa24f4768641b2d6eb565d65
Merge: 49174ab 28fe3b7
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Fri Jan 29 14:33:00 2021 +0100

    Merge pull request #266 from zodf0055980/master

    Prevent free uninitialized pointer

commit 28fe3b7174c46ca9f33cf29e4927ee2bd4c00535
Author: zodf0055980 <zodf0055980@gmail.com>
Date:	Fri Jan 29 19:56:44 2021 +0800

    Prevent free uninitialized pointer
    Fixes #263

M	src/libjasper/jpc/jpc_enc.c

commit 49174ab592cdfa6f1a929a2ee3d4b4976f9459fd
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Jan 19 22:59:33 2021 -0800

    Fixes #259

A	data/test/bad/hoob_8.jp2
M	src/libjasper/jp2/jp2_dec.c

commit 8bab5b1625187cf65d2cf1bbbb2a5a53c54e3399
Merge: 9a2835a 75bb65b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Jan 19 07:55:38 2021 -0800

    Merge pull request #261 from jubalh/nospecials

    Remove ternary operation only done on some compilers

commit 75bb65b7ef4c4beefbb4c6f44d71814ee647faa3
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Mon Jan 18 12:17:29 2021 +0100

    Remove ternary operation only done on some compilers

    If this ternary operation creates a problem on some clang version.
    Why not just use the more readable if clause in all cases?

    https://github.com/jasper-software/jasper/issues/260 further reports
    that it also creates problems on intel compilers.

    Instead of adding more and more checks for compatible compilers let's
    just use the if clause.

    Fixes https://github.com/jasper-software/jasper/issues/260

M	src/libjasper/jpc/jpc_enc.c

commit 9a2835a81ce9c41a48f36dadce79f110da8d6c75
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Mon Jan 4 10:11:50 2021 +0100

    Add forgotten change to NEWS

    https://github.com/jasper-software/jasper/commit/3ed71843e485d88fc100a930e5a8784542989f46
    was forgotten to mention.

M	NEWS

commit f2a6987ebdd528d34fe160b2b9d81f0856caf2a0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 3 18:51:32 2021 -0800

    Bumped the version number and updated the NEWS document.

M	CMakeLists.txt
M	NEWS

commit fdc5d4e8bb2fdcc1a167acacd6e6bfbc8bb1969b
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 3 18:40:38 2021 -0800

    Added the following preprocessor defines to the jas_config.h
    header:
	JAS_VERSION_MAJOR
	JAS_VERSION_MINOR
	JAS_VERSION_PATCH
    These defines give easier access to the major, minor, and patch
    components of the version than JAS_VERSION.

M	src/libjasper/include/jasper/jas_config.h.in

commit 2fdf698809e1542a7e42a2868e6b1c3be67e74bb
Merge: 0e54fdf 85fed30
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Jan 3 17:41:26 2021 -0800

    Merge pull request #258 from Jamaika1/patch-1

    Add JAS_HAVE_IO_H

commit 85fed30bfb4394fc8429ed20338a147d34a670d4
Author: Jamaika1 <lukaszcz18@wp.pl>
Date:	Wed Dec 30 18:02:15 2020 +0100

    Add JAS_HAVE_IO_H

M	src/libjasper/base/jas_stream.c

commit 0e54fdf695503850ab32cb5bafd6d64ea1ffa144
Merge: cc02d63 3ed7184
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Fri Dec 11 16:30:07 2020 +0100

    Merge pull request #257 from MaxKellermann/alloca_once

    jas_image: call _alloca() only once

commit 3ed71843e485d88fc100a930e5a8784542989f46
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Dec 11 16:16:02 2020 +0100

    jas_image: call _alloca() only once

    Fixes stack overflow bug on Windows, where variable-length arrays are
    not available.  Unlike VLAs, _alloca() calls accumulate, and calling
    it in every loop iteration is certainly a bad idea.

    Regression from commit 5017d3ab2eae49957c3e41cbf9df207b1f31f3bd

    Closes https://github.com/jasper-software/jasper/issues/256

M	src/libjasper/base/jas_image.c

commit cc02d63dde901e06d1f866984fd0e80601deaa13
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Tue Dec 8 08:41:45 2020 +0100

    Release 2.0.23

M	CMakeLists.txt
M	NEWS

commit a1f26d21aa1484f811de7cd64d1565334a655449
Merge: 9975856 4cd52b5
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Nov 30 20:46:05 2020 -0800

    Merge branch 'zodf0055980-master'

commit 4cd52b5daac62b00a0a328451544807ddecf775f
Author: yuan <zodf0055980@gmail.com>
Date:	Mon Nov 30 19:03:20 2020 +0800

    Avoid maxrlvls more than upper bound to cause heap-buffer-overflow

M	src/libjasper/jpc/jpc_enc.c

commit 99758566a5fd90d4ff3a8f7827df43b41c49dc05
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Nov 3 09:08:31 2020 -0800

    Changed the Travis CI testing to also consider the arm64 architecture.

M	.travis.yml

commit ee9d2cc0042706243c9118b48f001b7e23ed4fd8
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Nov 3 08:59:59 2020 -0800

    Changed the Travis CI testing to also consider the ppc64le
    architecture.

M	.travis.yml

commit 0b619730b9c1b42e2a151b24295e019f29274a45
Merge: 95b2f05 3780087
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Oct 6 09:13:46 2020 -0700

    Merge pull request #250 from jubalh/2022

    Add 2.0.22 changes to NEWS file

commit 3780087f14baab698b1cf73c43ee8a59894ce2c1
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Tue Oct 6 09:22:26 2020 +0200

    Add 2.0.22 changes to NEWS file

M	NEWS

commit 95b2f0583a71c92cddefb54b522efe717b7a5adc
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Oct 5 09:41:38 2020 -0700

    Bumped the version number.

M	CMakeLists.txt

commit 7c172c13e909394b9bc0a4fd1a2ecabf59afa4bb
Merge: adbaf67 bd2dfee
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Oct 5 09:37:43 2020 -0700

    Merge pull request #248 from uvic-frodo/fix-glut-build-issue

    Fix for GLUT-related build issue

commit bd2dfeeed3da194ce21ba44d7b577d35070ec97c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Sep 22 07:46:26 2020 -0700

    Closes https://github.com/jasper-software/jasper/issues/247

    This code change fixes a build problem introduced in 1229a12.
    A botched
    attempt to fix this problem was made in a0856f1 (which fixed one
    problem
    by creating another).

    The code change in this commit moves the point at which the JasPer
    OpenGL cmake module is included in the top-level CMakeLists.txt
    file so
    that the main JasPer config header jas_config.h is generated correctly
    (with JAS_HAVE_GL_GLUT_H and JAS_HAVE_GLUT_H set properly) and all of
    the initialization required for this module is performed prior to its
    inclusion.

M	CMakeLists.txt

commit adbaf6714289a33a7febad9809a3d4f2b9a8d7da
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Oct 5 08:23:01 2020 -0700

    Fixes 2.0.21: test suite is failing

    Since the MIF codec is only enabled in internal testing mode, running
    the JasPer test suite normally (i.e., not in internal testing mode)
    will cause tests that require the MIF codec to fail.  This problem
    has been resolved disabling such tests except when internal testing
    mode is enabled (which is controlled by the new environment variable
    JAS_INTERNAL_TESTING_MODE).

M	build/travis/build
M	test/bin/run_codec_test
M	test/bin/run_test_1
M	test/bin/run_test_2
M	test/bin/run_test_3
M	test/bin/run_test_4

commit fe2230d05fac223d69e57fb08e3bf4137618b038
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Oct 5 06:51:02 2020 -0700

    The JasPer JPEG codec support requires the availability of the IJG
    JPEG library.  Previously, when this JPEG library was not installed,
    a dummy JPEG codec was built into JasPer that essentially causes
    all JPEG codec operations to fail (due to lack of real JPEG codec
    support).  There is no practical benefit to including a dummy codec
    in this manner, and doing so may be confusing to end users because
    this causes the jasper application to indicate that it knows about
    the JPEG format, due to the presence of this dummy codec.  Therefore,
    the JasPer software has been modified so that no dummy JPEG codec
    is included in the case that the IJG JPEG library is not available.

M	CMakeLists.txt
M	src/libjasper/CMakeLists.txt
D	src/libjasper/jpg/jpg_dummy.c

commit 896965a1d633a70413a1cf9e45715e02374070bd
Merge: 2c3ab8c d4ba100
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Tue Sep 22 06:27:28 2020 -0700

    Merge pull request #246 from jubalh/news-cleanup1

    Improve NEWS file

commit d4ba10088b27537faf492d3a34737b17dd83fe12
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Tue Sep 22 14:05:31 2020 +0200

    Add addiitonal infos to NEWS file

    Let's link the corresponding issues for reference.
    In the case where the issue is actually directly reported in a PR
    with a
    fix, use that instead.

    Clarify about CVE-2018-19541 decoder/encoder, otherwise users might be
    confused why we claim to have it fixed in 2.0.20 already.

M	NEWS

commit 3609c6747cd3ff7ca4e6ed8bab3eb656b29ed191
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Tue Sep 22 14:03:14 2020 +0200

    Cleanup NEWS file

    Capitalize first letter.
    Use present tense.

    Like it is done in the first entry.
    Let's stay consistent.

M	NEWS

commit 2c3ab8c542a66eb5def030d30602fa455d1adbd9
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Sep 20 13:24:59 2020 -0700

    Manual:
    Corrected some outdated URLs in the manual.
    Included the NEWS document to the manual.
    Started to add some documentation for the initialization and image
    modules
    of the library.

M	doc/src/bugs.dox
M	doc/src/mainpage.dox.in
M	doc/src/modules.dox
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_init.h

commit 5e810df87a1bc2debfd60e1c7722d98c30bee8ff
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Sep 20 11:55:35 2020 -0700

    Bumped the version number and added some notes to the NEWS document
    about security vulnerabilities that have been fixed.

M	CMakeLists.txt
M	NEWS

commit 3fe68853f2b3dc66d811b9dfcd4c7173557d94de
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Sep 20 11:49:14 2020 -0700

    Added a URL for the most recent version of the JasPer Reference Manual
    to the top-level README document.

M	README

commit d5b29fa1abf9de61a13ae72ee3fb09b18570f0f6
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Sep 20 11:42:24 2020 -0700

    Added a missing "jasper" component to an include directive in the
    source file src/appl/dummy2.c.

M	src/appl/dummy2.c

commit 46ccd966b96f62aaac84e9bcbe38a76c748ac1a2
Merge: 24d81bf 3a9319c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Sep 20 11:31:48 2020 -0700

    Merge pull request #214 from jhgit/master

    Add -I<include_dir> to support users that use #include
    <jasper/jasper.h>

commit 24d81bf927b5275495abf5d62551ea79893d6be2
Merge: dff3402 dafd3af
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Sep 20 11:16:24 2020 -0700

    Merge pull request #245 from theta682/patch-2

    Fix for ZDI-15-529

commit dff340220e191dc7794369ef54c52ce57d1821db
Merge: d10a710 78f9c1c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Sep 20 11:14:45 2020 -0700

    Merge pull request #244 from theta682/patch-1

    Fix for CVE-2018-19541

commit 78f9c1c7e211122dcbbbd8aa3cb143c588ee2669
Author: Timothy Lyanguzov <theta682@gmail.com>
Date:	Tue Sep 8 09:56:56 2020 +1200

    Fix for CVE-2018-19541

    The fix was not backported from jasper-maint properly.
    The commit 27d5a884598e909b6e88ee8bf0c5db300a418adb (see
    jasper-maint/jasper#25)
    `numlutens` field is only validate in the encoder,
    but `jas_image_depalettize` is used only in the decoder. The decoder
    should validate incoming data,
    otherwise specifically crafter file can crash the application.
    If `numlutents` is exactly 0 `v` can too big as unsigned `-1` on
    line 1044

M	src/libjasper/base/jas_image.c
M	src/libjasper/jp2/jp2_dec.c

commit dafd3af1f31ac54f44e495c83332d909706d1054
Author: Timothy Lyanguzov <timothy.lyanguzov@sap.com>
Date:	Mon Sep 7 15:17:22 2020 +1200

    Fix for ZDI-15-529

    We fixed input validation as part of the fix for
    [ZDI-15-529](https://www.zerodayinitiative.com/advisories/ZDI-15-529/)

M	src/libjasper/jpc/jpc_dec.c

commit d10a710f31da3d079a984d35ff6cc82a853d25d7
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Sep 5 07:52:22 2020 -0700

    Added a few missing details to the NEWS document.
    Bumped the version number.

M	CMakeLists.txt
M	NEWS

commit e5461e4732b6a1b35d4895a5ee46ecd1cbb4266d
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Sep 5 07:24:10 2020 -0700

    Fixed some typos in the Travis CI build script (introduced in commit
    e50e334).

M	build/travis/build

commit e50e33423830a56b48c31d004a2be2036264bc16
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Sep 5 07:10:02 2020 -0700

    Fixes Security vulnerability: the MIF decoder opens arbitrary files

    The manner in which the MIF codec is enabled has been changed so
    that no
    sane library packager would accidentally enable the MIF codec without
    realizing that there are negative security implications.  Now, the
    only way to enable the MIF codec is to enable the cmake option called
    JAS_DANGEROUS_INTERNAL_TESTING_MODE.  This option defaults to false so
    that the MIF codec is not enabled.	Furthermore, this option has
    multiple
    strongly-worded warnings that it should not be enabled except for
    internal
    use by the JasPer development team.

M	CMakeLists.txt
M	build/travis/build
M	src/libjasper/CMakeLists.txt
M	src/libjasper/include/jasper/jas_config.h.in

commit 09665efc0f1724a16b6b8783524cf71c2835aa7a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Sep 3 17:26:51 2020 -0700

    Added some missing cmake options to the Travis CI build script.

M	build/travis/build

commit 98b5b85751871afe5e8245a6e5815d28c56c0c01
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Sep 3 16:49:22 2020 -0700

    Fixed some problems created by the revert of c20f20b and 7b9d1b1.

M	src/libjasper/base/jas_icc.c
M	src/libjasper/include/jasper/jas_icc.h

commit 425f776c31f9285c17bfb33221835716ba1e8ef0
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Sep 3 16:18:31 2020 -0700

    Added options to the top-level CMakeLists.txt file to allow individual
    codecs to be excluded from the library.
    Added an option to allow the MIF codec to be enabled/disabled if
    included,
    which is set to disabled by default for security reasons.

    Modified the Travis CI build script so that the MIF codec is enabled,
    since the MIF codec is needed for testing.

    Added the inclusion of jas_config.h in a few header files where it was
    missing.

M	CMakeLists.txt
M	build/travis/build
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_compiler.h
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_dll.h
M	src/libjasper/include/jasper/jas_image.h

commit c830ad795e29a9bb9d372b7ce8787ea8ef3514dd
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Sep 3 13:56:32 2020 -0700

    Revert "jas_image: hard-coded format list"

    This reverts commit 7b9d1b10006bda29d6a80b7492ef2ea9e1f588fe.

M	src/appl/fuzz.c
M	src/appl/imgcmp.c
M	src/appl/imginfo.c
M	src/appl/jasper.c
M	src/appl/jiv.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_init.h

commit 24efd9462da3bdc51903f98f55b7761f90215a3c
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Thu Sep 3 13:56:22 2020 -0700

    Revert "CMakeLists.txt: add option to disable the encoder"

    This reverts commit c20f20b970e66aae957e60fc157305a0c49312fa.

M	CMakeLists.txt
M	INSTALL
M	src/libjasper/CMakeLists.txt
M	src/libjasper/base/jas_image.c
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/jp2/jp2_cod.c
M	src/libjasper/jp2/jp2_cod.h
M	src/libjasper/jpc/jpc_cs.c
M	src/libjasper/jpc/jpc_cs.h
M	src/libjasper/jpc/jpc_mct.c
M	src/libjasper/jpc/jpc_mct.h
M	src/libjasper/jpc/jpc_qmfb.c
M	src/libjasper/jpc/jpc_qmfb.h
M	src/libjasper/jpc/jpc_tsfb.c
M	src/libjasper/jpc/jpc_tsfb.h

commit bcb98fe47298991157e9891e9fb1196def5d0650
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 30 21:11:53 2020 -0700

    This commit is mainly addressing various issues related to the
    Doxygen-based JasPer manual.
    Fixed the project title in the JasPer manual (which was not set).
    Added some Doxygen markup in numerous header files.
    Added documentation for the library API for I/O streams in the
    jas_stream.h header.  (Numerous items that need further consideration
    have been marked as TODO or FIXME.)
    Added a license preamble to a few header files that were missing one.
    Added an implementation of the jas_stream_setrwlimit function, which
    was declared but not defined.

M	doc/Doxyfile.in
M	doc/src/modules.dox
M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_cm.h
M	src/libjasper/include/jasper/jas_compiler.h
M	src/libjasper/include/jasper/jas_debug.h
M	src/libjasper/include/jasper/jas_dll.h
M	src/libjasper/include/jasper/jas_fix.h
M	src/libjasper/include/jasper/jas_getopt.h
M	src/libjasper/include/jasper/jas_icc.h
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_init.h
M	src/libjasper/include/jasper/jas_malloc.h
M	src/libjasper/include/jasper/jas_math.h
M	src/libjasper/include/jasper/jas_seq.h
M	src/libjasper/include/jasper/jas_stream.h
M	src/libjasper/include/jasper/jas_string.h
M	src/libjasper/include/jasper/jas_tmr.h
M	src/libjasper/include/jasper/jas_tvp.h
M	src/libjasper/include/jasper/jas_types.h
M	src/libjasper/include/jasper/jas_version.h
M	src/libjasper/include/jasper/jasper.h

commit 4ec5eb457253082a1c5137946a9a1e8ff6b2ba9a
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 30 10:56:54 2020 -0700

    Changed the branch from which to deploy the Doxygen-generated manual
    to master in preparation for merging into master.

M	.travis.yml

commit 227d0a44747622de90fe26c6b571e8e9915c0dde
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sun Aug 30 10:46:02 2020 -0700

    The Travis CI configuration has been modified in order to add the
    deployment of the Doxygen-generated manual to the jasper-manual
    repository.  The Travis CI build script was also enhanced to provide a
    few command-line options (one of which is now used in the
    .travis.yml).

M	.travis.yml
M	build/travis/build

commit 4e9ebda0e40716e04c913b39e191de9ab26a8088
Merge: 86a0931 aba005f
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Sat Aug 29 17:10:32 2020 -0700

    Merge pull request #240 from jubalh/website

    Update website URL in README

commit 86a09319736adff192bc6d498be907d87b924f38
Merge: 657ea0f 5711f7d
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 28 15:44:37 2020 +0200

    Merge branch 'cleanup11' of github.com:MaxKellermann/jasper

commit 657ea0f9c53c84e47289eaf6354e0b999b28d07c
Author: Peter Klotz <peter.klotz99@gmail.com>
Date:	Thu Aug 27 21:34:13 2020 +0200

    Fixed typo in deprecation message

M	src/libjasper/base/jas_debug.c

commit 5711f7d14bdf26dbd2524e57f983e92e1cb54c46
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 27 13:09:49 2020 +0200

    bmp_dec: obey `max_samples` in bmp_getinfo()

    Fixes out-of-memory bugs for the palette allocation.

M	src/libjasper/bmp/bmp_dec.c

commit aba005f60516080b2bd6bb892957cdb3aaacd1ad
Author: Michael Vetter <jubalh@iodoru.org>
Date:	Thu Aug 27 11:37:07 2020 +0200

    Update website URL in README

M	README

commit 5bb1156880ef649dffdeb8716a31680b5656b353
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 15:26:12 2020 +0200

    doc/Doxyfile.in: clear EXAMPLE_PATH, not used

M	doc/Doxyfile.in

commit de193e3dd1def6478f2896c68a76bbed6d34f636
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 15:26:02 2020 +0200

    doc/Doxyfile.in: collapse "doc/../"

M	doc/Doxyfile.in

commit 7585d587e0ecad85989fef0cbe749fb2237be9b4
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 15:20:28 2020 +0200

    doc/Doxyfile.in: strip path names

M	doc/Doxyfile.in

commit bd451334d66edb5646c0a07a87dfbb09d919b451
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 15:21:01 2020 +0200

    doc/Doxyfile.in: remove install.dox from INPUT

    This file has never existed.

M	doc/Doxyfile.in

commit 8104a22ad55ec616adaf0b151081f93c3d608824
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 15:10:10 2020 +0200

    doc/Doxyfile.in: remove non-existent excludes

M	doc/Doxyfile.in

commit 33b39c041fd4aebeed10c440b63880729b34cd21
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 15:09:32 2020 +0200

    doc/Doxyfile.in: remove obsolete options

M	doc/Doxyfile.in

commit ad6935c365ba89a9d04c55ec10da4b49155b7258
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 13:21:57 2020 +0200

    doc/CMakeLists.txt: add dependencies to avoid unnecessary rebuilds

    Use add_custom_command() instead of add_custom_target() because the
    latter forces rebuild on every "make"/"ninja" invocation.  The former
    allows declaring dependencies and rebuilds only if a dependency
    has changed.

M	doc/CMakeLists.txt

commit c036de5571d6dff8ec392b4f39f1370fcaf06fc0
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 14:38:17 2020 +0200

    doc/CMakeLists.txt: "clean" deletes Doxygen output files

M	doc/CMakeLists.txt

commit 4f3e7b3621407ae782db6579ffa2db084959a886
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 14:11:07 2020 +0200

    jas_icc: disable jas_iccprof_save() if encoder is enabled

    This shrinks the library binary by another 11 kB.

M	src/libjasper/base/jas_icc.c
M	src/libjasper/include/jasper/jas_icc.h

commit c20f20b970e66aae957e60fc157305a0c49312fa
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 11:32:44 2020 +0200

    CMakeLists.txt: add option to disable the encoder

    For people who need a small build but never need to encode.  I suppose
    most users don't ever need an encoder, because they only want to read
    existing files.

    This shrinks the library binary by 70 kB.

M	CMakeLists.txt
M	INSTALL
M	src/libjasper/CMakeLists.txt
M	src/libjasper/base/jas_image.c
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/jp2/jp2_cod.c
M	src/libjasper/jp2/jp2_cod.h
M	src/libjasper/jpc/jpc_cs.c
M	src/libjasper/jpc/jpc_cs.h
M	src/libjasper/jpc/jpc_mct.c
M	src/libjasper/jpc/jpc_mct.h
M	src/libjasper/jpc/jpc_qmfb.c
M	src/libjasper/jpc/jpc_qmfb.h
M	src/libjasper/jpc/jpc_tsfb.c
M	src/libjasper/jpc/jpc_tsfb.h

commit 715059ff68ea171b9824c94a0812eabee464b947
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 12:15:39 2020 +0200

    CMakeLists.txt: remove unimplemented option JAS_ENABLE_STRICT

    Commit c3d3c4109de6 removed the option JAS_STRICT, which was probably
    a typo.  Anyway, this commit removes the remains of this option that
    has always been broken.

M	CMakeLists.txt
M	INSTALL

commit 7b9d1b10006bda29d6a80b7492ef2ea9e1f588fe
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 10:44:02 2020 +0200

    jas_image: hard-coded format list

    Why initialize the format array at runtime when we can do that easily
    at compile time?  This eliminates the need to call jas_init() and also
    avoids the atexit() kludge.

M	src/appl/fuzz.c
M	src/appl/imgcmp.c
M	src/appl/imginfo.c
M	src/appl/jasper.c
M	src/appl/jiv.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/base/jas_init.c
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/include/jasper/jas_init.h

commit 7a82835b778db78fa0a7fb01cb268fc6c2ee54bd
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 10:48:28 2020 +0200

    jas_image: make jas_image_fmtinfo_t pointer `const`

M	src/libjasper/base/jas_image.c

commit 84cf8207ec068d8f1f01ac41ab34c12ab268bb6e
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 11:18:42 2020 +0200

    jas_compiler.h: add JAS_DEPRECATED

M	src/libjasper/include/jasper/jas_compiler.h

commit 00cee1470902b2596305de2d3ec62e19dc30edd1
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 11:16:34 2020 +0200

    jas_config.h.in: move macros to jas_compiler.h

    Let's use jas_config.h.in only for generated macros.

M	src/libjasper/CMakeLists.txt
C052	src/libjasper/include/jasper/jas_config.h.in
src/libjasper/include/jasper/jas_compiler.h
M	src/libjasper/include/jasper/jas_config.h.in

commit 09f95cb9c9daaeb61c41af635edf45db05ffe9bf
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 11:45:19 2020 +0200

    jpc_t1dec: fix NULL pointer dereference

    Found by Coverity, and was only possible to find after commit
    65485b312c0e380

M	src/libjasper/jpc/jpc_t1dec.c

commit 1fcd12dcbb4ce2841dcdc875df23f4e84d1c9ac1
Merge: 923599a 0baeff4
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 10:23:59 2020 +0200

    Merge branch 'fix/exported-symbols' of git://github.com/SpaceIm/jasper

commit 923599a4cd60dbc493032e2aee510594a5480504
Merge: a0856f1 c2cd9d3
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 25 08:46:31 2020 +0200

    Merge branch 'cleanup10' of github.com:MaxKellermann/jasper

commit a0856f1142534f4cd635da19deebc35932214a52
Author: Michael Adams <mdadams@ece.uvic.ca>
Date:	Mon Aug 24 19:21:49 2020 -0700

    Fixed a problem that caused JasPer not build on at least some systems
    (such as Fedora) due to the glut.h header not being found.
    This problem
    appears to be been caused by recent changes in how OpenGL is handled
    in the build process.  The JasPer configuration header was not
    properly
    setting the defines that specify where to pickup the glut.h header.

    In the make CMakeLists.txt file, set OpenGL_GL_PREFERENCE to GLVND to
    avoid complaints from CMake related to legacy behavior.

M	CMakeLists.txt
M	build/cmake/modules/JasOpenGL.cmake
M	src/appl/CMakeLists.txt

commit c2cd9d375903a641843c4c34f517752e95fb666c
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 21 16:57:33 2020 +0200

    jpc_mqdec: rephrase expression to allow compiler optimization

    The two expressions are now the same, and the compiler can merge them.

M	src/libjasper/jpc/jpc_mqdec.h

commit f6cffa56a88fc357ba849396106261ef13eae500
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 21 16:49:28 2020 +0200

    jpc_mqdec: convert jpc_mqdec_renormd() to function

    Allows removing some duplicate code.

M	src/libjasper/jpc/jpc_mqdec.c
M	src/libjasper/jpc/jpc_mqdec.h

commit b92a2ea58404a2082a749df4554da1a0545aaa59
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 21 16:32:41 2020 +0200

    jas_config.h.in: remove obsolete `JAS_CONFIGURE` kludge

    cmake is used on Windows, so we can use its results.  Only the
    hard-coded JAS_HAVE_SNPRINTF needs to stay, because we have no cmake
    check for it (yet).

M	src/libjasper/include/jasper/jas_config.h.in

commit b0770471cc24421a4f9276cee3c1cb62da6f8ccf
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 21 16:23:29 2020 +0200

    jpc_t1dec: convert unrolled loop to `for` loop

    Reduce code duplication.

M	src/libjasper/jpc/jpc_t1dec.c

commit 51295ac0247ffeb8a2aa6adf22a0526a137542e4
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 21 16:00:35 2020 +0200

    jpc_t1dec: convert macros to functions

M	src/libjasper/jpc/jpc_t1dec.c

commit 5aa912d137e1e9536d87cf94b5e69ba7ba1186f4
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 21 15:56:08 2020 +0200

    jpc_t1dec: remove unused parameters

M	src/libjasper/jpc/jpc_t1dec.c

commit 7dbcf2fa7f64103ea3702b63510237bc4faad9da
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 21 15:48:54 2020 +0200

    jas_stream: convert abort() to `return -1`

    JasPer shouldn't crash the application.

M	src/libjasper/base/jas_stream.c

commit 579cfda09114afd9e13fc9d5b1dc99a5da5325d9
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 21 15:44:00 2020 +0200

    jas_stream: use `long` instead of `ssize_t`

    In the `jas_stream_t` API, offsets are `long`, so why bother using
    `ssize_t` here.

    This allows removing the `ssize_t` macro from `jas_config.h.in`, which
    could break applications using JasPer.

M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_config.h.in

commit 8a12b29fb5dcb370707954811f561d527c4ccfb2
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 08:42:01 2020 +0200

    jpc_qmfb: move duplicate code to functions

M	src/libjasper/jpc/jpc_qmfb.c

commit 3171d12f31d2f97a3972f3f64624afad69a89d71
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 18 19:32:37 2020 +0200

    jpc_qmfb: cache expression in variable `end_parity`

M	src/libjasper/jpc/jpc_qmfb.c

commit 7538e43766acdbdc994b11af4d131a09ceda42ce
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 18 19:33:37 2020 +0200

    jpc_qmfb: convert `parity` to bool`

M	src/libjasper/jpc/jpc_qmfb.c

commit 78a3fac872ba4edf45352c55a628e6876c0b1f93
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 15:46:09 2020 +0200

    CMakeLists.txt: remove unimplemented option JAS_MEMORY_LIMIT

    This option was added by commit 055568d29d, but there never was an
    implementation.  It was never connected to the
    `JAS_DEFAULT_MAX_MEM_USAGE` C macro.

    In any case, `JAS_DEFAULT_MAX_MEM_USAGE` is flawed, and therefore I
    would not like to extend its support, because it is not thread-safe.
    This race condition can make libJasPer completely defunct.

M	CMakeLists.txt
M	INSTALL

commit c8ee8a324641176c16ee11180c790bdcba193947
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 21 09:46:19 2020 +0200

    jpc_dec: remove unused field pkthdrstreampos

M	src/libjasper/jpc/jpc_dec.c
M	src/libjasper/jpc/jpc_dec.h

commit 65485b312c0e38076cba24b4c3c9f41875080a16
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 21 09:18:44 2020 +0200

    jpc_dec: convert several struct fields to local variables

    `mqdec`, `nulldec` and `flags` are only used inside
    jpc_dec_decodecblk().

M	src/libjasper/jpc/jpc_dec.c
M	src/libjasper/jpc/jpc_dec.h
M	src/libjasper/jpc/jpc_t1dec.c

commit ba1bb9872647eb9d10bd1c368618c201038deb7a
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 21 09:27:43 2020 +0200

    jpc_t1dec: use local variable `ccp` instead of dereferencing
    `tile->cp->ccps`

M	src/libjasper/jpc/jpc_t1dec.c

commit fa79de579e4af3e38c0c1b9f6ce54b1498eaa409
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 21 09:08:58 2020 +0200

    jpc_mq{cod,dec}: use smaller integer types

    This can improve CPU cache efficiency.

M	src/libjasper/jpc/jpc_mqcod.h
M	src/libjasper/jpc/jpc_mqdec.c
M	src/libjasper/jpc/jpc_mqdec.h
M	src/libjasper/jpc/jpc_mqenc.c
M	src/libjasper/jpc/jpc_mqenc.h

commit 8251f84dfc6a42afa48c53864b1826f123f07166
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 20 23:20:09 2020 +0200

    jpc_dec: copy struct fields to local variables

    Avoid redundant memory reads.

M	src/libjasper/jpc/jpc_dec.c

commit 937cb5a295969937be1ce1d818503b9fef274d2c
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 10:19:58 2020 +0200

    jpc_mqdec: convert macros to inline functions

M	src/libjasper/jpc/jpc_mqdec.c
M	src/libjasper/jpc/jpc_mqdec.h

commit 1708cb89de1d8ffd4162452a450ef13ff3f71cf1
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 20 22:06:59 2020 +0200

    jpc_t1dec: convert macros to functions

    Force inlining them because not doing so would reduce performance.

M	src/libjasper/jpc/jpc_t1dec.c

commit 86f69ae6dc5872205df6cf42f9ca89a9295a2c7d
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 20 22:12:45 2020 +0200

    jpc_t1dec: convert constants to jpc_fix_t

M	src/libjasper/jpc/jpc_t1dec.c

commit c6e87bbfe23e8a91fa11460abe1d7a0802901f85
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 20 22:10:31 2020 +0200

    jpc_t1dec: convert `bitpos` to unsigned

M	src/libjasper/jpc/jpc_t1dec.c

commit a076a014894c09cee96c541420c3f6f61e18eb7d
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 20 22:09:12 2020 +0200

    jpc_t1dec: remove unused macro parameters

M	src/libjasper/jpc/jpc_t1dec.c

commit ccaeded6a6260987e201e1f8a9d8217feabde244
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 20 22:24:53 2020 +0200

    jas_config.h: add more GCC attribute macros

M	src/libjasper/include/jasper/jas_config.h.in

commit 3cee824f1d547b29b5f22d0a6397c2ac06cb7796
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 20 15:07:59 2020 +0200

    jpc_dec: skip clipping if the min/max calculation would overflow

    Even though the JPEG2000 standard allows a precision of up to 38 bit
    (section A.5.1 table A-11), JasPer can't represent such values In 32
    bit mode.  To avoid integer overflows in the min/max value
    calculation, which would corrupt the data even more, this commit adds
    a check for the precision and omits the clipping stage if the
    precision is too large.

    While this looks like a hot fix, and we should catch unsupported
    precisions earlier, this is also useful for the maximum supported
    precision (31 bits) - that calculation (1<<31) would also overflow,
    but clipping should be a no-op there.

M	src/libjasper/jpc/jpc_dec.c

commit 3bd17d766b1b7171185b77318bf8ddba43c6e11a
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 20 15:10:16 2020 +0200

    jpc_dec: use jas_seqent_t for level shift and clipping

    Fixes several integer overflow bugs.

M	src/libjasper/jpc/jpc_dec.c

commit bf32746d5eb436b1343e732864eca8042fa708fc
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 20 15:09:41 2020 +0200

    jpc_dec: skip level shift for signed data

    There's no point in adding 0 to all matrix values.

M	src/libjasper/jpc/jpc_dec.c

commit a83ed04314d20b46760158d5c40ef4539554f386
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 20 14:22:58 2020 +0200

    jpc_fix, jas_seq: use 32-bit shift in JAS_ENABLE_32BIT mode

    Eliminate the implicit cast to 64 bit (`int_fast32_t`).  This allows
    the compiler to switch from the Intel SSE2 instruction `psllq` (shift
    two 64 bit values at a time) to `pslld` (shift four 32 bit values at a
    time).

M	src/libjasper/include/jasper/jas_math.h
M	src/libjasper/include/jasper/jas_seq.h
M	src/libjasper/jpc/jpc_fix.h

commit a8cd574f9daa823aaf2c352024ae579d224381c2
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 20 14:08:07 2020 +0200

    jas_seq: _empty() returns true if either value is zero

    Fixes regression from commit 276ef3867164cce5ea5344272caaffc177174ceb

M	src/libjasper/include/jasper/jas_seq.h

commit 756eb8d63317ba2adeac8413fb3dcabd963b5653
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 16:33:25 2020 +0200

    CMakeLists.txt: remove overly verbose messages

    Those are not helpful, and not worth spamming the screen.

M	CMakeLists.txt
M	build/cmake/modules/JasOpenGL.cmake
M	build/cmake/modules/Sanitizers.cmake

commit 169454f4c1ff8e51e6a3c029e46c8a0b6c320740
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 16:30:39 2020 +0200

    build/cmake/modules/FindMakeDist.cmake: remove unused module

    This module was added by commit
    1dfec33972f121395d0203d7290bd7cc63066735, but was never used.

D	build/cmake/modules/FindMakeDist.cmake

commit a69074f468032d85e4811226b2cc28f5c59553d0
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 16:29:23 2020 +0200

    CMakeLists.txt: remove some commented cruft

M	CMakeLists.txt

commit f186d8d281e8500a61b5aef2afc619bb68e11215
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 16:25:18 2020 +0200

    CMakeLists.txt: remove option JAS_LOCAL

    All this option does is disable compiler optimizations, which is
    rather useless, because people can do that with generic cmake options
    already.

M	CMakeLists.txt

commit 1229a12afbae5b8d1de2fbb5adf9d01ca7f9f249
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 16:19:25 2020 +0200

    CMakeLists.txt: don't detect OpenGL if JAS_ENABLE_PROGRAMS is disabled

    Move the OpenGL detection code to a cmake module and include it only
    from `src/appl/CMakeLists.txt`.

M	CMakeLists.txt
A	build/cmake/modules/JasOpenGL.cmake
M	src/appl/CMakeLists.txt

commit cddb7b199a1c78f3ec0b2c6b8af705588437af4b
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 15:14:47 2020 +0200

    CMakeLists.txt: don't detect Doxygen and LaTeX if JAS_ENABLE_DOC
    is disabled

M	CMakeLists.txt
M	doc/CMakeLists.txt

commit c3d3c4109de6f1cdda8c699db9b1cb74de906311
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 14:46:13 2020 +0200

    CMakeLists.txt: always enable all compiler warnings

    Remove the (undocumented) option `JAS_STRICT`.  We should fix all
    compiler warnings instead of disabling them by default.

M	CMakeLists.txt

commit a6e6f98f1301595352e88021a7110d47c553f59d
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 12:42:54 2020 +0200

    jpc_t2cod: fix division by zero

M	src/libjasper/jpc/jpc_t2cod.c

commit 5da5d02d76f3fbd3a2a198965a56a6e97be71995
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 12:40:16 2020 +0200

    jas_cm: fix division by zero

M	src/libjasper/base/jas_cm.c

commit 2508d59c5e8bb7d7d20e0d0a1f413977b7bb971f
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 12:36:43 2020 +0200

    jpc_t2enc: fix leaking jas_stream

M	src/libjasper/jpc/jpc_t2enc.c

commit f23acc792034cad8f4be62e7eec86debb87f7acc
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Mon Aug 17 15:21:52 2020 +0200

    CMakeLists.txt: enable `-Wmissing-declarations -Wredundant-decls`

M	CMakeLists.txt
M	src/libjasper/jpc/jpc_enc.c

commit 9f4db129b269fe714353153c3c141bb3b5246fb0
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Mon Aug 17 10:38:13 2020 +0200

    jpc_dec: cache data in local variables

    Allow more compiler optimizations.

M	src/libjasper/jpc/jpc_dec.c

commit 1e743cb05a7f26bd5875100dace1c00509783a46
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 18 19:55:23 2020 +0200

    jpc_tsfb: simplify various checks

    Reduce indentation levels and allow tail calls.

M	src/libjasper/jpc/jpc_tsfb.c

commit 36a01a9409df421f503987827188ef625fb83003
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 18 19:37:56 2020 +0200

    jpc_tsfb: make jpc_tsfb_analyze2() static

M	src/libjasper/jpc/jpc_tsfb.c
M	src/libjasper/jpc/jpc_tsfb.h

commit 5017d3ab2eae49957c3e41cbf9df207b1f31f3bd
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 18 19:11:41 2020 +0200

    jas_image: _readcmpt() fast path for 8 bits per pixel

M	src/libjasper/base/jas_image.c

commit e1729043db8f2262a248956d606d22a0e109c915
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 18 19:11:56 2020 +0200

    jas_image: use local variables in jas_image_writecmpt()

M	src/libjasper/base/jas_image.c

commit 5472df353949cb66d6d0da733b1ecaaae88c58e4
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Mon Aug 17 15:26:35 2020 +0200

    jas_icc: add explicit casts to fix "possible loss of data" warnings

M	src/libjasper/base/jas_cm.c
M	src/libjasper/base/jas_icc.c

commit cdddef3555b5fb5d14ee8c59ff745943a10f3080
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 18 08:19:30 2020 +0200

    jas_cm: fix various `-Wconversion` warnings

M	src/libjasper/base/jas_cm.c

commit 5a029d2fd08a8eccf3a5dccc9dc350bcdee941ec
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 18 08:21:09 2020 +0200

    jas_cm: pass unsigned size to jas_cmshapmatlut_invert()

M	src/libjasper/base/jas_cm.c

commit 00c2ccf4b1e35bc790d5c6ade8f0e5f4025f2d1c
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Mon Aug 17 15:35:53 2020 +0200

    jas_cm: fix jas_cmpxformseq_appendcnvt() parameter types

M	src/libjasper/base/jas_cm.c

commit a5619974dcdacd548d1bd721b0f1b326176e6eaf
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Mon Aug 17 15:34:58 2020 +0200

    jas_cm: fix prfintent type

M	src/libjasper/base/jas_cm.c

commit 0bcb358532ca6706b6394172a50184648da9c89c
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Mon Aug 17 15:32:44 2020 +0200

    jas_cm: icctoclrspc() returns jas_clrspc_t

M	src/libjasper/base/jas_cm.c

commit 137aafd661ad4a3535264a23bab123f75a50f859
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 18 08:14:30 2020 +0200

    jas_seq: add explicit casts to fix `-Wsign-conversion`

M	src/libjasper/include/jasper/jas_seq.h

commit 276ef3867164cce5ea5344272caaffc177174ceb
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 18 19:36:52 2020 +0200

    jas_seq: add jas_{matrix,seq2d}_empty()

M	src/libjasper/include/jasper/jas_seq.h
M	src/libjasper/jpc/jpc_tsfb.c

commit e493d6de3f8dc417c53c34a141ba575f772e5fea
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 10:26:21 2020 +0200

    jas_fix: use JAS_FIX_ONE, reduce code duplication

M	src/libjasper/include/jasper/jas_fix.h

commit 8f4573a1aea03b1cb3a42f7f4ebfc1001e314b26
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 10:35:52 2020 +0200

    jas_fix: use JAS_INTTOFIX(), reduce code duplication

M	src/libjasper/include/jasper/jas_fix.h

commit 0932b4bcd1d9d6cb4028d28b0c893c41a34bbcc6
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Wed Aug 19 10:32:16 2020 +0200

    jas_fix: JAS_INTTOFIX() casts to fix_t first, then shifts

    Shifting first can produce an integer overflow because the parameter
    type may be smaller than `fix_t`.

M	src/libjasper/include/jasper/jas_fix.h

commit e1d7e7473cdd096c4b6e560dfcfec3271f00efb2
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 18 08:14:54 2020 +0200

    jas_math: pass shift operand as `unsigned` to jas_fast32_as[rl]()

M	src/libjasper/include/jasper/jas_math.h

commit 117b36ffbb5da58f54ade75cc55fb763dc0da248
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Mon Aug 17 15:31:47 2020 +0200

    jas_math: jas_fast32_as*() returns int_fast32_t

M	src/libjasper/include/jasper/jas_math.h

commit 73f2cd1bc480609bbb6fc2274b4c7f8a84fa67df
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Tue Aug 18 12:36:48 2020 +0200

    build/appveyor/build.bat: disable various options where dependencies
    are missing

M	build/appveyor/build.bat

commit 646e440aed3da498305733b79935a443c0e32edf
Author: OSAMU WATANABE <owatanab@es.takushoku-u.ac.jp>
Date:	Wed Aug 19 05:48:10 2020 +0900

    Hotfix to SOP marker checking

    Why: The commit 13390bd said "the `dec->numpkts` holds the number of
    packets that have been already read. Because the maximum value of
    `Nsop` is 65535, `dec->numpkts % 65536` is necessary to validate a
    `Nsop` value in a SOP marker segment.", however, this was wrong.

    How: Instead of the `dec->numpkts`, `tile->pi->pktno` is used to
    validate a `Nsop` because the `Nsop` is defined as packet seqence
    number in a **tile**. `tile->pi->pktno` holds the packet seqence
    number in a certain tile.

M	src/libjasper/jpc/jpc_t2dec.c

commit 13390bd3a6aee14186f960b45dc3e88bbb46905d
Author: OSAMU WATANABE <owatanab@es.takushoku-u.ac.jp>
Date:	Tue Aug 18 16:39:20 2020 +0900

    Fix SOP marker checking

    Why: If SOP marker segments are allowed (by setting the second
    LSB of Scod parameter to "1" in the COD marker segment, see A.6.1
    in the spec), each packet in any given tile-part may or may not
    be appended with an SOP marker segment. So, the decoding process
    should not be stopped by missing SOP markers. However, whether or
    not the SOP marker segment is used, the count in the Nsop (packet
    sequence number) is incremented for each packet. Nsop is a field
    which has 16 bits length. Valid range of the value of Nsop is from
    0 to 65535. The first packet in a coded tile is assigned the value
    zero. For every successive packet in this coded tile, this number is
    incremented by one. When the maximum number is reached, the number
    rolls over to zero.

    How: Added code lines to check packet sequence number when a SOP
    is found. The `dec->numplts` holds the number of packets that have
    been already read. Because the maximum value of `Nsop` is 65535,
    `dec->numpkts % 65536` is necessary to validate a `Nsop` value in
    a SOP marker segment.

M	src/libjasper/jpc/jpc_t2dec.c

commit 9a705133621bc6961a782c27855db038b185b497
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 21:31:56 2020 +0200

    jas_image: add fast path for 8 bits per pixel

M	src/libjasper/base/jas_image.c

commit f964e6ed30f364bdf19f62fe519c021eb786fbc6
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Mon Aug 17 10:53:34 2020 +0200

    jpc_cs, jp2_cod: use jas_stream_read()

    Reduces function call overhead a bit.

M	src/libjasper/jp2/jp2_cod.c
M	src/libjasper/jpc/jpc_cs.c

commit 0f045f7cfbd8b39b7b00cadb066139d7c21ae461
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Mon Aug 17 10:58:31 2020 +0200

    jas_stream: jas_stream_{read,write}() return unsigned integer

    Both can never return a negative value, even though many callers
    assume so.

M	src/libjasper/base/jas_icc.c
M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_stream.h
M	src/libjasper/jp2/jp2_cod.c
M	src/libjasper/jp2/jp2_enc.c
M	src/libjasper/jpc/jpc_cs.c
M	src/libjasper/jpc/jpc_dec.c

commit 1b990bb3dcfc7b8b50109be132c284c6c7d61a8f
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Mon Aug 17 11:23:56 2020 +0200

    jas_stream: add jas_stream_peek()

    Reduce code duplication in several validate() implementations.

    This also fixes an API misunderstanding: jas_stream_read() never
    returnes a negative value.

M	src/libjasper/base/jas_stream.c
M	src/libjasper/bmp/bmp_dec.c
M	src/libjasper/include/jasper/jas_stream.h
M	src/libjasper/jp2/jp2_dec.c
M	src/libjasper/jpc/jpc_cs.c
M	src/libjasper/jpg/jpg_val.c
M	src/libjasper/mif/mif_cod.c
M	src/libjasper/pgx/pgx_dec.c
M	src/libjasper/pnm/pnm_dec.c
M	src/libjasper/ras/ras_dec.c

commit 16a55fe7d7fd2fd8192fed15227ab7d5cac6ce6b
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 18:40:31 2020 +0200

    jas_stream: implement fast path for unbuffered streams

    This returns to the original speed of buffered `jas_stream_memobj_t`,
    but with less memory usage.  From here, we can optimize further.

M	src/libjasper/base/jas_stream.c

commit 787e414a20d6e907991c67a271bb4a27b791239a
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 18:53:16 2020 +0200

    jas_stream: bulk I/O in jas_stream_copy()

    Copy 8 kB at a time, instead of one byte at a time.

M	src/libjasper/base/jas_stream.c

commit 0c9c53603c14ddf4a1915fa4f280e22e5645dd43
Author: Max Kellermann <max@duempel.org>
Date:	Wed Aug 19 12:36:09 2015 +0200

    jas_stream: make memory streams unbuffered

    This is currently slower, but optimizations using bulk writes are
    coming.

M	src/libjasper/base/jas_stream.c

commit b5d39f08ab682788203fcc659ce04bb7000c6051
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Mon Aug 17 11:08:20 2020 +0200

    jp2_cod: convert jp2_colr_t.iccplen to unsigned

M	src/libjasper/jp2/jp2_cod.c
M	src/libjasper/jp2/jp2_cod.h
M	src/libjasper/jp2/jp2_enc.c

commit 447e54a01d0071d642bdedafac1dfab9d15c67a1
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Mon Aug 17 09:31:58 2020 +0200

    jas_debug: add `const` to jas_memdump()

M	src/libjasper/base/jas_debug.c
M	src/libjasper/include/jasper/jas_debug.h

commit 4f7180e0ff8f9534eb76d83d7b8a5f83e90a0413
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 22:12:54 2020 +0200

    jas_image: copy struct fields to local variables

    Allow the compiler to cache the values in registers and avoid memory
    reads.

M	src/libjasper/base/jas_image.c

commit 5bd60b9d04f0bee0f507ff6b3613f061da9966af
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 22:00:54 2020 +0200

    jas_image: eliminate local variable `found`

M	src/libjasper/base/jas_image.c

commit 64b5933034a2dc267ef6a61852203c50879b6591
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 21:41:45 2020 +0200

    jas_image: convert more integers to `unsigned`

M	src/appl/imgcmp.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/bmp/bmp_enc.c
M	src/libjasper/include/jasper/jas_image.h
M	src/libjasper/jp2/jp2_enc.c
M	src/libjasper/pnm/pnm_enc.c

commit 1d4000308ec90e9871927dd3c0a7ca23d58e5c32
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 21:47:38 2020 +0200

    jas_cm: convert macros to enums

M	src/appl/jasper.c
M	src/libjasper/base/jas_cm.c
M	src/libjasper/base/jas_image.c
M	src/libjasper/include/jasper/jas_cm.h
M	src/libjasper/include/jasper/jas_image.h

commit 5625d051a72041f31941b590c1f68ec73d55aebd
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 21:44:33 2020 +0200

    jas_image: use enum jas_image_cmpttype_t

M	src/libjasper/base/jas_image.c
M	src/libjasper/include/jasper/jas_image.h

commit 0e76df3cb808510c737161e95ff307025f142d99
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 21:42:26 2020 +0200

    jas_image: remove FIX_ME code

    This code has been disabled before the very first git commit, and
    changing this would require a new libJasPer ABI.  Won't happen.  So
    let's remove it.

M	src/libjasper/include/jasper/jas_image.h

commit 46dbba47210c7e16f7304f67a896b2f0faea4859
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 18:40:53 2020 +0200

    jas_stream: pass const buffer to write_()

M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_stream.h

commit 8be87525577275729e4075d61e22612e7a15c44f
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 18:15:32 2020 +0200

    jas_stream: convert macros to inline functions

M	src/libjasper/include/jasper/jas_stream.h

commit 80e4b4267f13e436c5ce2269312d9c450eb7c346
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 18:13:56 2020 +0200

    jas_stream: use `bool`

M	src/libjasper/base/jas_stream.c

commit 5ef38b74b8fb897acd985a5e957d9fa54400c30a
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 18:10:19 2020 +0200

    jas_stream: remove obsolete jas_stream_memopen() implementation

    Obsoleted by commit 634ce8e8a5 four years ago.  Since nobody has
    needed this code, let's remove it.

M	src/libjasper/base/jas_stream.c

commit 5aad012e28577f74971b3ddc580088535b23d161
Author: Max Kellermann <max@duempel.org>
Date:	Wed Jun 16 23:06:13 2010 +0200

    use NDEBUG instead of DEBUG

    NDEBUG is a standard C macro.

M	src/libjasper/include/jasper/jas_stream.h
M	src/libjasper/jpc/jpc_bs.h
M	src/libjasper/jpc/jpc_mqdec.c
M	src/libjasper/jpc/jpc_mqdec.h
M	src/libjasper/jpc/jpc_mqenc.c
M	src/libjasper/jpc/jpc_t1dec.c

commit d930181cd00e0fea370d4a37ccc205940f461ee8
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 10:52:49 2020 +0200

    appl/jiv: fix shadow warnings

M	src/appl/jiv.c

commit 254ac24f114319b4b6d0a16cc368c017a0beb909
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 10:52:39 2020 +0200

    jpc_tagtree: add `const` to fix `-Wcast-qual`

M	src/libjasper/jpc/jpc_tagtree.c

commit f0315a1a5a802ea09fb1d315059aa71ac7cc0474
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 10:35:04 2020 +0200

    jpc_mqdec: use unsigned integers

M	src/libjasper/jpc/jpc_mqdec.c
M	src/libjasper/jpc/jpc_mqdec.h

commit 562a98aa8aeacacda2f56b7bb2509e26bdb51fc3
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 10:26:42 2020 +0200

    jpc_mqdec: use `bool` instead of `int`

M	src/libjasper/jpc/jpc_mqdec.c
M	src/libjasper/jpc/jpc_mqdec.h

commit 0461a3b9de5a838b2d510e02240545c008c27ebc
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 10:36:01 2020 +0200

    jpc_mqdec: remove unused function jpc_mqdec_setctx()

M	src/libjasper/jpc/jpc_mqdec.c
M	src/libjasper/jpc/jpc_mqdec.h

commit 48c86ff877eb407808a6524f5e2da27e4c9f054b
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 10:05:03 2020 +0200

    jas_types.h: don't include windows.h

    This was a kludge from long ago for MSVC versions which did not
    support some C99 definitions, and this kludge was effectively disabled
    by commit d42b2388f7f four years ago, but it did not remove the
    "#include <windows.h>".

    Let's clean this up now.

M	CMakeLists.txt
M	src/libjasper/include/jasper/jas_config.h.in
M	src/libjasper/include/jasper/jas_types.h

commit d6405fd4e605a0a53aa84b7120ca5e23daed7819
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 14 09:34:17 2020 +0200

    jas_stream: fix signedness mismatch

M	src/libjasper/base/jas_stream.c

commit c7ee493d1f0e2195e905b4f2cfbfaacd53cdd525
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 16:16:25 2020 +0200

    jas_stream: use O_TMPFILE on Linux

M	src/libjasper/base/jas_stream.c

commit 4fbc1e8b9d19d0313a580ea6173a01a2f0ff489c
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 15:09:51 2020 +0200

    jas_stream: use mkstemp() instead of tmpnam() which was unsafe

    Unlike tmpnam(), the caller needs to choose a directory for mkstemp().
    So for this transition, we need some code to determine the system temp
    file directory.  This makes the commit pretty complicated.
    Unfortunately, there's no simple to use POSIX function which creates a
    temporary file safely.

    Closes https://github.com/jasper-software/jasper/issues/206

M	CMakeLists.txt
M	src/libjasper/base/jas_stream.c
M	src/libjasper/include/jasper/jas_config.h.in

commit e5753e53b7f18d62e7e12772e651389b3519dec9
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 16:21:01 2020 +0200

    jas_stream: use O_CLOEXEC on Linux for thread-safety

    Without O_CLOEXEC, file descriptor opened by one thread can be leaked
    to a child process created by another thread.  This requires defining
    `_GNU_SOURCE`, or else the definitions will not be made available by
    glibc.

M	CMakeLists.txt
M	src/libjasper/base/jas_stream.c

commit 59ac1ea3662111ad238e02c0b0bf14269403a0bc
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 16:29:46 2020 +0200

    jas_stream: remove unused `openflags` variable from
    jas_stream_freopen()

M	src/libjasper/base/jas_stream.c

commit b295641d4170999e8204e79657a4a95ced7b8354
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 14:31:15 2020 +0200

    jp2_cod: remove redundant initialization

    After memset(), we don't need to assign NULL pointers.

M	src/libjasper/jp2/jp2_cod.c

commit fb84f45d75719cc799913067562212b7fdb5e41c
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 14:28:09 2020 +0200

    jp2_cod: fix the jp2_boxinfolookup() error check

    On error, jp2_boxinfolookup() returns `&jp2_boxinfo_unk`, not NULL.

    Closes https://github.com/jasper-software/jasper/issues/129

M	src/libjasper/jp2/jp2_cod.c

commit 8d277434247a4a0b92bc6ea6da3f6a3f438d3b3f
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 14:27:09 2020 +0200

    jp2_cod: move the jp2_boxinfolookup() call to the top

    Avoid the memory leak described in
    https://github.com/jasper-software/jasper/issues/129

M	src/libjasper/jp2/jp2_cod.c

commit d0d0499714a4d0f5a0c183573315b0363550b5e5
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 14:26:12 2020 +0200

    jp2_cod: remove redundant jp2_boxinfolookup() call

    Just use `box->info` instead of looking it up again.

M	src/libjasper/jp2/jp2_cod.c

commit 7778ce5bf460df654282acc576e9ee61beec8b86
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 14:19:35 2020 +0200

    jp2_cod: add `const`

M	src/libjasper/jp2/jp2_cod.c
M	src/libjasper/jp2/jp2_cod.h

commit 123f6c60c5ad124c5847531c655637700367a2c1
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 14:04:58 2020 +0200

    appl/jiv: remove bogus assert()

    This assert() has always been wrong, because the float to integer
    conversion caused rounding problems which led to assertion failures.
    This never occurred until commit dc129830baf8 changed abs() to
    JAS_ABS(), which eliminated an integer roundtrip, with increased
    accuracy leading to a delta larger than `1e-5`.

    Closes https://github.com/jasper-software/jasper/issues/177

M	src/appl/jiv.c

commit f79ac630706094b9510c18433e0e11a5076dd463
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 14:14:09 2020 +0200

    appl/jiv: free the jas_cmprof_t object in loadimage()

M	src/appl/jiv.c

commit c08881bcd33ce90bf713de7bbf01503322eece08
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 14:12:04 2020 +0200

    jas_image: add `const`

M	src/libjasper/base/jas_image.c
M	src/libjasper/include/jasper/jas_image.h

commit 834cf3c3201db9d6b1ad011da2b088f7cfa3dbf8
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 14:11:55 2020 +0200

    jas_cm: add `const`

M	src/libjasper/base/jas_cm.c
M	src/libjasper/include/jasper/jas_cm.h

commit 3c9c7c2b9fb41733a873cc23bf11dbae6fbf00c5
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 13:19:29 2020 +0200

    jpc_t2cod: use more unsigned integers

M	src/libjasper/jpc/jpc_t2cod.c

commit bcced41f9d5191105b05ad6e97a28c31a90583d1
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 13 13:15:18 2020 +0200

    jpc_t2cod: use unsigned integers in jpc_pirlvl_t

M	src/libjasper/jpc/jpc_t2cod.h

commit a906f7b8015965dbaa00493c05e32cb35e399db1
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:47:41 2020 +0200

    jpc_dec: use unsigned integers

M	src/libjasper/jpc/jpc_dec.c
M	src/libjasper/jpc/jpc_dec.h
M	src/libjasper/jpc/jpc_t1dec.c
M	src/libjasper/jpc/jpc_t2dec.c

commit 21ef6f4cc476928fe9db863e23c1caf089989045
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:45:28 2020 +0200

    jp2_enc: use __builtin_unreachable() on illegal `switch` labels

M	src/libjasper/jp2/jp2_enc.c

commit 587337ad428f36aabae72241c7636b0580f02ad0
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:37:07 2020 +0200

    jpc_enc: convert abort() to assert()

M	src/libjasper/jpc/jpc_enc.c

commit 7bdac6f5c4bf3dd524bda727b5961d6a75aee42b
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:37:01 2020 +0200

    jpc_enc: convert abort() to runtime checks

M	src/libjasper/jpc/jpc_enc.c

commit 8cdc9423539aaadfc10065508c075de2b7696cda
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:35:48 2020 +0200

    jpc_bvs: use __builtin_unreachable() instead of abort()

M	src/libjasper/jpc/jpc_bs.c

commit d1499e645a683c925590255dff8470ff3ad2e472
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:33:19 2020 +0200

    jpc_cs: convert abort() to runtime check

M	src/libjasper/jpc/jpc_cs.c

commit 925990f116c7930a0154d4e7d4f32e6ef487b0a0
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:15:49 2020 +0200

    jpc_t2enc: use unsigned integers

M	src/libjasper/jpc/jpc_t2enc.c
M	src/libjasper/jpc/jpc_t2enc.h

commit 0e00ffa99a4d72326cf9649c2656a8bcaca1e7cf
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:17:46 2020 +0200

    jpc_t2enc: use `bool` instead of `int`

M	src/libjasper/jpc/jpc_t2enc.c

commit d28c707fa0e3781b2b7a17f728acde93ffeb3fff
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:16:18 2020 +0200

    jpc_t2enc: pass `bool` to jpc_init_t2state()

M	src/libjasper/jpc/jpc_enc.c
M	src/libjasper/jpc/jpc_t2enc.c
M	src/libjasper/jpc/jpc_t2enc.h

commit 2dca735e5b759dd507d2a8c05318580d590bcff1
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:11:03 2020 +0200

    jpc_mqenc: use unsigned integers

M	src/libjasper/jpc/jpc_mqenc.c
M	src/libjasper/jpc/jpc_mqenc.h

commit e281d3002c1096619b2568e216e5cbdf8c445dcf
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:09:04 2020 +0200

    jpc_mqenc: convert macros to inline functions

M	src/libjasper/jpc/jpc_mqenc.c
M	src/libjasper/jpc/jpc_mqenc.h

commit f0e92955054919774cc9e660788027862c35357b
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:08:36 2020 +0200

    jpc_mqenc: convert `err` to `bool`

M	src/libjasper/jpc/jpc_mqenc.c
M	src/libjasper/jpc/jpc_mqenc.h

commit 423662e6bb50881522a0755198556adf21f264f8
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:06:34 2020 +0200

    jpc_mqenc: pass `bool` to jpc_mqenc_putbit()

M	src/libjasper/jpc/jpc_mqenc.c
M	src/libjasper/jpc/jpc_mqenc.h

commit 75611c4d3449486df22077917c58142c3ffce1cb
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:05:15 2020 +0200

    jpc_mqenc: use __builtin_unreachable() on illegal `switch` labels

M	src/libjasper/jpc/jpc_mqenc.c

commit dc1a0a71cc0a1c1fe424540f755f06ebe90d3acc
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:04:22 2020 +0200

    jpc_t2enc: convert abort() to runtime check

M	src/libjasper/jpc/jpc_t2enc.c

commit 3ba00895d457f749bd72a9f77bad124ffd1a0341
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:02:01 2020 +0200

    jpc_dec: convert abort() to assert()

    Check for code bugs only in debug builds.

M	src/libjasper/jpc/jpc_dec.c

commit aa5ec08b44ad1d9f5fbb56e066e9880b1c979c7f
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 21:41:51 2020 +0200

    jpc_t1enc: use unsigned integers

M	src/libjasper/jpc/jpc_t1enc.c

commit 9765127d4aaa836832dfdb558505481a441929c7
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 21:46:53 2020 +0200

    jpc_t1enc: convert abort() to runtime check

M	src/libjasper/jpc/jpc_t1enc.c

commit fa995fe187f85c0558003aacd8df6a8b909eba74
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 21:41:34 2020 +0200

    jpc_t1enc: remove unreachable `break` statements

M	src/libjasper/jpc/jpc_t1enc.c

commit c3d765f4d5cba2de521caf147128e2f64d663eca
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 21:39:28 2020 +0200

    jpc_t1enc: use `bool` instead of `int`

M	src/libjasper/jpc/jpc_t1enc.c

commit ec882c7a6e8e784a3486dd6d560fd36387c2a5d8
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 21:38:30 2020 +0200

    jpc_t1enc: make jpc_enc_enccblk() static

    Only used internally.

M	src/libjasper/jpc/jpc_t1enc.c
M	src/libjasper/jpc/jpc_t1enc.h

commit 67ee9ee2d62a3b1a02be98527026e32bd49b3e27
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 21:26:21 2020 +0200

    jpc_t1enc: add `const`

M	src/libjasper/jpc/jpc_t1enc.c
M	src/libjasper/jpc/jpc_t1enc.h

commit 08e261dcec254118df5e5bcd141ead2187069f2c
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 21:24:55 2020 +0200

    jpc_t1dec: remove unreachable `break` statements

M	src/libjasper/jpc/jpc_t1dec.c

commit 7084fe1c50d37a958d5852fa7e313c945110637d
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 07:54:19 2020 +0200

    jpc_t1dec: use `bool` instead of `int`

M	src/libjasper/jpc/jpc_t1dec.c

commit 90a8915f1b13f0cc114d39720990add332d72bfa
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 6 20:52:03 2020 +0200

    jpc_t1dec: use unsigned integers

M	src/libjasper/jpc/jpc_t1dec.c

commit 54fbba7dc7f3b9fed76d2834b273e1570791c1d8
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 6 20:27:44 2020 +0200

    jpc_t1cod: use unsigned integers

M	src/libjasper/jpc/jpc_t1cod.c
M	src/libjasper/jpc/jpc_t1cod.h

commit 60281f00b54dfc91ee691a0526f5aac7711f8bdf
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 6 20:30:29 2020 +0200

    jpc_t1{cod,dec}: use __builtin_unreachable() on illegal `switch`
    labels

    This allows removing some initialization code which is confusing,
    because it should never be reachable.

M	src/libjasper/jpc/jpc_t1cod.c
M	src/libjasper/jpc/jpc_t1dec.c

commit e36d2bbecaff8308411076fbce56deb9e36c7390
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 6 20:46:47 2020 +0200

    jpc_t1cod: JPC_SEGTYPE() returns an `enum`

M	src/libjasper/jpc/jpc_dec.h
M	src/libjasper/jpc/jpc_enc.h
M	src/libjasper/jpc/jpc_t1cod.c
M	src/libjasper/jpc/jpc_t1cod.h

commit e6d9649e28c145da563a2826943ffb9a533f1b65
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 6 20:36:46 2020 +0200

    jpc_t1cod: JPC_PASSTYPE() returns an `enum`

    Reduce CPP macros.

M	src/libjasper/jpc/jpc_t1cod.c
M	src/libjasper/jpc/jpc_t1cod.h
M	src/libjasper/jpc/jpc_t1dec.c
M	src/libjasper/jpc/jpc_t1enc.c

commit 670bb17516ce06b2f74835ca0d034d28c95cf2a3
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 6 20:26:49 2020 +0200

    jpc_t1cod: simplify JPC_ISTERMINATED() return value

    No implicit `int` to `bool` cast.

M	src/libjasper/jpc/jpc_t1cod.c

commit 18c99c3910674c2025d68afbc08f099f9700e02d
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 6 20:24:58 2020 +0200

    jpc_t1cod: use `f` suffix for `float` literals

    This avoids the implicit cast to `double` on some architectures.

M	src/libjasper/jpc/jpc_t1cod.c

commit 1a35a847c139d6444a65586367ccb569e1ce2296
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Thu Aug 6 20:40:18 2020 +0200

    jpc_t1{dec,enc}: restore and fix the JPC_PASSTYPE() calls

    The `#if 1` code is equivalent, but less clear.  Let's restore the
    calls.  This requires fixing the parameter: the `+2` offset is wrong,
    but it has been since the very first git commit, so I can't seem to
    find out why.

    If optimization is really important, we better convert JPC_PASSTYPE()
    to an inline function with that formula.  But for now, code clarity
    seems more important.

M	src/libjasper/jpc/jpc_t1dec.c
M	src/libjasper/jpc/jpc_t1enc.c

commit 1b7b84675e1eedca43892e167e2a14d3cb43b2a4
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 21:09:30 2020 +0200

    jpc_tsfb: use unsigned integers

M	src/libjasper/jpc/jpc_tsfb.c
M	src/libjasper/jpc/jpc_tsfb.h

commit f5170ec61ae6a5e486961c75b9093aca52343a7b
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 21:05:15 2020 +0200

    jpc_tsfb: convert macros to `enum jpc_tsfb_orient`

    This improves code readability, because you can see what values are
    possible.

M	src/libjasper/jpc/jpc_dec.h
M	src/libjasper/jpc/jpc_enc.h
M	src/libjasper/jpc/jpc_t1cod.c
M	src/libjasper/jpc/jpc_t1cod.h
M	src/libjasper/jpc/jpc_t1dec.c
M	src/libjasper/jpc/jpc_t1enc.c
M	src/libjasper/jpc/jpc_tsfb.h

commit 70b66332bfa410e1fdac5fc7a706c10c414d77cb
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 22:24:31 2020 +0200

    jpc_math: use unsigned integers in jpc_floorlog2()

M	src/libjasper/jpc/jpc_math.c
M	src/libjasper/jpc/jpc_math.h
M	src/libjasper/jpc/jpc_t2enc.c

commit f3137972edf2026bd54f77b9c1c90bc341419814
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Fri Aug 7 23:08:39 2020 +0200

    jas_math: suppress -Wshift-negative-value only with GCC >= 6

    This option was added in GCC 6, and using the pragma on older GCC
    version breaks the build (since commit df01ace988f3).

M	src/libjasper/include/jasper/jas_math.h

commit 990bb29f7e0e933312f7768d7bfb95fbb273974f
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Sat Aug 8 13:25:00 2020 +0200

    jas_config.h.in: use the `no_sanitize_undefined` attribute only
    with GCC>=6

    Fixes build failure with GCC 5 and older.

M	src/libjasper/include/jasper/jas_config.h.in

commit 1083b11dbce419a3accf84dd5b27a43b8ac28304
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Sat Aug 8 13:21:29 2020 +0200

    jas_config.h.in: reorder GCC/clang checks for simplification

M	src/libjasper/include/jasper/jas_config.h.in

commit ae3c8319a5240e106e3a0766093c44882aeff8f1
Author: Max Kellermann <max.kellermann@gmail.com>
Date:	Sat Aug 8 13:20:20 2020 +0200

    jas_math: require GCC>=5 for __builtin_*_overflow()

    These are not available in GCC 4.x or older.

M	src/libjasper/include/jasper/jas_math.h

commit a3bca5d3b0cfdf6f246f27fd03dee5ffd856aeb4
Author: OSAMU WATANABE <owatanab@es.takushoku-u.ac.jp>
Date:	Fri Aug 7 17:06:05 2020 +0900

    Fix wrong EPH marker checking

    If EPH markers are required (by setting the third LSB of Scod
    parameter to "1" in the COD marker segment, see A.6.1), each packet
    header in any given tile-part shall be postpended with an EPH marker
